// BaseNabidka.h: interface for the CBaseNabidka class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BASENABIDKA_H__AA49A961_28DC_11D8_83E3_008048208521__INCLUDED_)
#define AFX_BASENABIDKA_H__AA49A961_28DC_11D8_83E3_008048208521__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "BaseObject.h"

#define ZV	1.5f		// zvetseni pisma
#define ZVN	2			// zvetseni pisma nadpisu
#define TLO_RAM	(VEL_ZNAKUY*ZV)	// tloustka ramecku
#define TLO_MEZ	0.15f	// tloustka mezery

// velikost obrazovky (v hloubce -10): x:-5.5 .. 5.5; y: -4 .. 4
#define TXTSCRX	5.5f
#define TXTSCRY	4.f

typedef enum {
	T_NORMALNI,
	T_SESIPKAMA,		// nejspis nikde se nepouziva
	T_SKRYTA,			// neda se vybrat, je ztmaveny
	T_KOUPIT,			// mirne stmavena (protoze ji este nemam)
	T_PRODAT,			// jako normalni
	T_MODRA				// jako normalni, ale udela se modra
} TYP_POLOZKY;

typedef struct {
	char	str[20];	// text nabidky nesmi bejt delsi naz 20
	TYP_POLOZKY		typ;
} TPolozka;

class CBaseNabidka : public CBaseObject
{
public:
	CBaseNabidka();
	virtual ~CBaseNabidka();

	int InitObject();
	void UpdateObjLogic(Uint8 *keys);		// posunovani v menu
	void UpdateObjDisplay();				// zobrazeni nabidky a ramecku

	void PosunDolu();		// posune vybranou nabidku dolu
	void PosunNahoru();		// posune vybranou nabidku nahoru
	void UdelejCtverecSTexturou(float x, float y, float w, float h);
	void UdelejCtverec(float x, float y, float w, float h);	// vola se z CMapaNabidka
	void UdelejRamecek(float x, float y, float w, float h);

	int			nabPoc;		// pocet polozek v nabidce
	int			velNejdNab;	// velikost nejdelsi nabidky
	TPolozka	*nab;		// pole polozek
	char		nadpis[50];	// to se zobrazi nahore na obrazovce

	int		vybranaNabidka;
	int		vybranaNabidkaOdkud;
	int		budeKonec;				// kdyz se zmackne naka nabidka, tak se ztmavuje obrazovka
	float	posunRamecku;			// posunuje ramecek kolem nabidky se zpozdenim
};

#endif // !defined(AFX_BASENABIDKA_H__AA49A961_28DC_11D8_83E3_008048208521__INCLUDED_)
