// Game.cpp: implementation of the CGame class.
//
//////////////////////////////////////////////////////////////////////

#include <time.h>
#include "Game.h"
#include "TridaKteraRidiHru.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CGame::CGame()
{
	pgame = this;
	kolikatyKolo=game_over=kolikObj=0;
	memset(objekty,0,sizeof(void *)*POCETOBJ);	// Set The Pointer To NULL
	konzole.semVKonzoli=0; konzole.fce=NULL;
	memset(konzole.radky,0,sizeof(konzole.radky));
	vypisujFps=0;

	// jaky mam rozliseni obrazovky:
	ROZ_X=  640; ROZ_Y= 480;	
	//ROZ_X=  800; ROZ_Y= 600;
	//ROZ_X= 1024; ROZ_Y= 768;
	// jestli sem ve fullscreenu:
	fullscreen=0;			
	//fullscreen=1;

	//nacita rozliseni atd. ze souboru "configure.txt"
	// neco podobnyho je v COptionNabidka a v CTridaKteraRidiHru!
	FILE *File=NULL;
	char s[1000]; int c;
	File=fopen("configure.txt","r");
	if (File) {
		while (fscanf(File,"%s",s)!=EOF) {
			if (strcmp(s,"width")==0) fscanf(File," %d",&ROZ_X);
			else if (strcmp(s,"height")==0) fscanf(File," %d",&ROZ_Y);
			else if (strcmp(s,"fullscreen")==0) fscanf(File," %d",&fullscreen);
			else if (s[0]=='/' && s[1]=='/') while (getc(File)!='\n');
			else while ( (c=getc(File))!='\n' && c!=0 );
		}
		fclose(File);
		fullscreen= !!fullscreen;
	}

	srand( (unsigned)time( NULL ) );	// init generatoru nahodnych cisel

}

CGame::~CGame()
{
	for(int i=0; i<POCETOBJ; i++)
		if (objekty[i]) delete objekty[i];
	//SDL_ShowCursor(1);
	Mix_CloseAudio();
	SDL_Quit();		// Shutdown all subsystems
}

int CGame::RegisterObject(CBaseObject *obj, int vePredu)
{
	int i;
	if ( kolikObj>=POCETOBJ ) {
		fprintf(stderr, "prilis mnoho objektu\n");
		delete obj;
		return 0;
	}

	IFERR(obj->InitObject(), "chyba inicializace objektu\n")

	//if ( vePredu ) { for (i=POCETOBJ-1; i>=0; i--) if (!objekty[i]) break; objekty[i] = obj; }
	if ( vePredu ) {
		CBaseObject *pom;
		for (i=POCETOBJ-1; obj!=0 && i>=0; i--) {
			pom= objekty[i]; objekty[i]= obj; obj= pom;
		}
	} else {
		for (i=0; i<POCETOBJ; i++) if (!objekty[i]) break;
		objekty[i] = obj;
	}
	kolikObj++;

	return 1;
}

int CGame::DestroyObject(CBaseObject *obj, int znicit, int pozice)
{
	if ( pozice>=0 && pozice<POCETOBJ ) {
		if (objekty[pozice]==obj) {
			if ( znicit ) delete objekty[pozice];
			objekty[pozice]=NULL;
			kolikObj--;
			return 1;
		}
		fprintf(stderr,"ve fci CGame::DestroyObject(): na zadanem indexu obj neni.\n");
		return 0;
	}
	for (int i=0; i<POCETOBJ; i++) if (objekty[i]==obj) {
		if ( znicit ) delete objekty[i];
		objekty[i]=NULL;
		kolikObj--;
		return 1;
	}

	fprintf(stderr,"nekdo chce uvolnit objekt, ktery neexistuje, nebo neni zaregistrovany\n");
	return 0;
}

int CGame::InitGame()
{
	for (int i=0; i<POCETOBJ; i++) if (objekty[i]) DestroyObject(objekty[i]);
	SDL_Quit();		// Shutdown all subsystems

	if( SDL_Init( SDL_INIT_VIDEO | SDL_INIT_AUDIO | SDL_INIT_TIMER ) ){
		fprintf( stderr, "Could not initialise SDL: %s\n", SDL_GetError() );
		return 0;
	}
	atexit(SDL_Quit);

	SDL_GL_SetAttribute( SDL_GL_DOUBLEBUFFER, 1 );
	if ( !(m_screen=SDL_SetVideoMode( ROZ_X, ROZ_Y, 0/*16*/,
		SDL_OPENGLBLIT | SDL_RESIZABLE/* | SDL_NOFRAME | SDL_HWSURFACE | SDL_DOUBLEBUF*/ | SDL_FULLSCREEN*fullscreen )) ) {
		fprintf(stderr, "Couldn't set GL video mode: %s\n", SDL_GetError());
		SDL_Quit();
		return 0;
	}

	SDL_ShowCursor(0);
	SDL_WM_GrabInput(SDL_GRAB_ON);
	SDL_WarpMouse(0, 0);

	pogl->ReSizeGLScene( ROZ_X, ROZ_Y);
	IFERR(pogl->InitGL(), "Initialization of OGL Failed.\n")

	//pogl->lighting(light); pogl->blending(blend);

	//loadovani objektu - CTridaKteraRidiHru
	CBaseObject *novyObj;
	novyObj = new CTridaKteraRidiHru;
	IFERR( novyObj, "nepodarilo se naalokovat pamet pro CTridaKteraRidiHru\n")
	IFERR( RegisterObject(novyObj,1), "chyba inicializace CTridaKteraRidiHru\n")
	
	//PlaySound("Data/Complete.wav", NULL, SND_ASYNC );
	
	return 1;
}

/*int CGame::Resize(int x, int y, int fs)
{	// tahle fce nefunguje
	ROZ_X= x; ROZ_Y= y; fullscreen= fs;

	SDL_GL_SetAttribute( SDL_GL_DOUBLEBUFFER, 1 );
	if ( !(m_screen=SDL_SetVideoMode( ROZ_X, ROZ_Y, 0,
		SDL_OPENGLBLIT | SDL_RESIZABLE | SDL_FULLSCREEN*fullscreen )) ) {
		fprintf(stderr, "Couldn't set GL video mode: %s\n", SDL_GetError());
		SDL_Quit();
		return 0;
	}

	glViewport(0, 0, ROZ_X, ROZ_Y);// Reset The Current Viewport
	glMatrixMode(GL_MODELVIEW);		// Select The Modelview Matrix
	glLoadIdentity();				// Reset The Modelview Matrix
//	pogl->ReSizeGLScene( ROZ_X, ROZ_Y);
//	IFERR(pogl->InitGL(), "Initialization of OGL Failed.\n")
//	gluPerspective(45.0f,(GLfloat)ROZ_X/(GLfloat)ROZ_Y,0.1f,100.0f);

	return 1;
}*/

// main game loop
int CGame::PlayGame()
{
	int disp=1;
	Uint32 next_time, fps=0, min_fps=0; fpss=0;

	next_time = SDL_GetTicks();
	while (!game_over) {
		while ( next_time < SDL_GetTicks() ) {
			UpdateGameLogic();
			next_time+=TICK_INTERVAL;
			kolikatyKolo++;
			disp=1;
		}

		// fps
		if ( next_time/1000 != min_fps ) {
			min_fps=next_time/1000; fpss=fps;
			fps=0;
		}

		if ( disp ) { disp=0; fps++; UpdateDisplay(); }
		if ( next_time > SDL_GetTicks() ) SDL_Delay( next_time-SDL_GetTicks());
		//else if ( SDL_GetTicks() - next_time > 1000*TICK_INTERVAL ) game_over=1;
	}
	return 0;
}

void CGame::UpdateGameLogic()
{
	static SDL_Event event;
	while( SDL_PollEvent( &event ) ){
		switch( event.type ){
		case SDL_MOUSEMOTION:
			break;
		case SDL_VIDEORESIZE:
			pogl->ReSizeGLScene(event.resize.w, event.resize.h);
			break;
		case SDL_QUIT:
			game_over=1;
			break;
		}
	}

	keys= SDL_GetKeyState(NULL);
	//if (keys[SDLK_ESCAPE]) game_over=1;

	//zacatekKoknzoleKonzoleKonzole
	if ( keys[SDLK_BACKQUOTE] ) {
		keys[SDLK_BACKQUOTE]=0;
		konzole.semVKonzoli= !konzole.semVKonzoli;
	}
	if ( konzole.semVKonzoli ) {
		UpdateLogicKonzole(keys);
		return;
	}
	//konecKonzoleKonzoleKonzole

	for(int i=0; i<POCETOBJ; i++) if (objekty[i]) {
		objekty[i]->UpdateObjLogic(keys);
		// kontrola, jestli neco chce znicit
		if ( objekty[i]->znicit ) DestroyObject(objekty[i],1,i);
	}
}

/*
 *            + y
 *          / | \
 *            |
 *            |     \
 *            +----- + x
 *          /       /
 *      | /
 *    z +-
 */

void CGame::UpdateDisplay()
{
	int i;

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	// Clear The Screen And The Depth Buffer
	glLoadIdentity();

	//glRotatef(180,0,0,1);

	for (i=0; i<POCETOBJ; i++) if (objekty[i]) {
		glPushMatrix();
			objekty[i]->UpdateObjDisplay();
		glPopMatrix();
	}
	/*/ tohle vytiskne u kazdyho objektu jeho cislo
	for (i=0; i<POCETOBJ; i++) if (objekty[i]) {
		glPushMatrix();
			glTranslatef(0,0,-20);
			pogl->glPrintEx( objekty[i]->pol.x, objekty[i]->pol.y,1,1,1,3, "%d", i);
		glPopMatrix();
	}/**/

	if (vypisujFps) pogl->glPrint( -TXTSCRX+VEL_ZNAKUX, TXTSCRY-1*VEL_ZNAKUY, "fps: %d (%d)", fpss, 1000/TICK_INTERVAL);
	//pogl->glPrint( -5.5+VEL_ZNAKUX, 4-2*VEL_ZNAKUY, "kolikObj: %d (%d)", kolikObj, POCETOBJ);

	//zacatekKoknzoleKonzoleKonzole
	if ( konzole.semVKonzoli ) {
		UpdateDisplayKonzole();
	}
	//konecKonzoleKonzoleKonzole

	glFlush();	// to by me zajimalo, jestli tady tohle ma bejt, nebo ne; 
	SDL_GL_SwapBuffers();
}

//////////konzole//////////
void CGame::UpdateLogicKonzole(Uint8 *keys)
{
	int pom1, pom2;

	pom1=CoJeZmacknuty(keys);
	switch (pom1) {
	case SDLK_RETURN:
		if ( strcmp(konzole.radky[0],"help")==0 ) { KonzolePosun(); strcpy(konzole.radky[0],"help; fps; (ve hre:) ctv; money; dncornholio; end; level;"); }
		else if ( strcmp(konzole.radky[0],"fps")==0 ) vypisujFps= !vypisujFps;
		else if ( konzole.fce ) konzole.fce(konzole.radky[0]);
		KonzolePosun();
		break;
	case SDLK_BACKSPACE:
		pom2= strlen(konzole.radky[0]);
		if (pom2>0) konzole.radky[0][pom2-1]=0;
		break;
	default:
		pom2= strlen(konzole.radky[0]);
		if (pom2<79) { konzole.radky[0][pom2]=pom1; konzole.radky[0][pom2+1]=0; }
	}
}

void CGame::UpdateDisplayKonzole()
{
	glDisable(GL_TEXTURE_2D);
	glColor3f(155.f/255,100.f/255,0.f/255);
	glBlendFunc(GL_SRC_COLOR,GL_ONE_MINUS_DST_COLOR);				//*** Blend Screen Color With Zero (Black)
	glBegin(GL_QUADS);												// Start Drawing A Textured Quad
		glVertex3f(-TXTSCRX,TXTSCRY-10*VEL_ZNAKUY, -10);	// Bottom Left
		glVertex3f( TXTSCRX,TXTSCRY-10*VEL_ZNAKUY, -10);	// Bottom Right
		glVertex3f( TXTSCRX,TXTSCRY, -10);	// Top Right
		glVertex3f(-TXTSCRX,TXTSCRY, -10);	// Top Left
	glEnd();														// Done Drawing The Quad
	glEnable(GL_TEXTURE_2D);
	glColor3f(1,1,1);
	for (int i=0; i<10; i++) pogl->glPrint(-TXTSCRX+VEL_ZNAKUX,TXTSCRY-(10-i)*VEL_ZNAKUY,konzole.radky[i]);

}

char CGame::CoJeZmacknuty(Uint8 *keys)
{
	for (int i=0; i<128; i++) if (
		i!=0 && //...
		keys[i] ){ keys[i]=0; return i; }
	return 0;
}

void CGame::KonzolePosun()
{
	for (int i=9; i>0; i--) strcpy(konzole.radky[i],konzole.radky[i-1]);
	konzole.radky[0][0]=0;
}

