// Game.h: interface for the CGame class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GAME_H__E3A13100_D9DD_11D6_83E1_B10FD10D1A25__INCLUDED_)
#define AFX_GAME_H__E3A13100_D9DD_11D6_83E1_B10FD10D1A25__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "main.h"
#include "BaseObject.h"

#define TICK_INTERVAL	10		// delka jednoho kola v ms
#define POCETOBJ		200		// max. pocet objektu

// typy objektu jsou definovany v CBaseObject

// okraje obrazovky v hloubce z=-30 (vsechno co lita)
#define SCREEN_X		15.0
#define SCREEN_Y		12.5

//naky typy potrebny pro konzoli:
typedef char TRadek[80];
typedef void (*TKonzoleFce)(char *);
typedef struct TKonzole {
	int semVKonzoli;	// kdyz sem v konzoli, tak se hra zastavi a muzu psat naky prikazy. ty se pak posilaj naky fci, kterou si zadefinuju
	TRadek radky[10];	// jednotlive radky konzole
	TKonzoleFce fce;	// ukazatel na fci, kterou si zadefinuju a ktera bude zpracovavat prikazy
} TKonzole;

// trida CGame
class CGame  
{
	friend struct TKonzole;
	SDL_Surface	*m_screen;
	Uint8	*keys;
	Uint32	 fpss;
	int vypisujFps;		// jestli se maj psat fps

	void UpdateGameLogic();
	void UpdateDisplay();

public:
	CGame();
	~CGame();
	int InitGame();		// SDL a OGL; CreateGLWindow; 0 when failed 
	int PlayGame();		//

	int RegisterObject(CBaseObject *obj, int vePredu=0);	// zaregistruje a nainicializuje novy objekt, pokud je nastaveny vePredu, tak se da na konec pole, takze se vola jako posledni (pro pruhledny obj...)
	int DestroyObject(CBaseObject *obj, int znicit=1, int pozice=-1);		// odregistruje a znici objekt; ktery je index v objekty[]
				// pokud je znicit rovny 0, tak objekt neznici, jenom odregistruje
				// pozice se pouziva proto, kdyz vime, na jakym miste je obj, takze se nemusi hledat

	// tohle je verejny, aby sly kontrolovat srazky s ostatnima objektama
	int kolikObj;
	CBaseObject *objekty[POCETOBJ];		// pole s objektama; 0 kdyz je volny policko

	int		game_over;					// kdyz se nastavi na 1, tak se zkonci
	Uint32	kolikatyKolo;				// pocet kol od zacatku programu (1 kolo == 10 ms)

	int ROZ_X, ROZ_Y;	// jaky mam rozliseni obrazovky
	int fullscreen;		// jestli sem ve fullscreenu
	//int Resize(int x, int y, int fs);	// nastavi rozliseni a fullscreen; ale nefunguje
			// vrati 1 kdyz vsechno ok

	TKonzole konzole;
	void UpdateLogicKonzole(Uint8 *keys);	// vola se kdyz sem v konzoli
	void UpdateDisplayKonzole();		// nakresli konzoli
	char CoJeZmacknuty(Uint8 *keys);	// vrati jaka klavesa je zmacknuta
	void KonzolePosun();	// prida novej radek do konzole

};

#endif // !defined(AFX_GAME_H__E3A13100_D9DD_11D6_83E1_B10FD10D1A25__INCLUDED_)
