// HangarNabidka.cpp: implementation of the CHangarNabidka class.
// hlavicka tridy je v HlavniNabidka.h!
//////////////////////////////////////////////////////////////////////

#include "Game.h"
#include "TridaKteraRidiHru.h"
#include "HlavniNabidka.h"

///////////////////////////////////////////////////////////
////////////////////////// Hangar /////////////////////////

CHangarNabidka::CHangarNabidka() { CBaseNabidka::CBaseNabidka(); }

CHangarNabidka::~CHangarNabidka()
{
	delete nab;
}

int CHangarNabidka::InitObject()
{
	// nadpis
	sprintf(nadpis,"zakladna");

	nabPoc=5; velNejdNab=14;
	nab = new TPolozka[nabPoc];
	strcpy(nab[0].str, "start");			nab[0].typ= T_NORMALNI;
	strcpy(nab[1].str, "nakup vybaveni");	nab[1].typ= T_NORMALNI;
	strcpy(nab[2].str, "nakup lodi");		nab[2].typ= T_NORMALNI;
	strcpy(nab[3].str, "nastaveni");		nab[3].typ= T_NORMALNI;
	strcpy(nab[4].str, "ulozit a konec");	nab[4].typ= T_NORMALNI;

	CBaseNabidka::InitObject();
	return 1;
}

void CHangarNabidka::UpdateObjLogic(Uint8 *keys)
{
	CMapaNabidka *pmn;
	CObchodNabidka *pon;
	CNakupLodiNabidka *pln;
	COptionNabidka *poptn;
	CHlavniNabidka *phln;

	if ( budeKonec ) {
		budeKonec--;
		if ( budeKonec==5 )		// jinak se to este rozsviti ???
			switch (vybranaNabidka) {
			case 0: // start hry
			case 1: // nakup vybaveni
			case 2: // nakup lode
			case 3: // nastaveni
				break;
			case 4: // konec hry a ulozeni
				ptkrh->hraci[0].save();
				znicit=1;
				phln = new CHlavniNabidka;
				if ( !phln ) fprintf(stderr,"nepodarilo se naalokovat pamet pro CHlavniNabidka\n");
				else if ( !pgame->RegisterObject(phln) ) fprintf(stderr, "chyba inicializace CHlavniNabidka\n");
				phln->vybranaNabidka= vybranaNabidkaOdkud;
				ptkrh->Rozni();
				return;
			}
		return;
	}

	CBaseNabidka::UpdateObjLogic(keys);	// posunovani v menu

	if (keys[SDLK_ESCAPE]) {	// to samy jako v ^ case 1:...
		keys[SDLK_ESCAPE]=0;

		ptkrh->hraci[0].save();
		znicit=1;
		CHlavniNabidka *phln = new CHlavniNabidka;
		if ( !phln ) fprintf(stderr,"nepodarilo se naalokovat pamet pro CHlavniNabidka\n");
		else if ( !pgame->RegisterObject(phln) ) fprintf(stderr, "chyba inicializace CHlavniNabidka\n");
		phln->vybranaNabidka= vybranaNabidkaOdkud;
		return;
	}
	if (keys[SDLK_RETURN]) {
		keys[SDLK_RETURN]=0;

		switch (vybranaNabidka) {
		case 0: // start hry
			znicit=1;
			pmn = new CMapaNabidka;
			if ( !pmn ) fprintf(stderr,"nepodarilo se naalokovat pamet pro CMapaNabidka\n");
			else if ( !pgame->RegisterObject(pmn) ) fprintf(stderr, "chyba inicializace CMapaNabidka\n");
			pmn->vybranaNabidkaOdkud= vybranaNabidka;
			return;
		case 1: // nakup vybaveni
			znicit=1;
			pon = new CObchodNabidka;
			if ( !pon ) fprintf(stderr,"nepodarilo se naalokovat pamet pro CObchodNabidka\n");
			else if ( !pgame->RegisterObject(pon) ) fprintf(stderr, "chyba inicializace CObchodNabidka\n");
			pon->vybranaNabidkaOdkud= vybranaNabidka;
			return;
		case 2:	// nakup lode
			znicit=1;
			pln = new CNakupLodiNabidka;
			if ( !pln ) fprintf(stderr,"nepodarilo se naalokovat pamet pro CNakupLodiNabidka\n");
			else if ( !pgame->RegisterObject(pln) ) fprintf(stderr, "chyba inicializace CNakupLodiNabidka\n");
			pln->vybranaNabidkaOdkud= vybranaNabidka;
			return;
		case 3:	// nastaveni
			znicit=1;
			poptn = new COptionNabidka;
			if ( !poptn ) fprintf(stderr,"nepodarilo se naalokovat pamet pro COptionNabidka\n");
			else if ( !pgame->RegisterObject(poptn) ) fprintf(stderr, "chyba inicializace COptionNabidka\n");
			poptn->vybranaNabidkaOdkud= vybranaNabidka;
			poptn->zKama= COptionNabidka::zHangaru;
			return;
		case 4: // konec hry a ulozeni
			budeKonec=100;
			ptkrh->Ztmav();
			break;
		}
	}
}

void CHangarNabidka::UpdateObjDisplay()
{
	pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, 2, (ptkrh->hraci[0].obtiznost)?.5:1, (ptkrh->hraci[0].obtiznost)?.5:1,1,ZV,
			"%s", ptkrh->hraci[0].jmeno);
	pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, 2-VEL_ZNAKUY*ZV, 1,1,1,ZV,
			"level: %d", ptkrh->hraci[0].maxLevel+1);
	pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, 2-VEL_ZNAKUY*ZV*2, 1,1,1,ZV,
			"penize: %d", ptkrh->hraci[0].penize);
	pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, 2-VEL_ZNAKUY*ZV*3, 1,1,1,ZV,
			"na planete: %s", ptkrh->hraci[0].mapa.mesta[ ptkrh->hraci[0].mapa.kdeSem ].meno);

	CBaseNabidka::UpdateObjDisplay();	// zobrazi nabidku
}

///////////////////////////////////////////////////////////
////////////////////////// Mapa ///////////////////////////

CMapaNabidka::CMapaNabidka() { CBaseNabidka::CBaseNabidka(); }

CMapaNabidka::~CMapaNabidka()
{
	delete nab;
}

int CMapaNabidka::InitObject()
{
	// nadpis
	sprintf(nadpis,"mapa");

	nabPoc= ptkrh->hraci[0].mapa.mesta[ ptkrh->hraci[0].mapa.kdeSem ].pocCest + 1;
	velNejdNab=13;
	nab = new TPolozka[nabPoc];
	int i;
	for(i=0; i<nabPoc-1; i++) {
		sprintf(nab[i].str,"%s(%d)", ptkrh->hraci[0].mapa.mesta[
			ptkrh->hraci[0].mapa.mesta[ ptkrh->hraci[0].mapa.kdeSem ].sousedi[i].kam
													].meno,
			ptkrh->hraci[0].mapa.mesta[ ptkrh->hraci[0].mapa.kdeSem ].sousedi[i].lvl+1);
		nab[i].typ= T_NORMALNI;
	}
	strcpy(nab[i].str, "zpet"); nab[i].typ= T_NORMALNI;

	CBaseNabidka::InitObject();
	vybranaNabidka= ptkrh->hraci[0].mapa.vybranaCesta;
	return 1;
}

void CMapaNabidka::UpdateObjLogic(Uint8 *keys)
{
	if ( budeKonec ) {
		budeKonec--;
		if ( budeKonec==5 )		// jinak se to este rozsviti ???
			if ( vybranaNabidka < nabPoc-1 ) {	// start hry
				ptkrh->hraci[0].mapa.vybranaCesta= vybranaNabidka;
				//tohle je pro ladeni mapy:
				/*ptkrh->hraci[0].vyhral();	// !tohle bude az po preletu!
				znicit=1;
				CHangarNabidka *phn = new CHangarNabidka;
				if ( !phn ) fprintf(stderr,"nepodarilo se naalokovat pamet pro CHangarNabidka\n");
				else if ( !pgame->RegisterObject(phn) ) fprintf(stderr, "chyba inicializace CHangarNabidka\n");
				ptkrh->Rozni();
				return;/**/
				//*
				znicit=1;
				ptkrh->Rozni();
				ptkrh->zacitHrat=1;/**/
				return;
			}
		return;
	}

	CBaseNabidka::UpdateObjLogic(keys);	// posunovani v menu

	if (keys[SDLK_ESCAPE]) {	// to samy jako v ^ case 1:...
		keys[SDLK_ESCAPE]=0;

		ptkrh->hraci[0].save();
		znicit=1;
		CHangarNabidka *phn = new CHangarNabidka;
		if ( !phn ) fprintf(stderr,"nepodarilo se naalokovat pamet pro CHangarNabidka\n");
		else if ( !pgame->RegisterObject(phn) ) fprintf(stderr, "chyba inicializace CHangarNabidka\n");
		phn->vybranaNabidka= vybranaNabidkaOdkud;
		return;
	}
	if (keys[SDLK_RETURN]) {
		keys[SDLK_RETURN]=0;

		if ( vybranaNabidka < nabPoc-1 ) {	// start hry
			budeKonec=100;
			ptkrh->Ztmav();
		} else {	// zpet
			znicit=1;
			CHangarNabidka *phn = new CHangarNabidka;
			if ( !phn ) fprintf(stderr,"nepodarilo se naalokovat pamet pro CHangarNabidka\n");
			else if ( !pgame->RegisterObject(phn) ) fprintf(stderr, "chyba inicializace CHangarNabidka\n");
			phn->vybranaNabidka= vybranaNabidkaOdkud;
			return;
		}
	}

	ptkrh->hraci[0].mapa.nakresliSeSpocti();	// prepocita pozice mest
}

void CMapaNabidka::UpdateObjDisplay()
{
	// nakreslim mapu
	ptkrh->hraci[0].mapa.nakresliSe(vybranaNabidka);
	glColor3f(1,1,1); glDisable(GL_TEXTURE_2D); glDisable(GL_DEPTH_TEST);
	glBlendFunc(GL_ZERO,GL_ONE_MINUS_SRC_COLOR);
	//zacernim to, co je mimo ramecek
	UdelejCtverec(-6,-5,12,3-TLO_RAM);		// spodni
	UdelejCtverec(-.5f+TLO_RAM,-2-TLO_RAM,7,4+2*TLO_RAM);	// pravej
	UdelejCtverec(-6,2+TLO_RAM,12,3-TLO_RAM);		// horni
	UdelejCtverec(-6,-2-TLO_RAM,1.5f-TLO_RAM,4+2*TLO_RAM);		// levej
	//plynulejsi ztmaveni okraju mapy
	glBegin(GL_QUADS);	// dole
		glColor3f(1, 1, 1); glVertex3f(-4.5f-TLO_RAM,-2-TLO_RAM,-10);
		glColor3f(1, 1, 1); glVertex3f(-.5f+TLO_RAM,-2-TLO_RAM,-10);
		glColor3f(0, 0, 0); glVertex3f(-.5f+TLO_RAM,-2,-10);
		glColor3f(0, 0, 0); glVertex3f(-4.5f-TLO_RAM,-2,-10);
	glEnd();
	glBegin(GL_QUADS);	// vpravo
		glColor3f(0, 0, 0); glVertex3f(-.5f,-2-TLO_RAM,-10);
		glColor3f(1, 1, 1); glVertex3f(-.5f+TLO_RAM,-2-TLO_RAM,-10);
		glColor3f(1, 1, 1); glVertex3f(-.5f+TLO_RAM, 2+TLO_RAM,-10);
		glColor3f(0, 0, 0); glVertex3f(-.5f, 2+TLO_RAM,-10);
	glEnd();
	glBegin(GL_QUADS);	// nahore
		glColor3f(0, 0, 0); glVertex3f(-4.5f-TLO_RAM, 2,-10);
		glColor3f(0, 0, 0); glVertex3f(-.5f+TLO_RAM, 2,-10);
		glColor3f(1, 1, 1); glVertex3f(-.5f+TLO_RAM, 2+TLO_RAM,-10);
		glColor3f(1, 1, 1); glVertex3f(-4.5f-TLO_RAM, 2+TLO_RAM,-10);
	glEnd();
	glBegin(GL_QUADS);	// vlevo
		glColor3f(1, 1, 1); glVertex3f(-4.5f-TLO_RAM,-2-TLO_RAM,-10);
		glColor3f(0, 0, 0); glVertex3f(-4.5f, -2-TLO_RAM,-10);
		glColor3f(0, 0, 0); glVertex3f(-4.5f, 2+TLO_RAM,-10);
		glColor3f(1, 1, 1); glVertex3f(-4.5f-TLO_RAM, 2+TLO_RAM,-10);
	glEnd();
	
	glColor3f(1,1,1); glEnable(GL_TEXTURE_2D); glEnable(GL_DEPTH_TEST);

	UdelejRamecek(-4.7f, -2.2f, 4.4f, 4.4f);

	CBaseNabidka::UpdateObjDisplay();	// zobrazi nabidku
}

///////////////////////////////////////////////////////////
////////////////////////// Obchod /////////////////////////

CObchodNabidka::CObchodNabidka() { CBaseNabidka::CBaseNabidka(); }

CObchodNabidka::~CObchodNabidka()
{
	delete nab;
}

int CObchodNabidka::InitObject()
{
	int pom1, pom2;

	// nadpis
	sprintf(nadpis,"Obchod na planete %s", ptkrh->hraci[0].mapa.mesta[ ptkrh->hraci[0].mapa.kdeSem ].meno);

	nabPoc=2+MAX_POCET_HL_ZBR+MAX_POCET_BOC_ZBR+1; velNejdNab=14;
	nab = new TPolozka[nabPoc];
	for (int i=0; i<nabPoc; i++) switch (i) {
		case 0:	// armour
			pom1= (int)ptkrh->hraci[0].lode[ ptkrh->hraci[0].vybranaLod ].maxArmour;
			pom2= (int)ptkrh->typyLodi[ ptkrh->hraci[0].vybranaLod ].maxArmour;
			if ( pom1<pom2*2 ) { // muzu si to este vylepsit
				sprintf(nab[i].str, "zivoty (%d)",pom1+pom2/5);
				nab[i].typ= T_KOUPIT;
			} else { // uz mam armour plnej
				sprintf(nab[i].str, "zivoty (%d)",pom1);
				nab[i].typ= T_SKRYTA;
			} break;
		case 1:	// shield
			pom1= (int)ptkrh->hraci[0].lode[ ptkrh->hraci[0].vybranaLod ].maxShield;
			pom2= (int)ptkrh->typyLodi[ ptkrh->hraci[0].vybranaLod ].maxShield;
			if ( pom1<pom2*2 ) { // muzu si to este vylepsit
				sprintf(nab[i].str, "stity (%d)",pom1+pom2/5);
				nab[i].typ= T_KOUPIT;
			} else {
				sprintf(nab[i].str, "stity (%d)",pom1);
				nab[i].typ= T_SKRYTA;
			} break;
		case 2+MAX_POCET_HL_ZBR+MAX_POCET_BOC_ZBR: // zpet
			strcpy(nab[i].str, "zpet");
			nab[i].typ= T_NORMALNI;
			break;
		default: // zbrane
			if ( 1<i && i< 2+MAX_POCET_HL_ZBR ) {// hl. zbran, 2..2+MAX-1
				sprintf(nab[i].str, "hl. zbran %d", i-1);
				if ( ptkrh->hraci[0].lode[ ptkrh->hraci[0].vybranaLod ].ktereHlZbrane[ i-2 ] )
					nab[i].typ= T_PRODAT;
				else nab[i].typ= T_KOUPIT;
			} else if ( 2+MAX_POCET_HL_ZBR <= i && i<2+MAX_POCET_HL_ZBR+MAX_POCET_BOC_ZBR ) {// boc. zbran
				sprintf(nab[i].str, "boc. zbran %d", i-1-MAX_POCET_HL_ZBR);
				if ( ptkrh->hraci[0].lode[ ptkrh->hraci[0].vybranaLod ].ktereBocZbrane[ i-2-MAX_POCET_HL_ZBR ] )
					nab[i].typ= T_PRODAT;
				else nab[i].typ= T_KOUPIT;
			}
			break;
	}

	CBaseNabidka::InitObject();

	// init napovedy a kolikToStoji
	napoveda[0]=0;
	spoctiKolikToStoji();

	return 1;
}

void CObchodNabidka::UpdateObjLogic(Uint8 *keys)
{
	int pom1, pom2;
	CHangarNabidka *phn;

	pom1= keys[SDLK_UP] || keys[SDLK_DOWN];

	CBaseNabidka::UpdateObjLogic(keys);	// posunovani v menu

	// update napovedy a kolikToStoji
	if ( pom1 ) spoctiKolikToStoji();

	if (keys[SDLK_ESCAPE]) {	// to samy jako v ^ case 2+..:
		keys[SDLK_ESCAPE]=0;

		znicit=1;
		CHangarNabidka *phn = new CHangarNabidka;
		if ( !phn ) fprintf(stderr,"nepodarilo se naalokovat pamet pro CHangarNabidka\n");
		else if ( !pgame->RegisterObject(phn) ) fprintf(stderr, "chyba inicializace CHangarNabidka\n");
		phn->vybranaNabidka= vybranaNabidkaOdkud;
		return;
	}
	if (keys[SDLK_RETURN]) {
		keys[SDLK_RETURN]=0;

		switch (vybranaNabidka) {
		case 0: // armour
			// odectu penize
			if ( ptkrh->hraci[0].penize < kolikToStoji ) {
				strcpy(napoveda,"Mas malo penez!");
				break;
			}
			ptkrh->hraci[0].penize -= kolikToStoji;
			// zlepsim lod
			ptkrh->hraci[0].lode[ ptkrh->hraci[0].vybranaLod ].maxArmour+=
					ptkrh->typyLodi[ ptkrh->hraci[0].vybranaLod ].maxArmour/5;
			// obnovim nastaveni nabidky
			pom1= (int)ptkrh->hraci[0].lode[ ptkrh->hraci[0].vybranaLod ].maxArmour;
			pom2= (int)ptkrh->typyLodi[ ptkrh->hraci[0].vybranaLod ].maxArmour;
			if ( pom1<pom2*2 ) { // muzu si to este vylepsit
				sprintf(nab[vybranaNabidka].str, "zivoty (%d)",pom1+pom2/5);
				nab[vybranaNabidka].typ= T_KOUPIT;
			} else { // uz mam armour plnej
				sprintf(nab[vybranaNabidka].str, "zivoty (%d)",pom1);
				nab[vybranaNabidka].typ= T_SKRYTA;
				PosunDolu();	// posunu se na dalsi nabidku
				spoctiKolikToStoji();
			} break;
		case 1: // shield
			// odectu penize
			if ( ptkrh->hraci[0].penize < kolikToStoji ) {
				strcpy(napoveda,"Mas malo penez!");
				break;
			}
			ptkrh->hraci[0].penize -= kolikToStoji;
			// zlepsim lod
			ptkrh->hraci[0].lode[ ptkrh->hraci[0].vybranaLod ].maxShield+=
					ptkrh->typyLodi[ ptkrh->hraci[0].vybranaLod ].maxShield/5;
			// obnovim nastaveni nabidky
			pom1= (int)ptkrh->hraci[0].lode[ ptkrh->hraci[0].vybranaLod ].maxShield;
			pom2= (int)ptkrh->typyLodi[ ptkrh->hraci[0].vybranaLod ].maxShield;
			if ( pom1<pom2*2 ) { // muzu si to este vylepsit
				sprintf(nab[vybranaNabidka].str, "stity (%d)",pom1+pom2/5);
				nab[vybranaNabidka].typ= T_KOUPIT;
			} else { // uz mam armour plnej
				sprintf(nab[vybranaNabidka].str, "stity (%d)",pom1);
				nab[vybranaNabidka].typ= T_SKRYTA;
				PosunDolu();	// posunu se na dalsi nabidku
				spoctiKolikToStoji();
			} break;
		case 2+MAX_POCET_HL_ZBR+MAX_POCET_BOC_ZBR: // zpet
			znicit=1;
			phn = new CHangarNabidka;
			if ( !phn ) fprintf(stderr,"nepodarilo se naalokovat pamet pro CHangarNabidka\n");
			else if ( !pgame->RegisterObject(phn) ) fprintf(stderr, "chyba inicializace CHangarNabidka\n");
			phn->vybranaNabidka= vybranaNabidkaOdkud;
			return;
		default: // zbrane
			// hlavni
			if ( 1<vybranaNabidka && vybranaNabidka<2+MAX_POCET_HL_ZBR ) {// hl. zbran, 2..2+MAX-1
				// vypoctu, kolik to stoji
				int kolikToStoji;
				kolikToStoji= ptkrh->typyZbrane[
						ptkrh->typyLodi[ ptkrh->hraci[0].vybranaLod ].typyHlavZbr[vybranaNabidka-2]
					].cena;
				// nakup / prodej
				if ( nab[vybranaNabidka].typ==T_KOUPIT ) { // kupuju si ji
					// odectu penize
					if ( ptkrh->hraci[0].penize < kolikToStoji ) {
						strcpy(napoveda,"Mas malo penez!");
						break;
					}
					ptkrh->hraci[0].penize -= kolikToStoji;
					// zlepsim lod
					ptkrh->hraci[0].lode[ ptkrh->hraci[0].vybranaLod ].ktereHlZbrane[ vybranaNabidka-2 ]= 1;
					// obnovim nabidku
					nab[vybranaNabidka].typ= T_PRODAT;
				} else { // prodavam ji
					// vzdycky musim mit aspon jednu hlavni zbran!
					pom1=0;
					for (int i=0; i<MAX_POCET_HL_ZBR; i++) pom1+= ptkrh->hraci[0].lode[ ptkrh->hraci[0].vybranaLod ].ktereHlZbrane[i];
					if ( pom1==1 ) {
						strcpy(napoveda,"Nemuzes prodat vsechny \nhlavni zbrane. Alespon \njednu potrebujes.");
						break;
					}
					// pridam penize
					ptkrh->hraci[0].penize += (int)((double)kolikToStoji*0.8);
					// zhorsim lod
					ptkrh->hraci[0].lode[ ptkrh->hraci[0].vybranaLod ].ktereHlZbrane[ vybranaNabidka-2 ]= 0;
					// obnovim nabidku
					nab[vybranaNabidka].typ= T_KOUPIT;
				}
			} else
			// bocni
			if ( 2+MAX_POCET_HL_ZBR <= vybranaNabidka && vybranaNabidka<2+MAX_POCET_HL_ZBR+MAX_POCET_BOC_ZBR ) {// // boc. zbran, 2+MAX-1..2+MAX+MAX-1
				// nakup / prodej
				if ( nab[vybranaNabidka].typ==T_KOUPIT ) { // kupuju si ji
					// odectu penize
					if ( ptkrh->hraci[0].penize < kolikToStoji ) {
						strcpy(napoveda,"Mas malo penez!");
						break;
					}
					ptkrh->hraci[0].penize -= kolikToStoji;
					// zlepsim lod
					ptkrh->hraci[0].lode[ ptkrh->hraci[0].vybranaLod ].ktereBocZbrane[ vybranaNabidka-2-MAX_POCET_HL_ZBR ]= 1;
					// obnovim nabidku
					nab[vybranaNabidka].typ= T_PRODAT;
				} else { // prodavam ji
					// pridam penize
					ptkrh->hraci[0].penize += (int)((double)kolikToStoji*0.8);
					// zhorsim lod
					ptkrh->hraci[0].lode[ ptkrh->hraci[0].vybranaLod ].ktereBocZbrane[ vybranaNabidka-2-MAX_POCET_HL_ZBR ]= 0;
					// obnovim nabidku
					nab[vybranaNabidka].typ= T_KOUPIT;
				}
			} else fprintf(stderr, "Sem sem se nikdy nemel dostat. (CObchodNabidka::UpdateObjLogic()");

			break;
		}

	}
}

void CObchodNabidka::UpdateObjDisplay()
{
	//armour
	//pogl->glPrintEx( -TXTSCRX+2*VEL_ZNAKUX*ZV, 6*VEL_ZNAKUY*ZV, 1,1,1,ZV,
	//		"armour (%d)", (int)ptkrh->hraci[0].lode[ ptkrh->hraci[0].vybranaLod ].maxArmour);
	//shield
	//pogl->glPrintEx( -TXTSCRX+2*VEL_ZNAKUX*ZV, 5*VEL_ZNAKUY*ZV, 1,1,1,ZV,
	//		"shield (%d)", (int)ptkrh->hraci[0].lode[ ptkrh->hraci[0].vybranaLod ].maxShield);
	//popis, napoveda
	pogl->glPrintEx( -TXTSCRX+2*VEL_ZNAKUX*ZV, 0*VEL_ZNAKUY, 1,1,1,1,
		"popis:");
	int pom1=0,pom2=1;
	for (int i=0; napoveda[i]!=0; i++) {
		if (napoveda[i]=='\n') {
			napoveda[i]=0;
			pogl->glPrintEx( -TXTSCRX+2*VEL_ZNAKUX*ZV, -pom2*VEL_ZNAKUY, 1,1,1,1, "%s", &napoveda[pom1]);
			napoveda[i]='\n';
			pom1=i+1; pom2++;
		}
	} pogl->glPrintEx( -TXTSCRX+2*VEL_ZNAKUX*ZV, -pom2*VEL_ZNAKUY, 1,1,1,1, "%s", &napoveda[pom1]);
	//buy/sell
	if ( vybranaNabidka<2+MAX_POCET_HL_ZBR+MAX_POCET_BOC_ZBR )
		if ( nab[vybranaNabidka].typ==T_KOUPIT )
			pogl->glPrintEx( -TXTSCRX+3*VEL_ZNAKUX*ZV, -5*VEL_ZNAKUY*ZV, 1, ((kolikToStoji<=ptkrh->hraci[0].penize)?1:0.5),((kolikToStoji<=ptkrh->hraci[0].penize)?1:0.5),ZV,
				"koupit za: %d", kolikToStoji);
		else pogl->glPrintEx( -TXTSCRX+3*VEL_ZNAKUX*ZV, -5*VEL_ZNAKUY*ZV, 1,1,1,ZV,
				"prodat za: %d", (int)((double)kolikToStoji*0.8));
	//kolik mam penez
	pogl->glPrintEx( -TXTSCRX+3*VEL_ZNAKUX*ZV, -6*VEL_ZNAKUY*ZV, 1,1,1,1,
		"penize: %d", ptkrh->hraci[0].penize);

	CBaseNabidka::UpdateObjDisplay();	// zobrazi nabidku
}

void CObchodNabidka::spoctiKolikToStoji()
{
	switch (vybranaNabidka) {
		case 0: case 1:
			kolikToStoji= ptkrh->typyLodi[ ptkrh->hraci[0].vybranaLod ].cena/10;
			sprintf(napoveda,"kupni cena: %d", kolikToStoji);
			break;
		case 2: case 3: case 4: case 5:
			kolikToStoji= ptkrh->typyZbrane[
						ptkrh->typyLodi[ ptkrh->hraci[0].vybranaLod ].typyHlavZbr[vybranaNabidka-2]
					].cena;
			sprintf(napoveda,"kupni cena: %d\nprodejni cena: %d", kolikToStoji, (int)((double)kolikToStoji*0.8));
			break;
		case 6: case 7: case 8:
			kolikToStoji= ptkrh->typyZbrane[
						ptkrh->typyLodi[ ptkrh->hraci[0].vybranaLod ].typyBocZbr[vybranaNabidka-2-MAX_POCET_HL_ZBR]
					].cena;
			sprintf(napoveda,"kupni cena: %d\nprodejni cena: %d", kolikToStoji, (int)((double)kolikToStoji*0.8));
			break;
	}
}

///////////////////////////////////////////////////////////
////////////////////////// Nakup lodi /////////////////////

CNakupLodiNabidka::CNakupLodiNabidka() { CBaseNabidka::CBaseNabidka(); }

CNakupLodiNabidka::~CNakupLodiNabidka()
{
	delete nab;
}

int CNakupLodiNabidka::InitObject()
{
	// nadpis
	sprintf(nadpis,"nakup lodi");

	nabPoc=7; velNejdNab=12;
	nab = new TPolozka[nabPoc];
	init();
	strcpy(nab[6].str, "zpet");		nab[6].typ= T_NORMALNI;

	CBaseNabidka::InitObject();
	return 1;
}

void CNakupLodiNabidka::UpdateObjLogic(Uint8 *keys)
{
	CHangarNabidka *phn;
	int i, pom;

	pom= keys[SDLK_UP] || keys[SDLK_DOWN];

	CBaseNabidka::UpdateObjLogic(keys);	// posunovani v menu

	// update napovedy a kolikToStoji
	if ( pom ) init();

	CBaseNabidka::UpdateObjLogic(keys);	// posunovani v menu

	if (keys[SDLK_ESCAPE]) {	// to samy jako v case 6:...
		keys[SDLK_ESCAPE]= 0;
		znicit=1;
		phn = new CHangarNabidka;
		if ( !phn ) fprintf(stderr,"nepodarilo se naalokovat pamet pro CHangarNabidka\n");
		else if ( !pgame->RegisterObject(phn) ) fprintf(stderr, "chyba inicializace CHangarNabidka\n");
		phn->vybranaNabidka= vybranaNabidkaOdkud;
		return;
	}

	if (keys[SDLK_RETURN]) {
		keys[SDLK_RETURN]=0;

		switch (vybranaNabidka) {
		case 0: // koupit/prodat 1.
		case 2: // koupit/prodat 2.
		case 4: // koupit/prodat 3.
			// nakup / prodej
			if ( nab[vybranaNabidka].typ==T_KOUPIT ) { // kupuju si ji
				// odectu penize
				if ( ptkrh->hraci[0].penize < kolikToStoji ) {
					strcpy(napoveda,"Mas malo penez!");
					break;
				}
				ptkrh->hraci[0].penize -= kolikToStoji;
				ptkrh->hraci[0].kteryMaLode[vybranaNabidka/2]= 1;
				ptkrh->hraci[0].lode[vybranaNabidka/2].init(vybranaNabidka/2);
				init();
			} else { // prodavam ji
				// vzdycky musim mit aspon jednu lod!
				if ( ptkrh->hraci[0].kteryMaLode[0]+
					ptkrh->hraci[0].kteryMaLode[1]+
					ptkrh->hraci[0].kteryMaLode[2] == 1 ) {
					strcpy(napoveda,"Nemuzes prodat vsechny \nlode. Alespon \njednu potrebujes.");
					break;
				}
				// pridam penize
				ptkrh->hraci[0].penize += (int)((double)kolikToStoji*0.8);
				ptkrh->hraci[0].kteryMaLode[vybranaNabidka/2]= 0;
				if (ptkrh->hraci[0].vybranaLod==vybranaNabidka/2) for (i=0; i<3; i++)
					if ( ptkrh->hraci[0].kteryMaLode[i] ) ptkrh->hraci[0].vybranaLod= i;
				init();
			}
			break;
		case 1: // pripravit 1.
		case 3: // pripravit 2.
		case 5:	// pripravit 3.
			ptkrh->hraci[0].vybranaLod= (vybranaNabidka-1)/2;
			init();
			//PosunDolu();
			break;
		case 6:	// zpet
			znicit=1;
			phn = new CHangarNabidka;
			if ( !phn ) fprintf(stderr,"nepodarilo se naalokovat pamet pro CHangarNabidka\n");
			else if ( !pgame->RegisterObject(phn) ) fprintf(stderr, "chyba inicializace CHangarNabidka\n");
			phn->vybranaNabidka= vybranaNabidkaOdkud;
			break;
		}
	}

	krObj.UpdateLogic();
}

void CNakupLodiNabidka::UpdateObjDisplay()
{
	TSour pom; pom.x= -TXTSCRX+12*VEL_ZNAKUX*ZV; pom.y= 10*VEL_ZNAKUY; pom.z= -20;
	krObj.UpdateDisplay( pom);

	//popis, napoveda
	pogl->glPrintEx( -TXTSCRX+2*VEL_ZNAKUX*ZV, 0*VEL_ZNAKUY, 1,1,1,1,
		"popis:");
	int pom1=0,pom2=1;
	for (int i=0; napoveda[i]!=0; i++) {
		if (napoveda[i]=='\n') {
			napoveda[i]=0;
			pogl->glPrintEx( -TXTSCRX+2*VEL_ZNAKUX*ZV, -pom2*VEL_ZNAKUY, 1,1,1,1, "%s", &napoveda[pom1]);
			napoveda[i]='\n';
			pom1=i+1; pom2++;
		}
	} pogl->glPrintEx( -TXTSCRX+2*VEL_ZNAKUX*ZV, -pom2*VEL_ZNAKUY, 1,1,1,1, "%s", &napoveda[pom1]);
	//buy/sell
	if ( vybranaNabidka==0 || vybranaNabidka==2 || vybranaNabidka==4 )
		if ( nab[vybranaNabidka].typ==T_KOUPIT )
			pogl->glPrintEx( -TXTSCRX+3*VEL_ZNAKUX*ZV, -5*VEL_ZNAKUY*ZV, 1, ((kolikToStoji<=ptkrh->hraci[0].penize)?1:0.5),((kolikToStoji<=ptkrh->hraci[0].penize)?1:0.5),ZV,
				"koupit za: %d", kolikToStoji);
		else pogl->glPrintEx( -TXTSCRX+3*VEL_ZNAKUX*ZV, -5*VEL_ZNAKUY*ZV, 1,1,1,ZV,
				"prodat za: %d", (int)((double)kolikToStoji*0.8));
	//kolik mam penez
	pogl->glPrintEx( -TXTSCRX+3*VEL_ZNAKUX*ZV, -6*VEL_ZNAKUY*ZV, 1,1,1,1,
		"penize: %d", ptkrh->hraci[0].penize);

	CBaseNabidka::UpdateObjDisplay();	// zobrazi nabidku
}

void CNakupLodiNabidka::init()
{
	strcpy(nab[0].str, "koupit 1.");	nab[0].typ= T_KOUPIT;
	strcpy(nab[1].str, "pripravit 1.");	nab[1].typ= T_SKRYTA;
	strcpy(nab[2].str, "koupit 2.");	nab[2].typ= T_KOUPIT;
	strcpy(nab[3].str, "pripravit 2.");	nab[3].typ= T_SKRYTA;
	strcpy(nab[4].str, "koupit 3.");	nab[4].typ= T_KOUPIT;
	strcpy(nab[5].str, "pripravit 3.");	nab[5].typ= T_SKRYTA;
	if ( ptkrh->hraci[0].kteryMaLode[0] )
	{ strcpy(nab[0].str, "prodat 1.");	nab[0].typ= T_PRODAT; }
	if ( ptkrh->hraci[0].kteryMaLode[0] && ptkrh->hraci[0].vybranaLod!=0 )
	{ strcpy(nab[1].str, "pripravit 1.");	nab[1].typ= T_NORMALNI; }
	if ( ptkrh->hraci[0].kteryMaLode[1] )
	{ strcpy(nab[2].str, "prodat 2.");	nab[2].typ= T_PRODAT; }
	if ( ptkrh->hraci[0].kteryMaLode[1] && ptkrh->hraci[0].vybranaLod!=1 )
	{ strcpy(nab[3].str, "pripravit 2.");	nab[3].typ= T_NORMALNI; }
	if ( ptkrh->hraci[0].kteryMaLode[2] )
	{ strcpy(nab[4].str, "prodat 3.");	nab[4].typ= T_PRODAT; }
	if ( ptkrh->hraci[0].kteryMaLode[2] && ptkrh->hraci[0].vybranaLod!=2 )
	{ strcpy(nab[5].str, "pripravit 3.");	nab[5].typ= T_NORMALNI; }
	switch (vybranaNabidka) {
		case 0: // koupit/prodat 1.
		case 2: // koupit/prodat 2.
		case 4:	// koupit/prodat 3.
			kolikToStoji= ptkrh->typyLodi[vybranaNabidka/2].cena;
			sprintf(napoveda,"kupni cena: %d\nprodejni cena: %d", kolikToStoji, (int)((double)kolikToStoji*0.8));
			break;
		case 1: // pripravit 1.
		case 3: // pripravit 2.
		case 5:	// pripravit 3.
			napoveda[0]=0;
			break;
	}
	if (ptkrh->hraci[0].maxLevel<3) nab[2].typ= nab[3].typ= T_SKRYTA;
	if (ptkrh->hraci[0].maxLevel<6) nab[4].typ= nab[5].typ= T_SKRYTA;

	krObj.init( ptkrh->typyLodi[ptkrh->hraci[0].vybranaLod].cisloTypuKrObj, TYPOBJ_LOD);

}

///////////////////////////////////////////////////////////
////////////////////////// Pause //////////////////////////

CPauseNabidka::CPauseNabidka() { CBaseNabidka::CBaseNabidka(); }

CPauseNabidka::~CPauseNabidka()
{
	delete nab;
}

int CPauseNabidka::InitObject()
{
	ptkrh->pauza= 1;

	// nadpis
	sprintf(nadpis,"pause");

	nabPoc=3; velNejdNab=10;
	nab = new TPolozka[nabPoc];
	strcpy(nab[0].str, "pokracovat");		nab[0].typ= T_NORMALNI;
	strcpy(nab[1].str, "nastaveni");		nab[1].typ= T_NORMALNI;
	strcpy(nab[2].str, "konec hry");		nab[2].typ= T_NORMALNI;

	CBaseNabidka::InitObject();
	return 1;
}

void CPauseNabidka::UpdateObjLogic(Uint8 *keys)
{
	COptionNabidka *pon;

	if ( budeKonec ) {
		budeKonec--;
		if ( budeKonec==5 )		// jinak se to este rozsviti ???
			switch (vybranaNabidka) {
			case 0: // pokracovat
			case 1: // nastaveni
				break;
			case 2: // konec hry
				znicit=1;
				ptkrh->pauza= 0;
				ptkrh->level->konecHry= 2;	// hrac prohral
				break;
			}
		return;
	}

	CBaseNabidka::UpdateObjLogic(keys);	// posunovani v menu

	if (keys[SDLK_ESCAPE] || keys[SDLK_p] || keys[SDLK_PAUSE]) {	// to samy jako v ^ case 1:...
		keys[SDLK_ESCAPE]= keys[SDLK_p]= keys[SDLK_PAUSE]=0;
		znicit=1;
		ptkrh->pauza= 0;
		return;
	}

	if (keys[SDLK_RETURN]) {
		keys[SDLK_RETURN]=0;

		switch (vybranaNabidka) {
		case 0: // pokracovat
			znicit=1;
			ptkrh->pauza= 0;
			return;
		case 1:	// nastaveni
			znicit=1;
			pon = new COptionNabidka;
			if ( !pon ) fprintf(stderr,"nepodarilo se naalokovat pamet pro COptionNabidka\n");
			else if ( !pgame->RegisterObject(pon,1) ) fprintf(stderr, "chyba inicializace COptionNabidka\n");
			pon->vybranaNabidkaOdkud= vybranaNabidka;
			pon->zKama= COptionNabidka::zeHry;
			return;
		case 2: // konec hry
			budeKonec=100;
			ptkrh->Ztmav();
			break;
		}
	}
}

void CPauseNabidka::UpdateObjDisplay()
{
	CBaseNabidka::UpdateObjDisplay();	// zobrazi nabidku
}

///////////////////////////////////////////////////////////
////////////////////////// Vyhral/Prohral //////////////////////////

CVyhralProhralNabidka::CVyhralProhralNabidka() { CBaseNabidka::CBaseNabidka(); }

CVyhralProhralNabidka::~CVyhralProhralNabidka()
{
	delete nab;
}

int CVyhralProhralNabidka::InitObject()
{
	cas= 0;

	// nadpis
	//sprintf(nadpis,"pribeh");
	nadpis[0]= 0;

	nabPoc=1; velNejdNab=10;
	nab = new TPolozka[nabPoc];

	strcpy(nab[0].str, "pokracovat");	nab[0].typ= T_NORMALNI;

	CBaseNabidka::InitObject();
	return 1;
}

void CVyhralProhralNabidka::UpdateObjLogic(Uint8 *keys)
{
	CHangarNabidka *phn;

	cas++;

	CBaseNabidka::UpdateObjLogic(keys);	// posunovani v menu

	if (keys[SDLK_ESCAPE]) {	// to samy jako v case 0:...
		keys[SDLK_ESCAPE]=0;
		znicit=1;
		phn = new CHangarNabidka;
		if ( !phn ) fprintf(stderr,"nepodarilo se naalokovat pamet pro CHangarNabidka\n");
		else if ( !pgame->RegisterObject(phn) ) fprintf(stderr, "chyba inicializace CHangarNabidka\n");
		return;
	}
	if (keys[SDLK_RETURN]) {
		keys[SDLK_RETURN]=0;
		switch (vybranaNabidka) {
		case 0: // ok
			znicit=1;
			phn = new CHangarNabidka;
			if ( !phn ) fprintf(stderr,"nepodarilo se naalokovat pamet pro CHangarNabidka\n");
			else if ( !pgame->RegisterObject(phn) ) fprintf(stderr, "chyba inicializace CHangarNabidka\n");
			break;
		}
	}
}

void CVyhralProhralNabidka::UpdateObjDisplay()
{
	// staryLevel, novyLevel,
	// ptkrh->level->konecHry,
	// ptkrh->hraci[0].mapa.mesta[ptkrh->hraci[0].mapa.kdeSem].pocCest ***

	if ( ptkrh->level->konecHry == 1 ) { // vyhral
		if ( staryLevel<novyLevel && ( 
				(staryLevel<3 && novyLevel>=3) || 
				(staryLevel<6 && novyLevel>=6) ) ) {
			if ( cas>100 )
				pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, 2, ((float)cas-100)/100,((float)cas-100)/100,((float)cas-100)/100,ZV,
					"Tentokrat jsi mel stesti");
			if ( cas>300 )
				pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, 2-VEL_ZNAKUY*ZV, ((float)cas-300)/100,((float)cas-300)/100,((float)cas-300)/100,ZV,
					"a dokazal jsi se o kus");
			if ( cas>500 )
				pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, 2-VEL_ZNAKUY*ZV*2, ((float)cas-500)/100,((float)cas-500)/100,((float)cas-500)/100,ZV,
					"priblizit konci sve cesty.");
			if ( cas>700 )
				pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, 2-VEL_ZNAKUY*ZV*3, ((float)cas-700)/100,((float)cas-700)/100,((float)cas-700)/100,ZV,
					"K tomu ti muze pomoci");
			if ( cas>900 )
				pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, 2-VEL_ZNAKUY*ZV*4, ((float)cas-900)/100,((float)cas-900)/100,((float)cas-900)/100,ZV,
					"i nova nabidka v obchodech.");
			if ( cas>1100 )
				CBaseNabidka::UpdateObjDisplay();	// zobrazi nabidku
		} else if ( staryLevel<novyLevel ) {
			if ( cas>100 )
				pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, 2, ((float)cas-100)/100,((float)cas-100)/100,((float)cas-100)/100,ZV,
					"Tentokrat jsi mel stesti");
			if ( cas>300 )
				pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, 2-VEL_ZNAKUY*ZV, ((float)cas-300)/100,((float)cas-300)/100,((float)cas-300)/100,ZV,
					"a dokazal jsi se o kus");
			if ( cas>500 )
				pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, 2-VEL_ZNAKUY*ZV*2, ((float)cas-500)/100,((float)cas-500)/100,((float)cas-500)/100,ZV,
					"priblizit konci sve cesty.");
			if ( cas>700 )
				CBaseNabidka::UpdateObjDisplay();	// zobrazi nabidku
		} else if ( ptkrh->hraci[0].mapa.mesta[ptkrh->hraci[0].mapa.kdeSem].pocCest==1 ) {
			if ( cas>100 )
				pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, 2, ((float)cas-100)/100,((float)cas-100)/100,((float)cas-100)/100,ZV,
					"Tentokrat jsi prezil,");
			if ( cas>300 )
				pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, 2-VEL_ZNAKUY*ZV, ((float)cas-300)/100,((float)cas-300)/100,((float)cas-300)/100,ZV,
					" ale dostal jsi se");
			if ( cas>500 )
				pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, 2-VEL_ZNAKUY*ZV*2, ((float)cas-500)/100,((float)cas-500)/100,((float)cas-500)/100,ZV,
					" do slepe ulicky.");
			if ( cas>700 )
				CBaseNabidka::UpdateObjDisplay();	// zobrazi nabidku
		} else {
			if ( cas>100 )
				pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, 2, ((float)cas-100)/100,((float)cas-100)/100,((float)cas-100)/100,ZV,
					"Nemam co rict :)");
			if ( cas>300 )
				CBaseNabidka::UpdateObjDisplay();	// zobrazi nabidku
		}
	} else { // prohral
		if ( cas>100 )
			pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, 2, ((float)cas-100)/100,((float)cas-100)/100,((float)cas-100)/100,ZV,
				"Tva lod byla znicena a bohove");
		if ( cas>300 )
			pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, 2-VEL_ZNAKUY*ZV, ((float)cas-300)/100,((float)cas-300)/100,((float)cas-300)/100,ZV,
				" se ti zvyskoka smeji.");
		if ( cas>500 )
			pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, 2-VEL_ZNAKUY*ZV*2, ((float)cas-500)/100,((float)cas-500)/100,((float)cas-500)/100,ZV,
				"Ale za polovinu tvych penez");
		if ( cas>700 )
			pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, 2-VEL_ZNAKUY*ZV*3, ((float)cas-700)/100,((float)cas-700)/100,((float)cas-700)/100,ZV,
				" vratili cas a ty muzes");
		if ( cas>900 )
			pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, 2-VEL_ZNAKUY*ZV*4, ((float)cas-900)/100,((float)cas-900)/100,((float)cas-900)/100,ZV,
				" zkusit znovu stesti.");
		if ( cas>1100 )
			CBaseNabidka::UpdateObjDisplay();	// zobrazi nabidku
	}
}

