// HlavniNabidka.cpp: implementation of the CHlavniNabidka class.
// + jsou tu i dalsi tridy nabidky, krome trid spojenych s HangarNabidka!
//////////////////////////////////////////////////////////////////////

#include "HlavniNabidka.h"
#include "Game.h"
#include "TridaKteraRidiHru.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CHlavniNabidka::CHlavniNabidka() { CBaseNabidka::CBaseNabidka(); }

CHlavniNabidka::~CHlavniNabidka()
{
	delete nab;
}

int CHlavniNabidka::InitObject()
{
	// nadpis
	sprintf(nadpis,"Warrior");

	nabPoc=5; velNejdNab=9;
	nab = new TPolozka[nabPoc];
	strcpy(nab[0].str, "nova hra");		nab[0].typ= T_NORMALNI;
	strcpy(nab[1].str, "nahrat");		nab[1].typ= T_NORMALNI;
	strcpy(nab[2].str, "autori");		nab[2].typ= T_NORMALNI;
	strcpy(nab[3].str, "nastaveni");	nab[3].typ= T_NORMALNI;
	strcpy(nab[4].str, "konec");		nab[4].typ= T_NORMALNI;

	CBaseNabidka::InitObject();
	return 1;
}

void CHlavniNabidka::UpdateObjLogic(Uint8 *keys)
{
	CNovaHraNabidka *pnhn;
	CLoadNabidka *pln;
	CAboutNabidka *pan;
	COptionNabidka *pon;

	if ( budeKonec ) {
		budeKonec--;
		if ( budeKonec==5 )		// jinak se to este rozsviti ???
			switch (vybranaNabidka) {
			//case 0: break; // nova hra
			//case 1: break; // load
			//case 2: break; // about
			//case 3: break; // nastavovani
			case 4: // konec hry
				pgame->game_over=1;
				return;
			}
		return;
	}

	CBaseNabidka::UpdateObjLogic(keys);	// posunovani v menu

	if (keys[SDLK_ESCAPE]) {
		keys[SDLK_ESCAPE]=0;

		pgame->game_over=1;
		return;
	}
	if (keys[SDLK_RETURN]) {
		keys[SDLK_RETURN]=0;

		switch (vybranaNabidka) {
		case 0: // nova hra
			znicit=1;
			pnhn = new CNovaHraNabidka;
			if ( !pnhn ) fprintf(stderr,"nepodarilo se naalokovat pamet pro CNovaHraNabidka\n");
			else if ( !pgame->RegisterObject(pnhn) ) fprintf(stderr, "chyba inicializace CNovaHraNabidka\n");
			pnhn->vybranaNabidkaOdkud= vybranaNabidka;
			break;
		case 1: // load hry
			znicit=1;
			pln = new CLoadNabidka;
			if ( !pln ) fprintf(stderr,"nepodarilo se naalokovat pamet pro CLoadNabidka\n");
			else if ( !pgame->RegisterObject(pln) ) fprintf(stderr, "chyba inicializace CLoadNabidka\n");
			pln->vybranaNabidkaOdkud= vybranaNabidka;
			break;
		case 2: // about
			znicit=1;
			pan = new CAboutNabidka;
			if ( !pan ) fprintf(stderr,"nepodarilo se naalokovat pamet pro CAboutNabidka\n");
			else if ( !pgame->RegisterObject(pan) ) fprintf(stderr, "chyba inicializace CAboutNabidka\n");
			pan->vybranaNabidkaOdkud= vybranaNabidka;
			break;
		case 3: // nastaveni
			znicit=1;
			pon = new COptionNabidka;
			if ( !pon ) fprintf(stderr,"nepodarilo se naalokovat pamet pro COptionNabidka\n");
			else if ( !pgame->RegisterObject(pon) ) fprintf(stderr, "chyba inicializace COptionNabidka\n");
			pon->vybranaNabidkaOdkud= vybranaNabidka;
			break;
		case 4: // konec hry
			budeKonec=100;
			ptkrh->Ztmav();
			break;
		}

	}
}

void CHlavniNabidka::UpdateObjDisplay()
{
	CBaseNabidka::UpdateObjDisplay();	// zobrazi nabidku
}

///////////////////////////////////////////////////////////
////////////////////////// Nova hra ///////////////////////

CNovaHraNabidka::CNovaHraNabidka() { CBaseNabidka::CBaseNabidka(); }

CNovaHraNabidka::~CNovaHraNabidka()
{
	delete nab;
}

int CNovaHraNabidka::InitObject()
{
	CMapa::mGen(jm);
	obt= 0;		// ->normal<-, narez

	// nadpis
	sprintf(nadpis,"nova hra");

	nabPoc=4; velNejdNab=13;
	nab = new TPolozka[nabPoc];


	strcpy(nab[0].str, "jmeno");			nab[0].typ= T_NORMALNI;
	strcpy(nab[1].str, "obtiznost");		nab[1].typ= T_NORMALNI;
	strcpy(nab[2].str, "zalozit hrace");	nab[2].typ= T_NORMALNI;
	strcpy(nab[3].str, "zpet");				nab[3].typ= T_NORMALNI;

	CBaseNabidka::InitObject();
	return 1;
}

void CNovaHraNabidka::UpdateObjLogic(Uint8 *keys)
{
	CNovaHraStoryNabidka *pnhsn;
	CHlavniNabidka *phln;

	if ( budeKonec ) {
		budeKonec--;
		if ( budeKonec==5 )		// jinak se to este rozsviti ???
			switch (vybranaNabidka) {
			case 0: // jmeno
			case 1: // obtiznost
			case 3: // zpet
				break;
			case 2: // ok
				znicit=1;
				ptkrh->hraci[0].init();
				strcpy(ptkrh->hraci[0].jmeno, jm);
				ptkrh->hraci[0].obtiznost= obt;
				pnhsn = new CNovaHraStoryNabidka;
				if ( !pnhsn ) fprintf(stderr,"nepodarilo se naalokovat pamet pro CNovaHraStoryNabidka\n");
				else if ( !pgame->RegisterObject(pnhsn) ) fprintf(stderr, "chyba inicializace CNovaHraStoryNabidka\n");
				ptkrh->Rozni();
				return;
			}
		return;
	}

	CBaseNabidka::UpdateObjLogic(keys);	// posunovani v menu

	if (keys[SDLK_ESCAPE]) {	// to samy jako v case 3:...
		keys[SDLK_ESCAPE]=0;

		znicit=1;
		phln = new CHlavniNabidka;
		if ( !phln ) fprintf(stderr,"nepodarilo se naalokovat pamet pro CHlavniNabidka\n");
		else if ( !pgame->RegisterObject(phln) ) fprintf(stderr, "chyba inicializace CHlavniNabidka\n");
		phln->vybranaNabidka= vybranaNabidkaOdkud;
		return;
	}
	if (keys[SDLK_RETURN]) {
		keys[SDLK_RETURN]=0;

		switch (vybranaNabidka) {
		case 0: // jmeno
			PosunDolu();	// posunu se na dalsi nabidku
			break;
		case 1: // obtiznost
			PosunDolu();	// posunu se na dalsi nabidku
			break;
		case 2: // ok
			budeKonec=100;
			ptkrh->Ztmav();
			break;
		case 3: // zpet
			znicit=1;
			phln = new CHlavniNabidka;
			if ( !phln ) fprintf(stderr,"nepodarilo se naalokovat pamet pro CHlavniNabidka\n");
			else if ( !pgame->RegisterObject(phln) ) fprintf(stderr, "chyba inicializace CHlavniNabidka\n");
			phln->vybranaNabidka= vybranaNabidkaOdkud;
			return;
		}

	}

	int pom1, pom2;
	switch (vybranaNabidka) {
	case 0: // jmeno
		pom1=pgame->CoJeZmacknuty(keys);
		switch (pom1) {
		case 0: break;
		case SDLK_BACKSPACE:
			pom2= strlen(jm);
			if (pom2>0) jm[pom2-1]=0;
			break;
		default:
			pom2= strlen(jm);
			if (pom2<9) { jm[pom2]= (keys[SDLK_LSHIFT]||keys[SDLK_RSHIFT])?pom1-('a'-'A'):pom1; jm[pom2+1]=0; }
			break;
		}
		break;
	case 1: // obtiznost
		if ( keys[SDLK_RIGHT] ) {
			keys[SDLK_RIGHT]=0;
			obt= (obt+1) % 2;
		}
		if ( keys[SDLK_LEFT] ) {
			keys[SDLK_LEFT]=0;
			obt= (obt+2-1) % 2;
		}
		break;
	}
}

void CNovaHraNabidka::UpdateObjDisplay()
{
	switch (vybranaNabidka) {
	case 0: // jmeno
		UdelejRamecek( -5.5f+2*VEL_ZNAKUX*ZV, ZV*(VEL_ZNAKUY+1.5f*TLO_MEZ), ZV*9*VEL_ZNAKUX, ZV*VEL_ZNAKUY);
		break;
	case 1: // obtiznost
		UdelejRamecek( -5.5f+2*VEL_ZNAKUX*ZV, ZV*0.5*TLO_MEZ, ZV*6*VEL_ZNAKUX, ZV*VEL_ZNAKUY);
		break;
	}

	pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, ZV*(VEL_ZNAKUY+1.5*TLO_MEZ), 1,1,1,ZV,
			"%s", jm);
	pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, ZV*0.5*TLO_MEZ, 1,1,1,ZV,
			(obt==0)?"normal":"narez");

	CBaseNabidka::UpdateObjDisplay();	// zobrazi nabidku
}

///////////////////////////////////////////////////////////
////////////////////////// Story //////////////////////////

CNovaHraStoryNabidka::CNovaHraStoryNabidka() { CBaseNabidka::CBaseNabidka(); }

CNovaHraStoryNabidka::~CNovaHraStoryNabidka()
{
	delete nab;
}

int CNovaHraStoryNabidka::InitObject()
{
	cas= 0;

	// nadpis
	//sprintf(nadpis,"pribeh");
	nadpis[0]= 0;

	nabPoc=1; velNejdNab=10;
	nab = new TPolozka[nabPoc];

	strcpy(nab[0].str, "pokracovat");	nab[0].typ= T_NORMALNI;

	CBaseNabidka::InitObject();
	return 1;
}

void CNovaHraStoryNabidka::UpdateObjLogic(Uint8 *keys)
{
	CHangarNabidka *phn;

	cas++;

	if ( budeKonec ) {
		budeKonec--;
		if ( budeKonec==5 )		// jinak se to este rozsviti ???
			switch (vybranaNabidka) {
			case 0: // ok
				znicit=1;
				phn = new CHangarNabidka;
				if ( !phn ) fprintf(stderr,"nepodarilo se naalokovat pamet pro CHangarNabidka\n");
				else if ( !pgame->RegisterObject(phn) ) fprintf(stderr, "chyba inicializace CHangarNabidka\n");
				phn->vybranaNabidkaOdkud= vybranaNabidka;
				ptkrh->Rozni();
				return;
			}
		return;
	}

	CBaseNabidka::UpdateObjLogic(keys);	// posunovani v menu

	if (keys[SDLK_ESCAPE]) {	// to samy jako v case 0:...
		keys[SDLK_ESCAPE]=0;
		znicit=1;
		phn = new CHangarNabidka;
		if ( !phn ) fprintf(stderr,"nepodarilo se naalokovat pamet pro CHangarNabidka\n");
		else if ( !pgame->RegisterObject(phn) ) fprintf(stderr, "chyba inicializace CHangarNabidka\n");
		phn->vybranaNabidkaOdkud= vybranaNabidka;
		ptkrh->Rozni();
		return;
	}
	if (keys[SDLK_RETURN]) {
		keys[SDLK_RETURN]=0;
		switch (vybranaNabidka) {
		case 0: // ok
			budeKonec=100;
			ptkrh->Ztmav();
			break;
		}
	}
}

void CNovaHraStoryNabidka::UpdateObjDisplay()
{
	if ( cas>100 )
		pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, 2, ((float)cas-100)/100,((float)cas-100)/100,((float)cas-100)/100,ZV,
			"Byl jsi predurcen");
	if ( cas>300 )
		pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, 2-VEL_ZNAKUY*ZV, ((float)cas-300)/100,((float)cas-300)/100,((float)cas-300)/100,ZV,
			"stat se panem vesmiru.");
	if ( cas>500 )
		pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, 2-VEL_ZNAKUY*ZV*2, ((float)cas-500)/100,((float)cas-500)/100,((float)cas-500)/100,ZV,
			"pohyb - sipky, strelba - lCtrl,");//"Ale na to potrebujes lepsi lod.");
	if ( cas>700 )
		pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, 2-VEL_ZNAKUY*ZV*3, ((float)cas-700)/100,((float)cas-700)/100,((float)cas-700)/100,ZV,
			"zmena zbrane - lShift");//"A proto potrebujes penize.");
	if ( cas>900 )
		pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, 2-VEL_ZNAKUY*ZV*4, ((float)cas-900)/100,((float)cas-900)/100,((float)cas-900)/100,ZV,
			"");//"Ale ty nerostou na strome...");

	if ( cas>900 )
		CBaseNabidka::UpdateObjDisplay();	// zobrazi nabidku
}

///////////////////////////////////////////////////////////
////////////////////////// Load ///////////////////////////

CLoadNabidka::CLoadNabidka() { CBaseNabidka::CBaseNabidka(); }

CLoadNabidka::~CLoadNabidka()
{
	delete nab;
}

int CLoadNabidka::InitObject()
{
	FILE *f; char poms[20];

	// nadpis
	sprintf(nadpis,"nahrat hru");

	nabPoc=6; velNejdNab=13;
	nab = new TPolozka[nabPoc];

	for(int i=0; i<5; i++) {
		sprintf(poms,"Save/save%d.war",i+1);
		f= fopen(poms,"rb");
		if (!f) {
			strcpy(nab[i].str, "--");	nab[i].typ= T_SKRYTA;
		} else {
			//ted se nacte cast souboru
			int obtiznost; int maxLevel; int penize; int vybranaLod; char jmeno[10];
			if ( fread((void*)&obtiznost, sizeof(obtiznost),1,f) +
				fread((void*)&maxLevel, sizeof(maxLevel),1,f) +
				fread((void*)&penize, sizeof(penize),1,f) +
				fread((void*)&vybranaLod, sizeof(vybranaLod),1,f) +
				fread((void*)&jmeno, sizeof(jmeno),1,f)
				< 5 ) fprintf(stderr, "Nepodarilo se nacist soubor %s (ve fci CLoadNabidka::InitObject().\n",poms);
			fclose(f);
			sprintf(poms,"%s(%d)",jmeno,maxLevel+1);
			strcpy(nab[i].str, poms);
			if ( obtiznost==0 ) nab[i].typ= T_NORMALNI; else nab[i].typ= T_MODRA;
		}
	}

	strcpy(nab[5].str, "zpet");		nab[5].typ= T_NORMALNI;

	CBaseNabidka::InitObject();
	return 1;
}

void CLoadNabidka::UpdateObjLogic(Uint8 *keys)
{
	CHangarNabidka *phn;
	CHlavniNabidka *phln;

	if ( budeKonec ) {
		budeKonec--;
		if ( budeKonec==5 )		// jinak se to este rozsviti ???
			switch (vybranaNabidka) {
			case 0: // 1.hrac
			case 1: // 2.hrac
			case 2: // 3.hrac
			case 3: // 4.hrac
			case 4: // 5.hrac
				znicit=1;
				ptkrh->hraci[0].load(vybranaNabidka+1);
				phn = new CHangarNabidka;
				if ( !phn ) fprintf(stderr,"nepodarilo se naalokovat pamet pro CHangarNabidka\n");
				else if ( !pgame->RegisterObject(phn) ) fprintf(stderr, "chyba inicializace CHangarNabidka\n");
				phn->vybranaNabidkaOdkud= vybranaNabidkaOdkud;
				ptkrh->Rozni();
				return;

			//case 5: break; // zpet
			}
		return;
	}

	CBaseNabidka::UpdateObjLogic(keys);	// posunovani v menu

	if (keys[SDLK_ESCAPE]) {	// to samy jako v case 4:...
		keys[SDLK_ESCAPE]=0;

		znicit=1;
		phln = new CHlavniNabidka;
		if ( !phln ) fprintf(stderr,"nepodarilo se naalokovat pamet pro CHlavniNabidka\n");
		else if ( !pgame->RegisterObject(phln) ) fprintf(stderr, "chyba inicializace CHlavniNabidka\n");
		phln->vybranaNabidka= vybranaNabidkaOdkud;
		return;
	}
	if (keys[SDLK_RETURN]) {
		keys[SDLK_RETURN]=0;

		switch (vybranaNabidka) {
		case 0: case 1: case 2: case 3: case 4: 
			budeKonec=100;
			ptkrh->Ztmav();
			break;
		case 5: // zpet
			znicit=1;
			phln = new CHlavniNabidka;
			if ( !phln ) fprintf(stderr,"nepodarilo se naalokovat pamet pro CHlavniNabidka\n");
			else if ( !pgame->RegisterObject(phln) ) fprintf(stderr, "chyba inicializace CHlavniNabidka\n");
			phln->vybranaNabidka= vybranaNabidkaOdkud;
			return;
		}

	}
}

void CLoadNabidka::UpdateObjDisplay()
{
	CBaseNabidka::UpdateObjDisplay();	// zobrazi nabidku
}


///////////////////////////////////////////////////////////
////////////////////////// About //////////////////////////

CAboutNabidka::CAboutNabidka() { CBaseNabidka::CBaseNabidka(); }

CAboutNabidka::~CAboutNabidka()
{
	delete nab;
}

int CAboutNabidka::InitObject()
{
	cas= 0;

	// nadpis
	//sprintf(nadpis,"autori");
	nadpis[0]= 0;

	nabPoc=1; velNejdNab=4;
	nab = new TPolozka[nabPoc];

	strcpy(nab[0].str, "zpet");	nab[0].typ= T_NORMALNI;

	CBaseNabidka::InitObject();
	return 1;
}

void CAboutNabidka::UpdateObjLogic(Uint8 *keys)
{
	CHlavniNabidka *phln;

	cas++;

	if ( budeKonec ) {
		budeKonec--;
		if ( budeKonec==5 )		// jinak se to este rozsviti ???
			switch (vybranaNabidka) {
			case 0: // zpet
				znicit=1;
				phln = new CHlavniNabidka;
				if ( !phln ) fprintf(stderr,"nepodarilo se naalokovat pamet pro CHlavniNabidka\n");
				else if ( !pgame->RegisterObject(phln) ) fprintf(stderr, "chyba inicializace CHlavniNabidka\n");
				phln->vybranaNabidka= vybranaNabidkaOdkud;
				ptkrh->Rozni();
				return;
			}
		return;
	}

	CBaseNabidka::UpdateObjLogic(keys);	// posunovani v menu

	if (keys[SDLK_ESCAPE]) {	// to samy jako v case 1:...
		keys[SDLK_ESCAPE]=0;
		znicit=1;
		phln = new CHlavniNabidka;
		if ( !phln ) fprintf(stderr,"nepodarilo se naalokovat pamet pro CHlavniNabidka\n");
		else if ( !pgame->RegisterObject(phln) ) fprintf(stderr, "chyba inicializace CHlavniNabidka\n");
		phln->vybranaNabidka= vybranaNabidkaOdkud;
		ptkrh->Rozni();
		return;
	}
	if (keys[SDLK_RETURN]) {
		keys[SDLK_RETURN]=0;
		switch (vybranaNabidka) {
		case 0: // ok
			budeKonec=100;
			ptkrh->Ztmav();
			break;
		}
	}
}

void CAboutNabidka::UpdateObjDisplay()
{
	// nadpis
	char nadpis[20]; strcpy(nadpis,"autori");
	pogl->glPrintEx( -(double)strlen(nadpis)/2*VEL_ZNAKUX*ZVN, TXTSCRY-1.5*VEL_ZNAKUY*ZVN, 1,1,1,ZVN, "%s", nadpis);

	if ( cas>100 )
		pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, 2, ((float)cas-100)/100,((float)cas-100)/100,((float)cas-100)/100,ZV,
			"programoval: Jakub Hlavacek");
	if ( cas>300 )
		pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, 2-VEL_ZNAKUY*ZV*2, ((float)cas-300)/100,((float)cas-300)/100,((float)cas-300)/100,ZV,
			"    grafika: Jakub Hlavacek");
	if ( cas>500 )
		pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, 2-VEL_ZNAKUY*ZV*4, ((float)cas-500)/100,((float)cas-500)/100,((float)cas-500)/100,ZV,
			"      hudba: Jan Hlavacek");
	if ( cas>700 )
		pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, 2-VEL_ZNAKUY*ZV*6, ((float)cas-700)/100,((float)cas-700)/100,((float)cas-700)/100,ZV,
			"      zvuky: Jan Hlavacek");
	if ( cas>900 )
		pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, 2-VEL_ZNAKUY*ZV*8, ((float)cas-900)/100,((float)cas-900)/100,((float)cas-900)/100,ZV,
			"     pribeh: Mirek Hedl");
	if ( cas>1100 )
		pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, 2-VEL_ZNAKUY*ZV*10, ((float)cas-1100)/100,((float)cas-1100)/100,((float)cas-1100)/100,ZV,
			"test player: Jakub Hlavacek");
	if ( cas>1300 )
		pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, 2-VEL_ZNAKUY*ZV*12, ((float)cas-1300)/100,((float)cas-1300)/100,((float)cas-1300)/100,ZV,
			"   homepage: hippo.nipax.cz");
	if ( cas>1500 )
		pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, 2-VEL_ZNAKUY*ZV*14, ((float)cas-1500)/100,((float)cas-1500)/100,((float)cas-1500)/100,ZV,
			"chyby hlasit na j.hlavacek@email.cz");

	if ( cas>1700 )
		CBaseNabidka::UpdateObjDisplay();	// zobrazi nabidku
}

///////////////////////////////////////////////////////////
////////////////////////// Option /////////////////////////

COptionNabidka::COptionNabidka() { CBaseNabidka::CBaseNabidka(); }

COptionNabidka::~COptionNabidka()
{
	delete nab;
}

int COptionNabidka::InitObject()
{
	napoveda[0]= 0;	// pro zobrazeni "Zmena nastaveni obrazovky se projevi az po restartu programu"
	zKama= zHlavni;	// z hlavni nabidky

	Reset();
	Nacti();	// nacte nastaveni ze souboru

	// nadpis
	sprintf(nadpis,"nova hra");

	nabPoc=10; velNejdNab=16;
	nab = new TPolozka[nabPoc];

	strcpy(nab[0].str, "rozliseni");		nab[0].typ= T_NORMALNI; // 640x480; 800x600; 1024x768; 1600x1200;
	strcpy(nab[1].str, "cela obrazovka");	nab[1].typ= T_NORMALNI;	// ano; ne;
	strcpy(nab[2].str, "efekty");			nab[2].typ= T_NORMALNI;	// ano; ne;
	strcpy(nab[3].str, "zvuky");			nab[3].typ= T_NORMALNI; // ne; 1..10;
	strcpy(nab[4].str, "hudba");			nab[4].typ= T_NORMALNI;	// ne; 1..10;
	strcpy(nab[5].str, "jazyk");			nab[5].typ= T_SKRYTA;	// cesky; English;
	strcpy(nab[6].str, "ovladani");			nab[6].typ= T_SKRYTA;	// klavesnice; joystick;
	strcpy(nab[7].str, "nastaveni klaves");	nab[7].typ= T_SKRYTA;
	//strcpy(nab[6].str, "nahoru");			nab[6].typ= T_NORMALNI;
	//strcpy(nab[7].str, "dolu");			nab[7].typ= T_NORMALNI;
	//strcpy(nab[8].str, "doleva");			nab[8].typ= T_NORMALNI;
	//strcpy(nab[9].str, "doprava");		nab[9].typ= T_NORMALNI;
	//strcpy(nab[10].str, "strelba");		nab[10].typ= T_NORMALNI;
	//strcpy(nab[11].str, "zmena zbrane");	nab[11].typ= T_NORMALNI;
	strcpy(nab[8].str, "reset");			nab[8].typ= T_NORMALNI;
	strcpy(nab[9].str, "ulozit a zpet");	nab[9].typ= T_NORMALNI;
	//strcpy(nab[10].str, "zpet");			nab[10].typ= T_NORMALNI;

	CBaseNabidka::InitObject();
	return 1;
}

void COptionNabidka::UpdateObjLogic(Uint8 *keys)
{
	CHlavniNabidka *phln;
	CHangarNabidka *phn;
	CPauseNabidka *ppn;

	CBaseNabidka::UpdateObjLogic(keys);	// posunovani v menu

	if (keys[SDLK_ESCAPE]) {	// to samy jako v ...
		keys[SDLK_ESCAPE]=0;

		Uloz();
		znicit=1;
		switch (zKama) {
		case zHlavni:
			phln = new CHlavniNabidka;
			if ( !phln ) fprintf(stderr,"nepodarilo se naalokovat pamet pro CHlavniNabidka\n");
			else if ( !pgame->RegisterObject(phln) ) fprintf(stderr, "chyba inicializace CHlavniNabidka\n");
			phln->vybranaNabidka= vybranaNabidkaOdkud;
			return;
		case zHangaru:
			phn = new CHangarNabidka;
			if ( !phn ) fprintf(stderr,"nepodarilo se naalokovat pamet pro CHangarNabidka\n");
			else if ( !pgame->RegisterObject(phn) ) fprintf(stderr, "chyba inicializace CHangarNabidka\n");
			phn->vybranaNabidka= vybranaNabidkaOdkud;
			return;
		case zeHry:
			ppn = new CPauseNabidka;
			if ( !ppn ) fprintf(stderr,"nepodarilo se naalokovat pamet pro CPauseNabidka\n");
			else if ( !pgame->RegisterObject(ppn,1) ) fprintf(stderr, "chyba inicializace CPauseNabidka\n");
			ppn->vybranaNabidka= vybranaNabidkaOdkud;
			return;
		}
	}
	if (keys[SDLK_RETURN]) {
		keys[SDLK_RETURN]=0;

		switch (vybranaNabidka) {
		case 0: // rozliseni
		case 1: // cela obrazovka
		case 2: // efekty
		case 3: // zvuky
		case 4: // hudba
		case 5: // jazyk
		case 6: // ovladani
			PosunDolu();	// posunu se na dalsi nabidku
			break;
		case 7: // nastaveni klaves
			break;
		case 8: // reset
			Reset();
			break;
		case 9: // ulozit a zpet
			// tady se to ulozi:
			Uloz();
			znicit=1;
			switch (zKama) {
			case zHlavni:
				phln = new CHlavniNabidka;
				if ( !phln ) fprintf(stderr,"nepodarilo se naalokovat pamet pro CHlavniNabidka\n");
				else if ( !pgame->RegisterObject(phln) ) fprintf(stderr, "chyba inicializace CHlavniNabidka\n");
				phln->vybranaNabidka= vybranaNabidkaOdkud;
				return;
			case zHangaru:
				phn = new CHangarNabidka;
				if ( !phn ) fprintf(stderr,"nepodarilo se naalokovat pamet pro CHangarNabidka\n");
				else if ( !pgame->RegisterObject(phn) ) fprintf(stderr, "chyba inicializace CHangarNabidka\n");
				phn->vybranaNabidka= vybranaNabidkaOdkud;
				return;
			case zeHry:
				ppn = new CPauseNabidka;
				if ( !ppn ) fprintf(stderr,"nepodarilo se naalokovat pamet pro CPauseNabidka\n");
				else if ( !pgame->RegisterObject(ppn,1) ) fprintf(stderr, "chyba inicializace CPauseNabidka\n");
				ppn->vybranaNabidka= vybranaNabidkaOdkud;
				return;
			}
		}
	}

	#define NASTAVENI_DOLEVA_DOPRAVA(prom,max)			\
						if ( keys[SDLK_RIGHT] ) {		\
							keys[SDLK_RIGHT]=0;			\
							prom= (prom+1) % max;		\
						}								\
						if ( keys[SDLK_LEFT] ) {		\
							keys[SDLK_LEFT]=0;			\
							prom= (prom+max-1) % max;	\
						}
	switch (vybranaNabidka) {
	case 0: // rozliseni			640x480; 800x600; 1024x768; 1600x1200;
		if ( keys[SDLK_RIGHT] || keys[SDLK_LEFT] )
			strcpy(napoveda,"Zmena nastaveni \nobrazovky se projevi \naz po restartu \nprogramu");
		NASTAVENI_DOLEVA_DOPRAVA(rozliseni,4)
		break;
	case 1: // cela obrazovka		ano; ne;
		if ( keys[SDLK_RIGHT] || keys[SDLK_LEFT] )
			strcpy(napoveda,"Zmena nastaveni \nobrazovky se projevi \naz po restartu \nprogramu");
		NASTAVENI_DOLEVA_DOPRAVA(celaObrazovka,2)
		break;
	case 2: // efekty				ano; ne;
		NASTAVENI_DOLEVA_DOPRAVA(efekty,2)
		ptkrh->efekty= efekty;
		break;
	case 3: // zvuky				0..10;
		if ( ( keys[SDLK_RIGHT] && zvuky==10 ) || ( keys[SDLK_LEFT] && zvuky==0 ) ) break;
		NASTAVENI_DOLEVA_DOPRAVA(zvuky,11)
		ptkrh->sound.NastavSoundVolume(zvuky);
		break;
	case 4: // hudba				0..10;
		if ( ( keys[SDLK_RIGHT] && hudba==10 ) || ( keys[SDLK_LEFT] && hudba==0 ) ) break;
		NASTAVENI_DOLEVA_DOPRAVA(hudba,11)
		ptkrh->sound.NastavMusicVolume(hudba);
		break;
	case 5: // jazyk				English; cesky;
		NASTAVENI_DOLEVA_DOPRAVA(jazyk,2)
		break;
	case 6: // ovladani				klavesnice; joystick;
		NASTAVENI_DOLEVA_DOPRAVA(ovladani,2)
		break;
	case 7: // nastaveni klaves
		//strcpy(nab[6].str, "nahoru");			nab[6].typ= T_NORMALNI;
		//strcpy(nab[7].str, "dolu");			nab[7].typ= T_NORMALNI;
		//strcpy(nab[8].str, "doleva");			nab[8].typ= T_NORMALNI;
		//strcpy(nab[9].str, "doprava");		nab[9].typ= T_NORMALNI;
		//strcpy(nab[10].str, "strelba");		nab[10].typ= T_NORMALNI;
		//strcpy(nab[11].str, "zmena zbrane");	nab[11].typ= T_NORMALNI;
		break;
	case 8: // reset
	case 9: // ulozit a zpet
	//case 10: // zpet
		break;
	}
}

void COptionNabidka::UpdateObjDisplay()
{

	// nakreslim levej sloupec. nejdriv ramecky a pak pismo
	#define UDELEJ_RAMECEK_V_LEVO(kolikata,zKolika,kolikPismen)		\
			UdelejRamecek( -5.5f+2*VEL_ZNAKUX*ZV,					\
				ZV*((zKolika*VEL_ZNAKUY+(zKolika-1)*TLO_MEZ)/2-VEL_ZNAKUY-(VEL_ZNAKUY+TLO_MEZ)*kolikata),	\
				ZV*VEL_ZNAKUX*kolikPismen, ZV*VEL_ZNAKUY)

	switch (vybranaNabidka) {
	case 0: // rozliseni			640x480; 800x600; 1024x768; 1600x1200;
		UDELEJ_RAMECEK_V_LEVO(vybranaNabidka,nabPoc,9);
		break;
	case 1: // obtiznost			ano; ne;
		UDELEJ_RAMECEK_V_LEVO(vybranaNabidka,nabPoc,3);
		break;
	case 2: // efekty				ano; ne;
		UDELEJ_RAMECEK_V_LEVO(vybranaNabidka,nabPoc,3);
		break;
	case 3: // zvuky				ne; 1..10;
		UDELEJ_RAMECEK_V_LEVO(vybranaNabidka,nabPoc,2);
		break;
	case 4: // hudba				ne; 1..10;
		UDELEJ_RAMECEK_V_LEVO(vybranaNabidka,nabPoc,2);
		break;
	case 5: // jazyk				English; cesky;
		UDELEJ_RAMECEK_V_LEVO(vybranaNabidka,nabPoc,7);
		break;
	case 6: // ovladani				klavesnice; joystick;
		UDELEJ_RAMECEK_V_LEVO(vybranaNabidka,nabPoc,10);
		break;
	case 7: // nastaveni klaves
	case 8: // reset
	case 9: // ulozit a zpet
	//case 10: // zpet
		break;
	}

	char *rozliseniStr[4] = { "640x480","800x600","1024x768","1600x1200" };
	char *anoNeStr[2] = { "ne","ano" };
	char *ne1az10[11] = { "ne","1","2","3","4","5","6","7","8","9","10" };
	//char *ovladaniStr[2] = { "klavesnice","joystick" };
	//char *jazykStr[2] = { "cesky","English" };
	#define YOVA_SOURADNICE_PRINT_EX(kolikata,zKolika)	ZV*((zKolika*VEL_ZNAKUY+(zKolika-1)*TLO_MEZ)/2-VEL_ZNAKUY-(VEL_ZNAKUY+TLO_MEZ)*kolikata)
	pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, YOVA_SOURADNICE_PRINT_EX(0,nabPoc), 1,1,1,ZV,
		"%s", rozliseniStr[ rozliseni ]);
	pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, YOVA_SOURADNICE_PRINT_EX(1,nabPoc), 1,1,1,ZV,
		"%s", anoNeStr[ celaObrazovka ]);
	pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, YOVA_SOURADNICE_PRINT_EX(2,nabPoc), 1,1,1,ZV,
		"%s", anoNeStr[ efekty ]);
	pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, YOVA_SOURADNICE_PRINT_EX(3,nabPoc), 1,1,1,ZV,
		"%s", ne1az10[zvuky] );
	pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, YOVA_SOURADNICE_PRINT_EX(4,nabPoc), 1,1,1,ZV,
		"%s", ne1az10[hudba] );
//	pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, YOVA_SOURADNICE_PRINT_EX(5,nabPoc), 1,1,1,ZV,
//		"%s", jazykStr[ jazyk ]);
//	pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, YOVA_SOURADNICE_PRINT_EX(6,nabPoc), 1,1,1,ZV,
//		"%s", ovladaniStr[ ovladani ]);

	// napoveda
	int pom1=0,pom2=0;
	for (int i=0; napoveda[i]!=0; i++) {
		if (napoveda[i]=='\n') {
			napoveda[i]=0;
			pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, YOVA_SOURADNICE_PRINT_EX(8,nabPoc)-VEL_ZNAKUY*pom2, 1,1,1,1, "%s", &napoveda[pom1]);
			napoveda[i]='\n';
			pom1=i+1; pom2++;
		}
	} pogl->glPrintEx( -5.5+2*VEL_ZNAKUX*ZV, YOVA_SOURADNICE_PRINT_EX(8,nabPoc)-VEL_ZNAKUY*pom2, 1,1,1,1, "%s", &napoveda[pom1]);

	CBaseNabidka::UpdateObjDisplay();	// zobrazi nabidku
}

void COptionNabidka::Reset()
{
	rozliseni=0;
	celaObrazovka=0;
	efekty=1;
	zvuky=5;
	hudba=5;
	jazyk=0;
	ovladani=0;
	nahoru= SDLK_UP; dolu= SDLK_DOWN; doleva= SDLK_LEFT; doprava= SDLK_RIGHT;
	strelba= SDLK_LCTRL; zmenaZbrane= SDLK_LSHIFT;

	ptkrh->sound.NastavSoundVolume(zvuky);
	ptkrh->sound.NastavMusicVolume(hudba);
	ptkrh->efekty= efekty;
}

void COptionNabidka::Nacti()
{
	//nacita rozliseni atd. ze souboru "configure.txt"
	// neco podobnyho je v CGame a v CTridaKteraRidiHru a v CSound!
	int ROZ_X, ROZ_Y;	// jaky mam rozliseni obrazovky
	FILE *File=NULL;
	char s[1000]; int c;
	File=fopen("configure.txt","r");
	if (File) {
		while (fscanf(File,"%s",s)!=EOF) {
			if (strcmp(s,"width")==0) fscanf(File," %d",&ROZ_X);
			else if (strcmp(s,"height")==0) fscanf(File," %d",&ROZ_Y);
			else if (strcmp(s,"fullscreen")==0) fscanf(File," %d",&celaObrazovka);
			else if (strcmp(s,"effects")==0) fscanf(File," %d",&efekty);
			else if (strcmp(s,"sound")==0) fscanf(File," %d",&zvuky);
			else if (strcmp(s,"music")==0) fscanf(File," %d",&hudba);
			else if (strcmp(s,"language")==0) fscanf(File," %d",&jazyk);
			else if (strcmp(s,"control")==0) fscanf(File," %d",&ovladani);
			else if (strcmp(s,"keyboard")==0) fscanf(File," %d %d %d %d %d %d",&nahoru, &dolu, &doleva, &doprava, &strelba, &zmenaZbrane);
			else if (s[0]=='/' && s[1]=='/') while (getc(File)!='\n');
			else while ( (c=getc(File))!='\n' && c!=0 );
		}
		fclose(File);

		if (ROZ_X==640 && ROZ_Y==480) rozliseni=0;
		else if (ROZ_X==800 && ROZ_Y==600) rozliseni=1;
		else if (ROZ_X==1024 && ROZ_Y==768) rozliseni=2;
		else if (ROZ_X==1600 && ROZ_Y==1200) rozliseni=3;
	}

	ptkrh->sound.NastavSoundVolume(zvuky);
	ptkrh->sound.NastavMusicVolume(hudba);

	ptkrh->efekty= efekty;
}

void COptionNabidka::Uloz()
{
	int ROZ_X, ROZ_Y;	// jaky mam rozliseni obrazovky
	switch( rozliseni ) {
	case 0: ROZ_X=640; ROZ_Y=480; break;
	case 1: ROZ_X=800; ROZ_Y=600; break;
	case 2: ROZ_X=1024; ROZ_Y=768; break;
	case 3: ROZ_X=1600; ROZ_Y=1200; break;
	default: ROZ_X=641; ROZ_Y=481; break;
	}
	FILE *File=NULL;
	File=fopen("configure.txt","w");
	if ( !File ) { fprintf(stderr,"Nepodarilo se otevrit soubor configure.txt pro zapis."); return; }
	fprintf( File, "// rozliseni obrazovky:\n");
	fprintf( File, "width %d\n", ROZ_X);
	fprintf( File, "height %d\n", ROZ_Y);
	fprintf( File, "fullscreen %d\n", celaObrazovka);
	fprintf( File, "\n// graficke efekty (0-vypnuto, 1-zapnuto):\n");
	fprintf( File, "effects %d\n", efekty);
	fprintf( File, "\n// zvuky a hudba (0..9):\n");
	fprintf( File, "sound %d\n", zvuky);
	fprintf( File, "music %d\n", hudba);
	//fprintf( File, "\n// jazyk (0-cesky, 1-anglicky):\n");
	//fprintf( File, "language %d\n",jazyk);
	//fprintf( File, "\n// ovladani (0-klavesnice, 1-joystick):\n");
	//fprintf( File, "control %d\n", ovladani);
	fprintf( File, "\n// nastaveni klavesnice (nahoru, dolu, doleva, doprava, strelba, zmena zbrane):\n");
	fprintf( File, "keyboard %d %d %d %d %d %d\n",nahoru, dolu, doleva, doprava, strelba, zmenaZbrane);
	fclose(File);
}
