// HlavniNabidka.h: interface for the CHlavniNabidka class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_HLAVNINABIDKA_H__6BBE3400_21C9_11D8_83E3_008048208521__INCLUDED_)
#define AFX_HLAVNINABIDKA_H__6BBE3400_21C9_11D8_83E3_008048208521__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "BaseNabidka.h"
#include "KrObj.h"

// 1
class CHlavniNabidka : public CBaseNabidka
{
public:
	CHlavniNabidka();
	virtual ~CHlavniNabidka();

	int InitObject();
	void UpdateObjLogic(Uint8 *keys);
	void UpdateObjDisplay();
};

// 1.1
class CNovaHraNabidka : public CBaseNabidka
{
	char jm[10];	// nove jmeno hrace
	int obt;		// obtiznost
public:
	CNovaHraNabidka();
	virtual ~CNovaHraNabidka();

	int InitObject();
	void UpdateObjLogic(Uint8 *keys);
	void UpdateObjDisplay();
};

// 1.1.1
class CNovaHraStoryNabidka : public CBaseNabidka
{
	int cas;
public:
	CNovaHraStoryNabidka();
	virtual ~CNovaHraStoryNabidka();

	int InitObject();
	void UpdateObjLogic(Uint8 *keys);
	void UpdateObjDisplay();
};

// 1.2
class CLoadNabidka : public CBaseNabidka
{
public:
	CLoadNabidka();
	virtual ~CLoadNabidka();

	int InitObject();
	void UpdateObjLogic(Uint8 *keys);
	void UpdateObjDisplay();
};

// 1.3
class CAboutNabidka : public CBaseNabidka
{
	int cas;
public:
	CAboutNabidka();
	virtual ~CAboutNabidka();

	int InitObject();
	void UpdateObjLogic(Uint8 *keys);
	void UpdateObjDisplay();
};

// 1.4
class COptionNabidka : public CBaseNabidka
{
	char napoveda[1000];	// odsud se pak pise napoveda (hlaska:"Zmena nastaveni obrazovky se projevi az po restartu programu")

	int rozliseni;
	int celaObrazovka;
	int efekty;
	int zvuky;
	int hudba;
	int jazyk;
	int ovladani;
	int nastaveniKlaves;
	int nahoru, dolu, doleva, doprava, strelba, zmenaZbrane;

	void Reset();	// vrati puvodni nastaveni
	void Nacti();	// nacte ze souboru configure.txt
	void Uloz();	// ulozi do     -- || --

public:
	COptionNabidka();
	virtual ~COptionNabidka();

	int InitObject();
	void UpdateObjLogic(Uint8 *keys);
	void UpdateObjDisplay();

	enum TZKama {
		zHlavni, zHangaru, zeHry
	};

	TZKama zKama;	// z kama (odkud) sem zavolal option nabidku
};

// 2 (vsechno, co zacina dvojkou, je v souboru u hangarn abidky)
class CHangarNabidka : public CBaseNabidka
{
public:
	CHangarNabidka();
	virtual ~CHangarNabidka();

	int InitObject();
	void UpdateObjLogic(Uint8 *keys);
	void UpdateObjDisplay();
};

// 2.1
class CMapaNabidka : public CBaseNabidka
{
public:
	CMapaNabidka();
	virtual ~CMapaNabidka();

	int InitObject();
	void UpdateObjLogic(Uint8 *keys);
	void UpdateObjDisplay();
};

// 2.2
class CObchodNabidka : public CBaseNabidka
{
	int kolikToStoji;		// kolik stoji vec, na ktery v nabidce prave sem
	char napoveda[1000];	// odsud se pak pise napoveda, posis, ... k jednotlivejm nabidkam
	void spoctiKolikToStoji();	// spocita napovedu a kolik to stoji
public:
	CObchodNabidka();
	virtual ~CObchodNabidka();

	int InitObject();
	void UpdateObjLogic(Uint8 *keys);
	void UpdateObjDisplay();
};

// 2.3
class CNakupLodiNabidka : public CBaseNabidka
{
	int kolikToStoji;		// kolik stoji vec, na ktery v nabidce prave sem
	char napoveda[1000];	// odsud se pak pise napoveda, posis, ... k jednotlivejm nabidkam
	void init();			// spocte ceny a zaktualizuje nabidku
	CKrObj krObj;
public:
	CNakupLodiNabidka();
	virtual ~CNakupLodiNabidka();

	int InitObject();
	void UpdateObjLogic(Uint8 *keys);
	void UpdateObjDisplay();
};

// 3.1 (vsechno, co zacina trojkou, je v souboru u hangarn abidky)
class CPauseNabidka : public CBaseNabidka
{
public:
	CPauseNabidka();
	virtual ~CPauseNabidka();

	int InitObject();
	void UpdateObjLogic(Uint8 *keys);
	void UpdateObjDisplay();
};

// 3.2
class CVyhralProhralNabidka : public CBaseNabidka
{
	int cas;
public:
	CVyhralProhralNabidka();
	virtual ~CVyhralProhralNabidka();

	int InitObject();
	void UpdateObjLogic(Uint8 *keys);
	void UpdateObjDisplay();

	int staryLevel, novyLevel;
};

#endif // !defined(AFX_HLAVNINABIDKA_H__6BBE3400_21C9_11D8_83E3_008048208521__INCLUDED_)
