// KrObj.cpp: implementation of the CKrObj class.
//
//////////////////////////////////////////////////////////////////////

#include "KrObj.h"
#include "TridaKteraRidiHru.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CKrObj::CKrObj() {}

CKrObj::~CKrObj() {}

void CKrObj::init(int cisloTypuKrObj, TYPOBJ tPratel)
{
	cT= cisloTypuKrObj;
	typPratel= tPratel;
	kolikatejObrazek= 0;
	zbejvaDoDalsiho= ptkrh->typyKrObj[cT].textury[kolikatejObrazek].jakDlouho;
}

void CKrObj::UpdateLogic()
{
	if (!zbejvaDoDalsiho) {
		kolikatejObrazek= (kolikatejObrazek + 1) % ptkrh->typyKrObj[cT].pocTextur;
		zbejvaDoDalsiho= ptkrh->typyKrObj[cT].textury[kolikatejObrazek].jakDlouho;
	} else zbejvaDoDalsiho--;
}

void CKrObj::UpdateDisplay(TSour kam, float pruhlednost)
{
	float w, h;

	// nastaveni cumeni (nahoru|dolu)
	switch ( typPratel ) {
	// cumim nahoru
	case TYPOBJ_STRELA:
	case TYPOBJ_LOD:
		w= ptkrh->typyKrObj[cT].w,
		h= ptkrh->typyKrObj[cT].h;
		break;
	// cumim dolu
	case TYPOBJ_NESTRELA:
	case TYPOBJ_NELOD:
		w=-ptkrh->typyKrObj[cT].w,
		h=-ptkrh->typyKrObj[cT].h;
		break;
	default:
		fprintf(stderr,"nekdo vykresluje pomoci CKrObj a neni potporovaneho typu objektu\n");
	}

	glPushMatrix();
	glTranslated(kam.x,kam.y,kam.z);

	if ( ptkrh->typyKrObj[cT].typTury==TYPTURA_NORMALNI ) {
	}

	// samotne vykresleni
	switch ( ptkrh->typyKrObj[cT].typTury ) {
	case TYPTURA_NORMALNI:	// lod, nelod, nake strely
		// stin
		if ( ptkrh->efekty ) {
			glPushMatrix();
			glTranslatef(0.0f,0.0f,-5.0f);
			//glRotatef( (float)lod.rych.x*100,0.0f,1.0f,0.0f);				// Rotate On The Z Axis 360 Degrees
			glColor3f(.4f,.4f,.4f);				// pruhlednost stinu je 60%
			glBlendFunc(GL_ZERO, GL_ONE_MINUS_SRC_COLOR);					// http://www.root.cz/clanek/1995
			glBindTexture(GL_TEXTURE_2D, ptkrh->typyKrObj[cT].textury[kolikatejObrazek].turaCB);
			glBegin(GL_QUADS);												// Start Drawing A Textured Quad
				glTexCoord2f(0.0f, 0.0f); glVertex3f(-w, -h, 0.f);	// Bottom Left
				glTexCoord2f(1.0f, 0.0f); glVertex3f( w, -h, 0.f);	// Bottom Right
				glTexCoord2f(1.0f, 1.0f); glVertex3f( w,  h, 0.f);	// Top Right
				glTexCoord2f(0.0f, 1.0f); glVertex3f(-w,  h, 0.f);	// Top Left
			glEnd();														// Done Drawing The Quad
			glColor3f(1.f,1.f,1.f);
			glPopMatrix();
		}

		// texturaCB	
		glDisable(GL_DEPTH_TEST);						// Disable Depth Testing
		glBlendFunc(GL_ZERO,GL_ONE_MINUS_SRC_COLOR);	// ted je na texture bila lod na cernym pozadi
		glBindTexture(GL_TEXTURE_2D, ptkrh->typyKrObj[cT].textury[kolikatejObrazek].turaCB);
		glBegin(GL_QUADS);												// Start Drawing A Textured Quad
			glTexCoord2f(0.f, 0.f); glVertex3f(-w, -h, 0.f);	// Bottom Left
			glTexCoord2f(1.f, 0.f); glVertex3f( w, -h, 0.f);	// Bottom Right
			glTexCoord2f(1.f, 1.f); glVertex3f( w,  h, 0.f);	// Top Right
			glTexCoord2f(0.f, 1.f); glVertex3f(-w,  h, 0.f);	// Top Left
		glEnd();														// Done Drawing The Quad
		glEnable(GL_DEPTH_TEST);						// Disable Depth Testing
		// textura
		glBlendFunc(GL_ONE, GL_ONE);					// Copy Image 2 Color To The Screen
		glBindTexture(GL_TEXTURE_2D, ptkrh->typyKrObj[cT].textury[kolikatejObrazek].tura);
		glBegin(GL_QUADS);												// Start Drawing A Textured Quad
			glTexCoord2f(0.f, 0.f); glVertex3f(-w, -h, 0.f);	// Bottom Left
			glTexCoord2f(1.f, 0.f); glVertex3f( w, -h, 0.f);	// Bottom Right
			glTexCoord2f(1.f, 1.f); glVertex3f( w,  h, 0.f);	// Top Right
			glTexCoord2f(0.f, 1.f); glVertex3f(-w,  h, 0.f);	// Top Left
		glEnd();														// Done Drawing The Quad
		break;
	case TYPTURA_PRUHLEDNA:	// stit lodi
		glColor3f( pruhlednost, pruhlednost, pruhlednost);
		glBlendFunc(GL_ONE, GL_ONE);
		glBindTexture(GL_TEXTURE_2D, ptkrh->typyKrObj[cT].textury[kolikatejObrazek].tura);
		glBegin(GL_QUADS);												// Start Drawing A Textured Quad
			glTexCoord2f(0.f, 0.f); glVertex3f(-w, -h, 0.f);	// Bottom Left
			glTexCoord2f(1.f, 0.f); glVertex3f( w, -h, 0.f);	// Bottom Right
			glTexCoord2f(1.f, 1.f); glVertex3f( w,  h, 0.f);	// Top Right
			glTexCoord2f(0.f, 1.f); glVertex3f(-w,  h, 0.f);	// Top Left
		glEnd();														// Done Drawing The Quad
		glColor3f(1.f,1.f,1.f);
		break;
	default:
		fprintf(stderr,"nekdo vykresluje pomoci CKrObj a neni potporovaneho typu textury\n");
	}

	glPopMatrix();

}
