// Lod.cpp: implementation of the CLod class.
//
//////////////////////////////////////////////////////////////////////

#include <math.h>
#include "Lod.h"
#include "Game.h"
#include "TridaKteraRidiHru.h"
#include "Vybuch.h"
#include "HlavniNabidka.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CLod::CLod()
{
	znicit=0;
	pol.z=-30;
	typObj=TYPOBJ_LOD;
}

//CLod::~CLod() {}

int CLod::InitObject()
{
	// tohle vsechno by se melo zinicializovat pri zacatku hry
	pol.x= 0;
	pol.y= -SCREEN_Y*2/3;
	rychlost= TSour(0,0,0);
	armour= maxArmour;
	shield= maxShield;
	stitySviti= 0;

	vybranaHlZbr=MAX_POCET_HL_ZBR-1;
	while ( ktereHlZbrane[vybranaHlZbr]==0 ) {
		vybranaHlZbr-= 1;
		if ( vybranaHlZbr<0 ) vybranaHlZbr= MAX_POCET_HL_ZBR-1;
	}

	while ( !ktereHlZbrane[vybranaHlZbr] ) vybranaHlZbr++;
	hlZbran.init( ptkrh->typyLodi[typTypuObj].typyHlavZbr[vybranaHlZbr], typObj,
		TYPZBRANE_HLAVNI,
		ptkrh->typyLodi[typTypuObj].poziceHlZbr.x,
		ptkrh->typyLodi[typTypuObj].poziceHlZbr.y
	);
	for (int i=0; i<MAX_POCET_BOC_ZBR; i++) if (ktereBocZbrane[i])
		bocZbran[i].init( ptkrh->typyLodi[typTypuObj].typyBocZbr[i], typObj,
			TYPZBRANE_BOCNI,
			ptkrh->typyLodi[typTypuObj].poziceBocZbr.x,
			ptkrh->typyLodi[typTypuObj].poziceBocZbr.y
		);
	krObj.init( ptkrh->typyLodi[typTypuObj].cisloTypuKrObj, typObj);
	krObjStit.init( ptkrh->typyLodi[typTypuObj].cisloTypuKrObjStitu, typObj);
	budeKonec=0;

	return 1;
}

void CLod::init(int cisloTypuLode, int cHrace)
{
	int i;
	typTypuObj= cisloTypuLode;	// index do ptkrh->typyLodi[]
	maxArmour= ptkrh->typyLodi[typTypuObj].maxArmour;
	maxShield= ptkrh->typyLodi[typTypuObj].maxShield;
	cisloHrace= cHrace;
	for (i=0; i<MAX_POCET_HL_ZBR; i++) ktereHlZbrane[i]= 0;
	for (i=0; i<MAX_POCET_BOC_ZBR; i++) ktereHlZbrane[i]= 0;
	for (i=0; i<MAX_POCET_VYBAVENI; i++) ktereHlZbrane[i]= 0;
	vybranaHlZbr= 0;
	ktereHlZbrane[0]= 1;
	//ktereHlZbrane[1]= 1;
	ktereBocZbrane[0]= 1;
	//ktereBocZbrane[1]= 1;
	specialniVybaveni[0]= 0;
}

//stitySviti je kolik kol este budou svitit
//chci aby zhasli po 1s => po 100 kolech
//ctvrtinovej zasah je rozsviti na 1s, tedy na 100 kol
#define KDYSTIYZHASNOU	100.		// to se pouziva este u kresleni
#define STITYPOCTVRTINE	4
void CLod::zasahJsemTe(double kolik)
{// rekne mu, aby si ubral zivoty, popripade se znici
	if ( budeKonec || ptkrh->hraci[0].godMode ) return;
	// !!!tohle je jediny misto, kde se pouziva obtiznost!!!
	if ( ptkrh->hraci[0].obtiznost==1 ) kolik*=2;
	shield-= kolik;
	if ( shield<0 ) {
		armour+= shield;
		stitySviti+= (int)(KDYSTIYZHASNOU*(shield+kolik)*STITYPOCTVRTINE/maxShield);
		shield= 0;
		if ( armour<=0 ) {
			budeKonec=200;
		}
	} else stitySviti+=(int)(KDYSTIYZHASNOU*kolik*STITYPOCTVRTINE/maxShield);
}

double CLod::zasahnulJsi()
{// vrati, kolik ubira zivotu
	return ptkrh->typyLodi[typTypuObj].nicivaSila;
}

void CLod::UpdateObjLogic(Uint8 *keys)
{
	if (ptkrh->pauza) return;

	int i;

	// kdyz uz sem umrel, tak cekam na stmaveni obrazovky
	if ( budeKonec ) {
		budeKonec--;
		if ( budeKonec==100 ) ptkrh->Ztmav();
		if ( budeKonec==5 )	{	// jinak se to este rozsviti
			ptkrh->level->konecHry= 2;	// hrac prohral
		}

		ptkrh->level->vybuchy->pridej(
						pol.x+(myRand()*2-1)*ptkrh->typyLodi[typTypuObj].w,
						pol.y+(myRand()*2-1)*ptkrh->typyLodi[typTypuObj].h, 1, 50);
		ptkrh->level->vybuchy->pridej(
						pol.x+(myRand()*2-1)*ptkrh->typyLodi[typTypuObj].w,
						pol.y+(myRand()*2-1)*ptkrh->typyLodi[typTypuObj].h, 1, 50);
		//return;
	}
	
	// pohyb:
	int zrychX=0, zrychY=0;
	if ( keys[SDLK_UP   ]) zrychY+=1;
	if ( keys[SDLK_DOWN ]) zrychY-=1;
	if ( keys[SDLK_LEFT ]) zrychX-=1;
	if ( keys[SDLK_RIGHT]) zrychX+=1;
	//rychlost
	double mR= ptkrh->typyLodi[typTypuObj].maxRych;
	double mRd3= mR/50;
	if ( !zrychX ) {
		if ( fabs(rychlost.x) < mRd3/2 ) rychlost.x= 0;
		else if ( rychlost.x > 0 ) rychlost.x-= mRd3;
		else rychlost.x+= mRd3;
	} else rychlost.x+= ptkrh->typyLodi[typTypuObj].zrych*zrychX;
	if ( !zrychY ) {
		if ( fabs(rychlost.y) < mRd3/2 ) rychlost.y= 0;
		else if ( rychlost.y > 0 ) rychlost.y-= mRd3;
		else rychlost.y+= mRd3;
	} else rychlost.y+= ptkrh->typyLodi[typTypuObj].zrych*zrychY;
	if ( rychlost.x >  mR ) rychlost.x=  mR;
	if ( rychlost.x < -mR ) rychlost.x= -mR;
	if ( rychlost.y >  mR ) rychlost.y=  mR;
	if ( rychlost.y < -mR ) rychlost.y= -mR;
	// poloha
	pol.x+=rychlost.x;
	pol.y+=rychlost.y;
	// vylet z obrazovky
	double vW=ptkrh->typyLodi[typTypuObj].w, vH=ptkrh->typyLodi[typTypuObj].h;
	if ( pol.x+vW >  SCREEN_X ) pol.x=  SCREEN_X-vW;	// vpravo
	if ( pol.x-vW < -SCREEN_X ) pol.x= -SCREEN_X+vW;	// vlevo
	if ( pol.y+vH >  SCREEN_Y ) pol.y=  SCREEN_Y-vH;	// nahore
	if ( pol.y-vH < -SCREEN_Y ) pol.y= -SCREEN_Y+vH;	// dole

	// srazky se kontrolujou v CLevel!!!

	// vymena zbrani:
	if ( keys[SDLK_LSHIFT] ) {
		keys[SDLK_LSHIFT]=0;
		do {
			vybranaHlZbr= (vybranaHlZbr+1) % MAX_POCET_HL_ZBR;
		} while ( ktereHlZbrane[vybranaHlZbr]==0 );
		hlZbran.init( ptkrh->typyLodi[typTypuObj].typyHlavZbr[vybranaHlZbr], typObj,
			TYPZBRANE_HLAVNI,
			ptkrh->typyLodi[typTypuObj].poziceHlZbr.x,
			ptkrh->typyLodi[typTypuObj].poziceHlZbr.y
		);
	}

	// strileni
	hlZbran.zevluj();
	for (i=0; i<MAX_POCET_BOC_ZBR; i++) if (ktereBocZbrane[i]) bocZbran[i].zevluj();
	if ( keys[SDLK_LCTRL] ) {
		hlZbran.strilej(pol);
		for (i=0; i<MAX_POCET_BOC_ZBR; i++) if (ktereBocZbrane[i]) bocZbran[i].strilej(pol);
	}

	// pauzovani
	if (keys[SDLK_ESCAPE] || keys[SDLK_p] || keys[SDLK_PAUSE]) {	// to samy jako v ^ case 1:...
		keys[SDLK_ESCAPE]= keys[SDLK_p]= keys[SDLK_PAUSE]=0;
		CPauseNabidka *ppn = new CPauseNabidka;
		if ( !ppn ) fprintf(stderr,"nepodarilo se naalokovat pamet pro CPauseNabidka\n");
		else if ( !pgame->RegisterObject(ppn,1) ) fprintf(stderr, "chyba inicializace CPauseNabidka\n");
		return;
	}

	// stity
	if ( stitySviti ) stitySviti--;	// ztmavovani stitu
	// dobejvani stitu
	int pom= hlZbran.KDR;
	for (i=0; i<MAX_POCET_BOC_ZBR; i++) if (ktereBocZbrane[i]) pom+= bocZbran[i].KDR;
	if ( !pom )
		shield+= maxShield/1000;
	else shield+= maxShield/3000;
	if ( shield > maxShield ) shield= maxShield;

	// update kresleni
	krObj.UpdateLogic();
	krObjStit.UpdateLogic();
}

void CLod::UpdateObjDisplay()
{
	krObj.UpdateDisplay(pol);
	if ( stitySviti ) krObjStit.UpdateDisplay(pol, (double)(stitySviti)/KDYSTIYZHASNOU);
	//stitySviti je kolik kol este budou svitit
	//chci aby zhasli po 1s => po 100 kolech
	//ctvrtinovej zasah je rozsviti na 1s, tedy na 100 kol

	// nakreslim ten zbytek (stav stitu, zivotu, bodu, vybrana zbran, ...),
	// (to sem zatim jenom skopnul z minuly verze)
	#define TXTSCRX	5.5f
	#define TXTSCRY	4.f
	// shield vlevo
	glColor3f(1,1,1);
	glBlendFunc(GL_ONE, GL_ONE);					// Copy Image 2 Color To The Screen
	glBindTexture(GL_TEXTURE_2D, ptkrh->typyKrObj[0].textury[0].tura);
	glBegin(GL_QUADS);												// Start Drawing A Textured Quad
		glTexCoord2f(0, 0); glVertex3f(-TXTSCRX+0.5*VEL_ZNAKUX, -TXTSCRY, -10);	// Bottom Left
		glTexCoord2f(1, 0); glVertex3f(-TXTSCRX+2*VEL_ZNAKUX, -TXTSCRY, -10);	// Bottom Right
		glTexCoord2f(1, 1*(float)shield);
							glVertex3f(-TXTSCRX+2*VEL_ZNAKUX, -TXTSCRY+TXTSCRY*2*(float)shield/(float)maxShield, -10);	// Top Right
		glTexCoord2f(0, 1*(float)shield);
							glVertex3f(-TXTSCRX+0.5*VEL_ZNAKUX, -TXTSCRY+TXTSCRY*2*(float)shield/(float)maxShield, -10);	// Top Left
	glEnd();														// Done Drawing The Quad
	// armour vpravo
	glBegin(GL_QUADS);												// Start Drawing A Textured Quad
		glTexCoord2f(0, 0); glVertex3f(TXTSCRX-2*VEL_ZNAKUX, -TXTSCRY, -10);	// Bottom Left
		glTexCoord2f(1, 0); glVertex3f(TXTSCRX-0.5*VEL_ZNAKUX, -TXTSCRY, -10);	// Bottom Right
		glTexCoord2f(1, 1.f*(float)armour);
							glVertex3f(TXTSCRX-0.5*VEL_ZNAKUX, -TXTSCRY+TXTSCRY*2*(float)armour/(float)maxArmour, -10);	// Top Right
		glTexCoord2f(0, 1.f*(float)armour);
							glVertex3f(TXTSCRX-2*VEL_ZNAKUX, -TXTSCRY+TXTSCRY*2*(float)armour/(float)maxArmour, -10);	// Top Left
	glEnd();														// Done Drawing The Quad
	// spodni informacni lista
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_DEPTH_TEST);
	glColor3f(.4f,.2f,.0f);
	//glBlendFunc(GL_DST_COLOR,GL_ZERO);				//*** Blend Screen Color With Zero (Black)
	glBegin(GL_QUADS);												// Start Drawing A Textured Quad
		glVertex3f(-TXTSCRX+3*VEL_ZNAKUX,-TXTSCRY-(float)VEL_ZNAKUY, -10);	// Bottom Left
		glVertex3f( TXTSCRX-3*VEL_ZNAKUX,-TXTSCRY-(float)VEL_ZNAKUY, -10);	// Bottom Right
		glVertex3f( TXTSCRX-3.f*VEL_ZNAKUX,-TXTSCRY+(float)VEL_ZNAKUY, -10);	// Top Right
		glVertex3f(-TXTSCRX+3.f*VEL_ZNAKUX,-TXTSCRY+(float)VEL_ZNAKUY, -10);	// Top Left
	glEnd();														// Done Drawing The Quad
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_TEXTURE_2D);
	glColor3f(1,1,1);
	// penize ve prostred
	int penize= ptkrh->hraci[0].penize;
	pogl->glPrint(-(3+(int)log10(penize))*VEL_ZNAKUX/2,-TXTSCRY+0*VEL_ZNAKUY,
			"$ %d", penize);
	// stit vlevo
	pogl->glPrint(-TXTSCRX+3*VEL_ZNAKUX,-TXTSCRY+0*VEL_ZNAKUY,
			"%d/%d", (int)shield, (int)maxShield);
	// armour vpravo
	pogl->glPrint(TXTSCRX-(6+(int)log10((armour<=0)?1:armour)+(int)log10(maxArmour))*VEL_ZNAKUX,-TXTSCRY+0*VEL_ZNAKUY,
			"%d/%d", (int)armour, (int)maxArmour);
	// vybrana hlavni zbran vpravo veprostred
	pogl->glPrint(TXTSCRX-20*VEL_ZNAKUX,-TXTSCRY+0*VEL_ZNAKUY,
			"zbran: %d", vybranaHlZbr+1);

	if ( DEBUG_CTVERCE_KOLEM_LODI ) {
	//udela se ctverec podle rozmeru lodi
	//	pol.x; pol.y; pol.z;
	//	ptkrh->typyLodi[typTypuObj].w;
	//	ptkrh->typyLodi[typTypuObj].h;

		glDisable(GL_TEXTURE_2D);
		//glPolygonMode( GL_BACK, GL_FILL );			// Back Face Is Filled In
		glPolygonMode( GL_FRONT, GL_LINE );
		glBegin(GL_QUADS);												// Start Drawing A Textured Quad
			glVertex3f( pol.x-ptkrh->typyLodi[typTypuObj].w, pol.y-ptkrh->typyLodi[typTypuObj].h, pol.z);	// Bottom Left
			glVertex3f( pol.x+ptkrh->typyLodi[typTypuObj].w, pol.y-ptkrh->typyLodi[typTypuObj].h, pol.z);	// Bottom Right
			glVertex3f( pol.x+ptkrh->typyLodi[typTypuObj].w, pol.y+ptkrh->typyLodi[typTypuObj].h, pol.z);	// Top Right
			glVertex3f( pol.x-ptkrh->typyLodi[typTypuObj].w, pol.y+ptkrh->typyLodi[typTypuObj].h, pol.z);	// Top Left
		glEnd();														// Done Drawing The Quad
		glPolygonMode( GL_FRONT, GL_FILL );
		glEnable(GL_TEXTURE_2D);
	}

}
