// Lod.h: interface for the CLod class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LOD_H__7F557A2A_84CD_11D8_83E4_008048208521__INCLUDED_)
#define AFX_LOD_H__7F557A2A_84CD_11D8_83E4_008048208521__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "BaseObject.h"
#include "KrObj.h"
#include "Zbran.h"

// tohle samy je i u CTypLod!
#define MAX_POCET_HL_ZBR	4
#define MAX_POCET_BOC_ZBR	3
#define MAX_POCET_VYBAVENI	1

// hrac bude mit instance od svejch lodi
// kdyz se zacne hra, tak se zaregistruje, kdyz se zkonci, tak se odregistruje, ale nezrusi
// pred koncem hry se musi odregistrovat!
// nejdriv se musi nainicializovat (init), a az pak zaregistrovat (registerobj..)
class CLod : public CBaseObject
{
	// tohle vsechno by se melo zinicializovat pri InitObject
	TSour rychlost;	// polohu zdedil
	int stitySviti;	// pocet kol, jak dlouho este budou svitit; stmavovani se nak urci z maxShield
	CZbran hlZbran, bocZbran[MAX_POCET_BOC_ZBR];
	int vybranaHlZbr;//, vybranaBocZbr;	// ktera hlavni a bocni zbran je zrovna vybrana
			// protoze na zacatku ma urcite tu prvni, tak se vzdycky nainicializuje na tu prvni
	CKrObj krObj;	// (jako u CStrela)
	CKrObj krObjStit;

	int budeKonec;	// aby kdyz mi dojdou zivoty, tak hra hned neskoncila, ale pockalo se, az se stmavi

public:
	CLod();
	//virtual ~CLod();

	// tohle sem zdedil
	int InitObject();
	void UpdateObjLogic(Uint8 *keys);
	void UpdateObjDisplay();
	void zasahJsemTe(double kolik);	// rekne mu, aby si ubral zivoty, popripade se znici
	double zasahnulJsi();			// vrati, kolik ubira zivotu

	void init(int cisloTypuLode, int cHrace=0);		// index do pole typu lodi, cisloHrace,
	int cisloHrace;	// pokud budou hrat dva
	double shield, armour, maxShield, maxArmour;	// maxima se zvetsujou az do dvojnasobku z init hodnot
	int ktereHlZbrane[MAX_POCET_HL_ZBR], ktereBocZbrane[MAX_POCET_BOC_ZBR];
												// 1 pokud ji mam, 0 pokud ne
	int specialniVybaveni[MAX_POCET_VYBAVENI];	// to se nak dodela; pridavny stity, rychlost, nesmrtelnost, radar, ...
	//int penize;			// kdyz sem ve hre, tak si pocitam penize, a kdyz doletim na konec, tak se prictou k hracovym penezum
};

#endif // !defined(AFX_LOD_H__7F557A2A_84CD_11D8_83E4_008048208521__INCLUDED_)
