// Mapa.cpp: implementation of the CMapa class.
//
//////////////////////////////////////////////////////////////////////

#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <math.h>
#include "Mapa.h"
#include "Game.h"
#include "TridaKteraRidiHru.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

TMesto::TMesto()
{
	jeVytvoreny=0;
}

CMapa::CMapa() {}

void CMapa::init()
{
	kolikJeVygenMest=0;
	kdeSem= 0;
	vybranaCesta= 0;

	// na zacatku vytvorim jedno mesto
	//meno
	mGen(mesta[0].meno);
	//pocCest
	mesta[0].pocCest= rand()%(MAXPOCCEST-2)+2;	// 2..7
	kolikJeVygenMest++;
	//sousedi a cesty
	for (int i=0; i<mesta[0].pocCest; i++) {
		//lvl cesty i
		if ( i==0 ) mesta[0].sousedi[i].lvl= 0;
		else {
			mesta[0].sousedi[i].lvl= rand() % 2;
			if ( !(rand() % 4) ) mesta[0].sousedi[i].lvl= rand() % 3;
		}
		//sousedi
		mesta[0].sousedi[i].kam= kolikJeVygenMest;
		//meno souseda
		mGen(mesta[kolikJeVygenMest].meno);
		//pocCest souseda
		mesta[kolikJeVygenMest].pocCest= 1;
		// cesty souseda
		mesta[kolikJeVygenMest].sousedi[0].kam= kdeSem;
		mesta[kolikJeVygenMest].sousedi[0].lvl= mesta[0].sousedi[i].lvl;
		mesta[kolikJeVygenMest].x= myRand()*2-1;
		mesta[kolikJeVygenMest].y= myRand()*2-1;
		mesta[kolikJeVygenMest].jeVytvoreny=1;
		kolikJeVygenMest++;
	}
	mesta[0].x= 0;
	mesta[0].y= 0;
	mesta[0].jeVytvoreny= 2;
}

//CMapa::~CMapa() {}

void CMapa::prelet()
{
	int i, kdeSemByl= kdeSem, pom;
	kdeSem= mesta[kdeSem].sousedi[vybranaCesta].kam;
	// najdu, odkud (po ktery ceste) sem priletel
	int odkud=0;
	for (i=0; i<mesta[kdeSem].pocCest; i++)
		if ( mesta[kdeSem].sousedi[i].kam==kdeSemByl ) odkud=i;

	if ( !mesta[kdeSem].jeVytvoreny ) fprintf(stderr, "Dostal sem se do mesta (%d), ktery este neni vygenerovany\n", kdeSem);

	// pokud je potreba, tak dovytvorim mesto (jeho sousedy)
	if ( mesta[kdeSem].jeVytvoreny==1 ) {
		//radsi si spocitam, kolik je este nevytvorenejch mest:
		for (i=0, pom=0; i<MAXPOCMEST; i++) if (mesta[i].jeVytvoreny==1) pom++;
		//kolik bude z mesta vest cest
		if (pom==1) mesta[kdeSem].pocCest= rand()%(MAXPOCCEST-2)+2;	// 2..7
		else mesta[kdeSem].pocCest= rand()%(MAXPOCCEST-1)+1;	// 1..7
		if ( mesta[kdeSem].pocCest-1 + kolikJeVygenMest >= MAXPOCMEST ) mesta[kdeSem].pocCest= MAXPOCMEST-kolikJeVygenMest;
		//sousedi a cesty
		for (i=1; i<mesta[kdeSem].pocCest; i++) {
			//lvl cesty i
			mesta[kdeSem].sousedi[i].lvl= rand() % 3 - 1 + ptkrh->hraci[0].maxLevel;
			if ( !(rand() % 4) ) mesta[kdeSem].sousedi[i].lvl= rand() % 5 -2 + ptkrh->hraci[0].maxLevel;
			if ( mesta[kdeSem].sousedi[i].lvl < 0 ) mesta[kdeSem].sousedi[i].lvl= 0;
			if ( mesta[kdeSem].sousedi[i].lvl > 9 ) mesta[kdeSem].sousedi[i].lvl= 9;
			//sousedi
			mesta[kdeSem].sousedi[i].kam= kolikJeVygenMest;
			//meno souseda
			mGen(mesta[kolikJeVygenMest].meno);
			//pocCest souseda
			mesta[kolikJeVygenMest].pocCest= 1;
			// cesty souseda
			mesta[kolikJeVygenMest].sousedi[0].kam= kdeSem;
			mesta[kolikJeVygenMest].sousedi[0].lvl= mesta[kdeSem].sousedi[i].lvl;
			mesta[kolikJeVygenMest].x= myRand()*2-1+mesta[kdeSem].x;
			mesta[kolikJeVygenMest].y= myRand()*2-1+mesta[kdeSem].y;
			mesta[kolikJeVygenMest].jeVytvoreny=1;
			kolikJeVygenMest++;
		}
		mesta[kdeSem].jeVytvoreny= 2;
	}

	// zvolim nahodne jednu z dalsich cest
	if (mesta[kdeSem].pocCest==1) vybranaCesta=0;
	else vybranaCesta= ( odkud + rand()%(mesta[kdeSem].pocCest-1) + 1 ) % mesta[kdeSem].pocCest;
	
}

// generovani noveho slova
int CMapa::mGen(char *slovo)
{
	static char samohlasky[]="AEIOUY";
	static char souhlasky[]="BCDFGHJKLMNPQRSTVWXZ";
	int delka, zac, i;
	delka=rand()%4+3;
	zac=rand()%2;
	for(i=0; i<delka; i++) {
		if ( (i+zac)%2==0 ) slovo[i]= souhlasky[rand()%strlen(souhlasky)];
		else slovo[i]= samohlasky[rand()%strlen(samohlasky)];
		if ( i ) slovo[i]= tolower(slovo[i]);
	}
	slovo[i]=0;
	return 0;	
}

// spocte souradnice mest tak, aby byly zhruba 1 jednotky od sebe
// vsechny mesta se odpuzujou, cesty chtej bejt dlouhy 1
void CMapa::nakresliSeSpocti()
{
	// odpuzovani
	int i;
	double koef;
	for(i=0; i<kolikJeVygenMest-1; i++)
		for(int j=i+1; j<kolikJeVygenMest; j++) {
			double vzdX= mesta[j].x-mesta[i].x;
			double vzdY= mesta[j].y-mesta[i].y;
			double vzd= sqrt(vzdX*vzdX+vzdY*vzdY);
			if ( vzd<1 ) {
				if (vzd<0.2) { vzd= 0.5; mesta[j].y+=.1; }
				koef= (1/vzd -1)/50;
				mesta[i].x-= vzdX*koef; mesta[j].x+= vzdX*koef;
				mesta[i].y-= vzdY*koef; mesta[j].y+= vzdY*koef;
			}/* else if ( vzd>2 ) {
				koef= (vzd-2)/500;
				mesta[i].x+= vzdX*koef; mesta[j].x-= vzdX*koef;
				mesta[i].y+= vzdY*koef; mesta[j].y-= vzdY*koef;
			}*/
		}

	// 0. mesto dam doprostred
	for(i=kolikJeVygenMest-1; i>=0; i--) {
		mesta[i].x-=mesta[0].x; mesta[i].y-=mesta[0].y;
	}

}

// kreslim v hloubce -10, do ctverce o souradnicich [-4.5,-2], [-.5,2]
// stred: [-2.5,0]
void CMapa::nakresliSe(int vybMesto)
{
	#define CERVENA		1.f, .5f, .5f
	#define FIALOVA		0.60f,0.41f,0.8f
	#define FIALOVA2	0.65f,0.45f,0.85f
	#define SEDIVA		0.2f,0.2f,0.2f

	double stredX= -2.5-mesta[kdeSem].x, stredY= 0-mesta[kdeSem].y;
	int i;

	glDisable(GL_TEXTURE_2D);
	glDisable(GL_DEPTH_TEST);
	glPointSize(10);
	glLineWidth(3);
	glEnable(GL_POINT_SMOOTH);
	glEnable(GL_LINE_SMOOTH);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	// cesty
	for(i=0; i<kolikJeVygenMest; i++) if ( mesta[i].jeVytvoreny == 2 ) {
		glBegin(GL_LINES);
		for(int j=0; j<mesta[i].pocCest; j++)
			if ( i==kdeSem || mesta[i].sousedi[j].kam != kdeSem ) {
				if ( i==kdeSem && j==vybMesto ) glColor3f(CERVENA);
				else  glColor3f(FIALOVA);
				glVertex3f(mesta[i].x+stredX, mesta[i].y+stredY, -10);
				if ( mesta[ mesta[i].sousedi[j].kam ].jeVytvoreny == 1 ) glColor3f(SEDIVA);
				glVertex3f(mesta[ mesta[i].sousedi[j].kam ].x+stredX,
							mesta[ mesta[i].sousedi[j].kam ].y+stredY, -10);
		}
		glEnd();
	}
	//mesta
	for(i=0; i<kolikJeVygenMest; i++) {
		if ( mesta[i].jeVytvoreny==1 ) glColor3f(SEDIVA);
		else if ( i == kdeSem || (vybMesto<mesta[kdeSem].pocCest && i == mesta[kdeSem].sousedi[vybMesto].kam) ) glColor3f(CERVENA);
		else glColor3f(FIALOVA2);
		glBegin(GL_POINTS);
			glVertex3f(mesta[i].x+stredX, mesta[i].y+stredY, -10);
		glEnd();
		glEnable(GL_TEXTURE_2D);
		if ( vybMesto<mesta[kdeSem].pocCest && i==mesta[kdeSem].sousedi[vybMesto].kam )
			pogl->glPrintEx(mesta[i].x+stredX, mesta[i].y+stredY, CERVENA, 1, "%s", mesta[i].meno);
		else if ( mesta[i].jeVytvoreny==2 ) pogl->glPrintEx(mesta[i].x+stredX, mesta[i].y+stredY, 1,1,1, 1, "%s", mesta[i].meno);
		glDisable(GL_TEXTURE_2D);
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	}
	glColor3f(1.f, 1.f, 1.f);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_TEXTURE_2D);
	glLineWidth(1);

	/*//////
	glColor3f(1,1,1);
	//glEnable(GL_POINT_SMOOTH);
	glDisable(GL_TEXTURE_2D);
	glPointSize(10);
	glBegin(GL_POINTS);
		glVertex3f(-2.5, 0, -10);
	glEnd();
	glEnable(GL_TEXTURE_2D);
	///////*/
}

int CMapa::lvlVybCesty()
{
	return mesta[kdeSem].sousedi[vybranaCesta].lvl;
}
