// Nelod.cpp: implementation of the CNelod class.
//
//////////////////////////////////////////////////////////////////////

#include <math.h>
#include "Nelod.h"
#include "Game.h"
#include "TridaKteraRidiHru.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CNelod::CNelod()
{
	znicit=0;
	pol.z=-30;
	typObj=TYPOBJ_NELOD;
}

CNelod::~CNelod() {}

int CNelod::InitObject() { return 1; }

void CNelod::init(int _cTypuNelode)
{
	typTypuObj= _cTypuNelode;	// index do ptkrh->typyNelodi[]
	armour= ptkrh->typyNelodi[typTypuObj].maxArmour;

	pol.x= ptkrh->typyNelodi[typTypuObj].vstupniBod*SCREEN_X
		+ ptkrh->typyNelodi[typTypuObj].nahVstupBod*(double)(rand()%2000-1000)/1000.*SCREEN_X;
	if ( pol.x + ptkrh->typyNelodi[typTypuObj].w > SCREEN_X ) pol.x= SCREEN_X-ptkrh->typyNelodi[typTypuObj].w;
	if ( pol.x - ptkrh->typyNelodi[typTypuObj].w <-SCREEN_X ) pol.x=-SCREEN_X+ptkrh->typyNelodi[typTypuObj].w;
	pol.y= SCREEN_Y + ptkrh->typyKrObj[ ptkrh->typyNelodi[typTypuObj].cisloTypuKrObj ].h;

	rychlost= ptkrh->typyNelodi[typTypuObj].pocRych;
	zbran.init( ptkrh->typyNelodi[typTypuObj].typZbrane, typObj,
		TYPZBRANE_HLAVNI,
		ptkrh->typyNelodi[typTypuObj].poziceZbrane.x,
		-ptkrh->typyNelodi[typTypuObj].poziceZbrane.y
	);
	krObj.init(ptkrh->typyNelodi[typTypuObj].cisloTypuKrObj, typObj);
	jakDlouhoLeti= 0;
}

void CNelod::zasahJsemTe(double kolik)
{// rekne mu, aby si ubral zivoty, popripade se znici
	armour-= kolik;
	if ( armour <=0 ) {
		znicit=1;
		ptkrh->hraci[0].penize+= ptkrh->typyNelodi[typTypuObj].body;
	}
}

double CNelod::zasahnulJsi()
{// vrati, kolik ubira zivotu
	return ptkrh->typyNelodi[typTypuObj].nicivaSila;
}

void CNelod::UpdateObjLogic(Uint8 *keys)
{
	if (ptkrh->pauza) return;

	// pohyb:
	double zrychX, zrychY;
	switch ( pohybovaFce( ptkrh->typyNelodi[typTypuObj].pohybovaFce ) ) {
	// 0..nic, 1..^; 2..^>; 3..>; 4..v>; 5..v; 6..<v; 7..<; 8..<^
	case 0: zrychX= 0; zrychY= 0; break;
	case 1: zrychX= 0; zrychY= 1; break;
	case 2: zrychX= 1; zrychY= 1; break;
	case 3: zrychX= 1; zrychY= 0; break;
	case 4: zrychX= 1; zrychY=-1; break;
	case 5: zrychX= 0; zrychY=-1; break;
	case 6: zrychX=-1; zrychY=-1; break;
	case 7: zrychX=-1; zrychY= 0; break;
	case 8: zrychX=-1; zrychY= 1; break;
	}
	double mR= ptkrh->typyNelodi[typTypuObj].maxRych;
	double mRd3= mR/50;
	//rychlost - takhle to je u Lode
	if ( !zrychX ) {
		if ( fabs(rychlost.x) < mRd3/2 ) rychlost.x= 0;
		else if ( rychlost.x > 0 ) rychlost.x-= mRd3;
		else rychlost.x+= mRd3;
	} else rychlost.x+= ptkrh->typyNelodi[typTypuObj].zrych*zrychX;
	/*/if ( !zrychY ) {
		if ( fabs(rychlost.y) < mRd3/2 ) rychlost.y= 0;
		else if ( rychlost.y > 0 ) rychlost.y-= mRd3;
		else rychlost.y+= mRd3;
	} else rychlost.y+= ptkrh->typyNelodi[typTypuObj].zrych*zrychY;/**/
	//rychlost - takhle to bylo tady (Nelod)
	/*/rychlost.x= (rychlost.x + zrychX*ptkrh->typyNelodi[typTypuObj].zrych)*1;/**/
	rychlost.y= (rychlost.y + zrychY*ptkrh->typyNelodi[typTypuObj].zrych)*1;
	if ( rychlost.x >  mR ) rychlost.x=  mR;
	if ( rychlost.x < -mR ) rychlost.x= -mR;
	if ( rychlost.y >  mR ) rychlost.y=  mR;
	if ( rychlost.y < -mR ) rychlost.y= -mR;
	// poloha
	pol.x+=rychlost.x;
	pol.y+=rychlost.y;
	// vylet z obrazovky
	double vW=ptkrh->typyNelodi[typTypuObj].w;
	if ( pol.x+vW >  SCREEN_X ) pol.x=  SCREEN_X-vW;	// vpravo
	if ( pol.x-vW < -SCREEN_X ) pol.x= -SCREEN_X+vW;	// vlevo
	// vylet z obrazovky
	int cTKrObj= ptkrh->typyNelodi[typTypuObj].cisloTypuKrObj;	// index do typyKrObj
	if (   pol.x+ptkrh->typyKrObj[cTKrObj].w < -SCREEN_X	// vylit vlevo
		|| pol.x-ptkrh->typyKrObj[cTKrObj].w > SCREEN_X		// vylit vpravo
		|| pol.y+ptkrh->typyKrObj[cTKrObj].h < -SCREEN_Y	// vylit dole
		|| pol.y-ptkrh->typyKrObj[cTKrObj].h > SCREEN_Y		// vylit nahore
		) { znicit= 1; return; }

	// srazky se kontrolujou v CLevel!!!

	// strileni
	zbran.zevluj();
	if ( strileciFce(ptkrh->typyNelodi[typTypuObj].strileciFce ) ) {
		zbran.strilej(pol);
	}

	krObj.UpdateLogic();
	jakDlouhoLeti++;
}

void CNelod::UpdateObjDisplay()
{
	krObj.UpdateDisplay(pol);

	if ( DEBUG_CTVERCE_KOLEM_LODI ) {
	//udela se ctverec podle rozmeru lodi
	//	pol.x; pol.y; pol.z;
	//	ptkrh->typyNeodi[typTypuObj].w;
	//	ptkrh->typyNeodi[typTypuObj].h;

		glDisable(GL_TEXTURE_2D);
		//glPolygonMode( GL_BACK, GL_FILL );			// Back Face Is Filled In
		glPolygonMode( GL_FRONT, GL_LINE );
		glBegin(GL_QUADS);												// Start Drawing A Textured Quad
			glVertex3f( pol.x-ptkrh->typyNelodi[typTypuObj].w, pol.y-ptkrh->typyNelodi[typTypuObj].h, pol.z);	// Bottom Left
			glVertex3f( pol.x+ptkrh->typyNelodi[typTypuObj].w, pol.y-ptkrh->typyNelodi[typTypuObj].h, pol.z);	// Bottom Right
			glVertex3f( pol.x+ptkrh->typyNelodi[typTypuObj].w, pol.y+ptkrh->typyNelodi[typTypuObj].h, pol.z);	// Top Right
			glVertex3f( pol.x-ptkrh->typyNelodi[typTypuObj].w, pol.y+ptkrh->typyNelodi[typTypuObj].h, pol.z);	// Top Left
		glEnd();														// Done Drawing The Quad
		glPolygonMode( GL_FRONT, GL_FILL );
		glEnable(GL_TEXTURE_2D);
	}

}

int CNelod::pohybovaFce(int cisloFce)
{	// 0..nic, 1..^; 2..^>; 3..>; 4..v>; 5..v; 6..<v; 7..<; 8..<^
	switch ( cisloFce ) {
	case 0: return 0; break;
	case 1:	// leti rovne, doprava, rovne
		if (jakDlouhoLeti>100)
			if ( (jakDlouhoLeti-100) < 150 ) return 3;
		break;
	case 2:	// leti rovne, doleva, rovne
		if (jakDlouhoLeti>100)
			if ( (jakDlouhoLeti-100) < 150 ) return 7;
		break;
	case 3:	// stridave lita doleva a doprava
		if (jakDlouhoLeti>100)
			if ( (jakDlouhoLeti-100)%200 < 50 ) return 3;
			if ( (jakDlouhoLeti-100)%200 > 100 &&
				 (jakDlouhoLeti-100)%200 < 150 ) return 7;
		break;
	}
	return 0;
}
int CNelod::strileciFce(int cisloFce)
{	// 1..strilet, 0..ne
	int i;
	switch ( cisloFce ) {
	case 0: return 1; break;
	case 1: if ( !(rand()%50) ) return 1; break;
	case 2:// strili, jenom kdyz pred nim nekdo je
		for(i=0; i<POCETOBJ-1; i++) if ( pgame->objekty[i] ) {
			if ( SOU_PROTI_SOBE(typObj, pgame->objekty[i]->typObj) ) {
				CBaseObject *objI;
				double Ix, Iy, Iw, Ih, Ijepaprsek;
				objI= pgame->objekty[i];
				Ix= objI->pol.x;
				Iy= objI->pol.y;
				switch ( objI->typObj ) {
				case TYPOBJ_LOD:
					Iw= ptkrh->typyLodi[ objI->typTypuObj ].w;
					Ih= ptkrh->typyLodi[ objI->typTypuObj ].h;
					Ijepaprsek= 0;
					break;
				case TYPOBJ_NELOD:
					Iw= ptkrh->typyNelodi[ objI->typTypuObj ].w;
					Ih= ptkrh->typyNelodi[ objI->typTypuObj ].h;
					Ijepaprsek= 0;
					break;
				case TYPOBJ_STRELA: case TYPOBJ_NESTRELA:
					Iw= ptkrh->typyZbrane[ objI->typTypuObj ].w;
					Ih= ptkrh->typyZbrane[ objI->typTypuObj ].h;
					Ijepaprsek= NEDA_SE_ZASAHNOUT(objI->typTypuObj);
					break;
				case TYPOBJ_FORMACE: case TYPOBJ_LEVEL: case TYPOBJ_NABIDKA:
				case TYPOBJ_TKRH: case TYPOBJ_JINA: break;
				}

				if ( pol.x+ptkrh->typyZbrane[typTypuObj].w > Ix-Iw && pol.x-ptkrh->typyZbrane[typTypuObj].w < Ix+Iw &&
					pol.y > Iy-Ih && !Ijepaprsek ) return 1;
		}	}

		break;
	}

	return 0;
}
