// Sound.cpp: implementation of the CSound class.
//
//////////////////////////////////////////////////////////////////////

#include "Game.h"
#include "Sound.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CSound::CSound()
{
	music= NULL;
	vybuch = NULL;
	strela = NULL;
	phaserChannel = -1;

	podarilaSeInicializace= 0;
	musicVolume= 5;
	soundVolume= 5;
}

CSound::~CSound() {}

int CSound::Init()
{
	// prectu inicializacni nastaveni z configuracniho souboru
	FILE *File=NULL;
	char s[1000]; int c;
	File=fopen("configure.txt","r");
	if (File) {
		while (fscanf(File,"%s",s)!=EOF) {
			if (strcmp(s,"sound")==0) fscanf(File," %d",&soundVolume);
			else if (strcmp(s,"music")==0) fscanf(File," %d",&musicVolume);
			else if (s[0]=='/' && s[1]=='/') while (getc(File)!='\n');
			else while ( (c=getc(File))!='\n' && c!=0 );
		}
		fclose(File);
	}

	// nastaveni music a sound; tutorial je na: http://www.kekkai.org/roger/sdl/mixer/
	if(Mix_OpenAudio(
			22050,		// audio_rate
			AUDIO_S16,	// audio_format-16-bit stereo
			2,			// audio_channels
			4096		// audio_buffers
		)) {
		fprintf(stderr, "Unable to open audio!\n");
		return 1;	// vratim 1, abych si moh zahrat i bez hudby ???
	}
	podarilaSeInicializace= 1;

	music= Mix_LoadMUS("./data/music/menu.wav");	// nactu
//	vybuch= Mix_LoadWAV("./data/music/phaser.wav");
//	strela= Mix_LoadWAV("./data/music/strela1.wav");

	NastavMusicVolume(musicVolume);
	NastavSoundVolume(soundVolume);

	return 1;
}

void CSound::NastavMusicVolume(int kolik)
{
	if (kolik<0) kolik=0;
	if (kolik>10) kolik=10;
	musicVolume= kolik;
	if( !podarilaSeInicializace ) return;
	if( musicVolume==0 ) {
		Mix_HaltMusic();
		Mix_FreeMusic(music);
		music = NULL;
	} else {
		if ( !music ) {
			music= Mix_LoadMUS("./data/music/menu.wav");
			Mix_PlayMusic(music, -1);
		}
		Mix_VolumeMusic(MIX_MAX_VOLUME*musicVolume/10);
	}
}

void CSound::NastavSoundVolume(int kolik)
{
	if (kolik<0) kolik=0;
	if (kolik>10) kolik=10;
	soundVolume= kolik;
	if( !podarilaSeInicializace ) return;
	if( soundVolume==0 ) Mix_HaltChannel(-1);
	else Mix_Volume(-1,MIX_MAX_VOLUME*soundVolume/10);
}

void CSound::SemVMenu()
{
	Mix_HaltMusic();				// zastavi hrani
	Mix_HaltChannel(-1);
	if ( music ) Mix_FreeMusic(music);		// uvolni pamet
	music= Mix_LoadMUS("./data/music/menu.wav");	// nactu
	Mix_PlayMusic(music, -1);			// pustim
}

void CSound::SemVeHre()
{
	Mix_HaltMusic();				// zastavi hrani
	Mix_HaltChannel(-1);
	if ( music ) Mix_FreeMusic(music);		// uvolni pamet
	music= Mix_LoadMUS("./data/music/menu.wav");	// nactu
	Mix_PlayMusic(music, -1);			// pustim
}

void CSound::Vybuch()
{
	phaserChannel = Mix_PlayChannel( -1, vybuch, 0);
}

void CSound::Strelba()
{
	phaserChannel = Mix_PlayChannel( -1, strela, 0);
}

	/*/////////////
	//music:
	Mix_VolumeMusic(MIX_MAX_VOLUME);
	Mix_Music *music= NULL;
	music= Mix_LoadMUS("./data/music/menu.wav");	// nactu
	Mix_PlayMusic(music, 0);			// pustim jednou
	//Mix_HookMusicFinished(musicDone);	// tim nastavim fci, ktera se zavola po zkonceni hrani
		void musicDone() {
			Mix_HaltMusic();			// zastavi hrani
			Mix_FreeMusic(music);		// uvolni pamet
			music = NULL;
		}
	//sound:
	Mix_Volume(-1,MIX_MAX_VOLUME/2);
	Mix_Chunk *sound = NULL;
	sound= Mix_LoadWAV("./data/music/phaser.wav");	// nactu
	int phaserChannel = -1;
	phaserChannel = Mix_PlayChannel(
			-1,		// pokud je jedno, v jakym bude kanalu
			sound,	// co ma hrat
			-1		// kolikrat
	);
	SDL_Delay(1000);
	Mix_HaltChannel(phaserChannel);		// vypnu pozadovany kanal, pokud je kanal -1, tak vypne vsechny
	/*/////////////

