// Strela.cpp: implementation of the CStrela class.
//
//////////////////////////////////////////////////////////////////////

#include <math.h>
#include "Strela.h"
#include "Lod.h"
#include "Nelod.h"
#include "Game.h"
#include "TridaKteraRidiHru.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CStrela::CStrela()
{
	znicit=0;
	pol.z=-30;
	typObj=TYPOBJ_STRELA;
}

CStrela::~CStrela() {}

int CStrela::InitObject() { return 1; }

void CStrela::Init(int typ, TYPOBJ typPratel, TSour poloha, int _levaBocni)
{
	int i;

	typTypuObj= typ;	// index do ptkrh->typyZbrane[]
	switch ( typPratel ) {
	case TYPOBJ_LOD: case TYPOBJ_STRELA: typObj= TYPOBJ_STRELA; break;
	case TYPOBJ_NELOD: case TYPOBJ_NESTRELA: typObj= TYPOBJ_NESTRELA; break;
	}
	pol= poloha;
	armour= ptkrh->typyZbrane[typTypuObj].maxArmour;
	rychlost= ptkrh->typyZbrane[typTypuObj].pocRych;
	if ( typObj==TYPOBJ_NESTRELA ) rychlost.y*= -1;
	levaBocni= _levaBocni;
	rychlost.x*= levaBocni;

	double minZivotu = 10000000000.0;
	switch (ptkrh->typyZbrane[typTypuObj].typStrely) {
	case TYPSTRELY_KYNETICKAxNORM:
		krObj.init( ptkrh->typyZbrane[typTypuObj].cisloTypuKrObj, typObj);
		break;
	case TYPSTRELY_KYNETICKAxNAVADENA:
		krObj.init( ptkrh->typyZbrane[typTypuObj].cisloTypuKrObj, typObj);
		if ( typObj==TYPOBJ_NESTRELA ) {
			double vel, nx, ny, vzdalenost;
			vel= sqrt(rychlost.x*rychlost.x+rychlost.y*rychlost.y);
			nx= ptkrh->hraci[0].lode[ ptkrh->hraci[0].vybranaLod ].pol.x;
			ny= ptkrh->hraci[0].lode[ ptkrh->hraci[0].vybranaLod ].pol.y;
			vzdalenost= sqrt( (pol.x-nx)*(pol.x-nx) + (pol.y-ny)*(pol.y-ny) );
			if ( vzdalenost != 0 ) {
				rychlost.x= (nx-pol.x)/vzdalenost*vel;
				rychlost.y= (ny-pol.y)/vzdalenost*vel;
			} else {
				rychlost.x=0;
				rychlost.y=0;
			}
		}
		break;
	case TYPSTRELY_PAPRSEKxNORM:
		// tady zjistim, kam az bude paprsek strilet (jestli se o nekoho zastavi)
		paprsekCitac=1;
		paprsekX= pol.x;
		paprsekY= pol.y;
		pol.y= ((typObj==TYPOBJ_STRELA)?1:-1) *SCREEN_Y;
		for(i=0; i<POCETOBJ-1; i++) if ( pgame->objekty[i] ) {
			if ( SOU_PROTI_SOBE(typObj, pgame->objekty[i]->typObj) ) {
				CBaseObject *objI;
				double Ix, Iy, Iw, Ih, Ijepaprsek;
				objI= pgame->objekty[i];
				Ix= objI->pol.x;
				Iy= objI->pol.y;
				switch ( objI->typObj ) {
				case TYPOBJ_LOD:
					Iw= ptkrh->typyLodi[ objI->typTypuObj ].w;
					Ih= ptkrh->typyLodi[ objI->typTypuObj ].h;
					Ijepaprsek= 0;
					break;
				case TYPOBJ_NELOD:
					Iw= ptkrh->typyNelodi[ objI->typTypuObj ].w;
					Ih= ptkrh->typyNelodi[ objI->typTypuObj ].h;
					Ijepaprsek= 0;
					break;
				case TYPOBJ_STRELA: case TYPOBJ_NESTRELA:
					Iw= ptkrh->typyZbrane[ objI->typTypuObj ].w;
					Ih= ptkrh->typyZbrane[ objI->typTypuObj ].h;
					Ijepaprsek= NEDA_SE_ZASAHNOUT(objI->typTypuObj);
					break;
				case TYPOBJ_FORMACE: case TYPOBJ_LEVEL: case TYPOBJ_NABIDKA:
				case TYPOBJ_TKRH: case TYPOBJ_JINA: break;
				}

				if ( pol.x+ptkrh->typyZbrane[typTypuObj].w > Ix-Iw && pol.x-ptkrh->typyZbrane[typTypuObj].w < Ix+Iw &&
					(( typObj==TYPOBJ_STRELA &&
							paprsekY < Iy+Ih && Iy<pol.y ) ||
					 ( typObj==TYPOBJ_NESTRELA &&
							paprsekY > Iy-Ih && Iy>pol.y ))
					&& !Ijepaprsek ) pol.y= Iy;
		}	}

		break;
	case TYPSTRELY_PAPRSEKxNAVADENA:
		// tady zjistim, kam az bude paprsek strilet (jestli se o nekoho zastavi)
		paprsekCitac=1;
		paprsekX= pol.x;
		paprsekY= pol.y;
		for(i=0; i<POCETOBJ-1; i++) if ( pgame->objekty[i] ) {
			if ( SOU_PROTI_SOBE(typObj, pgame->objekty[i]->typObj) ) {
				CBaseObject *objI;
				double Ix, Iy, /*Iw, Ih,*/ Ijepaprsek, Izivotu;
				objI= pgame->objekty[i];
				Ix= objI->pol.x;
				Iy= objI->pol.y;
				switch ( objI->typObj ) {
				case TYPOBJ_LOD:
					Ijepaprsek= 0;
					Izivotu= ((CLod*)objI)->shield+((CLod*)objI)->armour;
					break;
				case TYPOBJ_NELOD:
					Ijepaprsek= 0;
					Izivotu= ((CNelod*)objI)->armour;
				break;
				case TYPOBJ_STRELA: case TYPOBJ_NESTRELA:
					Ijepaprsek= NEDA_SE_ZASAHNOUT(objI->typTypuObj);
					Izivotu= ((CStrela*)objI)->armour;
					break;
				case TYPOBJ_FORMACE: case TYPOBJ_LEVEL: case TYPOBJ_NABIDKA:
				case TYPOBJ_TKRH: case TYPOBJ_JINA: break;
				}

				if ( Izivotu<minZivotu && !Ijepaprsek ) {
					pol.x= Ix; pol.y= Iy; minZivotu= Izivotu;
				}
		}	}

		break;
	case TYPSTRELY_VLNAxNORM:
		paprsekCitac= ptkrh->typyZbrane[ typTypuObj ].iKDR;
		paprsekX= ptkrh->typyKrObj[ ptkrh->typyZbrane[ typTypuObj ].cisloTypuKrObj ].w;
		paprsekY= ptkrh->typyKrObj[ ptkrh->typyZbrane[ typTypuObj ].cisloTypuKrObj ].h;
		vlnaW= ptkrh->typyZbrane[ typTypuObj ].w;
		vlnaH= ptkrh->typyZbrane[ typTypuObj ].h;
		break;
	//case TYPSTRELY_CASOVANAxNORM:
	}


}

void CStrela::zasahJsemTe(double kolik)
{// rekne mu, aby si ubral zivoty, popripade se znici
	if ( NEDA_SE_ZASAHNOUT( typTypuObj ) ) return;

	armour-= kolik;
	if ( armour <=0 ) {
		znicit=1;
		ptkrh->hraci[0].penize+= 0;//ptkrh->typyZbrane[typTypuObj].???;
			// kdyz sestrelim strelu, tak za to nic nedostanu
	}
}

double CStrela::zasahnulJsi()
{// vrati, kolik ubira zivotu
	if ( ptkrh->typyZbrane[typTypuObj].typStrely==TYPSTRELY_VLNAxNORM )
		return ptkrh->typyZbrane[typTypuObj].nicivaSila * (double)paprsekCitac/ptkrh->typyZbrane[typTypuObj].iKDR;
	else return ptkrh->typyZbrane[typTypuObj].nicivaSila;
}

void CStrela::UpdateObjLogic(Uint8 *keys)
{
	if (ptkrh->pauza) return;

	// zmena polohy:
	switch ( ptkrh->typyZbrane[typTypuObj].typStrely ) {
	case TYPSTRELY_KYNETICKAxNORM:
	case TYPSTRELY_KYNETICKAxNAVADENA:
		rychlost.x+= ptkrh->typyZbrane[typTypuObj].zrych.x*levaBocni;
		if ( typObj==TYPOBJ_STRELA ) rychlost.y+= ptkrh->typyZbrane[typTypuObj].zrych.y;
		else rychlost.y-= ptkrh->typyZbrane[typTypuObj].zrych.y;
		pol.x+=rychlost.x;
		pol.y+=rychlost.y;
		break;
	case TYPSTRELY_CASOVANAxNORM: break;
	case TYPSTRELY_VLNAxNORM:
		if ( !paprsekCitac ) { znicit= 1; return; }
		paprsekCitac--;
		rychlost.x+= ptkrh->typyZbrane[typTypuObj].zrych.x*levaBocni;
		if ( typObj==TYPOBJ_STRELA ) rychlost.y+= ptkrh->typyZbrane[typTypuObj].zrych.y;
		else rychlost.y-= ptkrh->typyZbrane[typTypuObj].zrych.y;
		pol.x+=rychlost.x;
		pol.y+=rychlost.y;
		paprsekY+=fabs(rychlost.y);
		paprsekX=paprsekY;
		vlnaW= paprsekX*ptkrh->typyZbrane[ typTypuObj ].w/ptkrh->typyKrObj[ ptkrh->typyZbrane[ typTypuObj ].cisloTypuKrObj ].w;
		vlnaH= paprsekY*ptkrh->typyZbrane[ typTypuObj ].h/ptkrh->typyKrObj[ ptkrh->typyZbrane[ typTypuObj ].cisloTypuKrObj ].h;
		break;
	case TYPSTRELY_PAPRSEKxNORM:
	case TYPSTRELY_PAPRSEKxNAVADENA:
		if ( !paprsekCitac ) { znicit= 1; return; }
		paprsekCitac--;
		break;
	}

	// jestli sem uz nevylit z obrazovky:
	int cTKrObj= ptkrh->typyZbrane[typTypuObj].cisloTypuKrObj;	// index do typyKrObj
	if (   pol.x+ptkrh->typyKrObj[cTKrObj].w < -SCREEN_X	// vylit vlevo
		|| pol.x-ptkrh->typyKrObj[cTKrObj].w > SCREEN_X		// vylit vpravo
		|| pol.y+ptkrh->typyKrObj[cTKrObj].h < -SCREEN_Y	// vylit dole
		|| pol.y-ptkrh->typyKrObj[cTKrObj].h > SCREEN_Y		// vylit nahore
		) { znicit= 1; return; }

	// srazky se kontrolujou v CLevel!!!

	// update kresleni:
	if ( !NEDA_SE_ZASAHNOUT(typTypuObj) )
		krObj.UpdateLogic();

}

void CStrela::UpdateObjDisplay()
{
	// vykreslim se:
	switch ( ptkrh->typyZbrane[typTypuObj].typStrely ) {
	case TYPSTRELY_KYNETICKAxNORM:
	case TYPSTRELY_KYNETICKAxNAVADENA:
		krObj.UpdateDisplay(pol);
		break;
	case TYPSTRELY_PAPRSEKxNORM:
	case TYPSTRELY_PAPRSEKxNAVADENA:
		glBlendFunc(GL_ONE, GL_ONE);
		glBindTexture(GL_TEXTURE_2D, ptkrh->typyKrObj[ptkrh->typyZbrane[typTypuObj].cisloTypuKrObj].textury[0].tura);
		double w; w= ptkrh->typyKrObj[ptkrh->typyZbrane[typTypuObj].cisloTypuKrObj].w;
		glBegin(GL_QUADS);												// Start Drawing A Textured Quad
			glTexCoord2f(0.f, 0.f); glVertex3f(paprsekX-w, paprsekY, pol.z);	// Bottom Left
			glTexCoord2f(1.f, 0.f); glVertex3f(paprsekX+w, paprsekY, pol.z);	// Bottom Right
			glTexCoord2f(1.f, 1.f); glVertex3f(pol.x+w, pol.y, pol.z);	// Top Right
			glTexCoord2f(0.f, 1.f); glVertex3f(pol.x-w, pol.y, pol.z);	// Top Left
		glEnd();														// Done Drawing The Quad
		break;
	case TYPSTRELY_VLNAxNORM:
		double pruhlednost; pruhlednost= (double)paprsekCitac/ptkrh->typyZbrane[typTypuObj].iKDR;
		glColor3f( pruhlednost, pruhlednost, pruhlednost);
		glBlendFunc(GL_ONE, GL_ONE);
		glBindTexture(GL_TEXTURE_2D, ptkrh->typyKrObj[ptkrh->typyZbrane[typTypuObj].cisloTypuKrObj].textury[0].tura);
		if ( typObj==TYPOBJ_STRELA ) {
			glBegin(GL_QUADS);												// Start Drawing A Textured Quad
				glTexCoord2f(0.f, 0.f); glVertex3f(pol.x-paprsekX, pol.y-paprsekY, pol.z);	// Bottom Left
				glTexCoord2f(1.f, 0.f); glVertex3f(pol.x+paprsekX, pol.y-paprsekY, pol.z);	// Bottom Right
				glTexCoord2f(1.f, 1.f); glVertex3f(pol.x+paprsekX, pol.y+paprsekY, pol.z);	// Top Right
				glTexCoord2f(0.f, 1.f); glVertex3f(pol.x-paprsekX, pol.y+paprsekY, pol.z);	// Top Left
			glEnd();														// Done Drawing The Quad
		} else {	// TYPOBJ_NESTRELA:
			glBegin(GL_QUADS);												// Start Drawing A Textured Quad
				glTexCoord2f(1.f, 1.f); glVertex3f(pol.x-paprsekX, pol.y-paprsekY, pol.z);	// Bottom Left
				glTexCoord2f(0.f, 1.f); glVertex3f(pol.x+paprsekX, pol.y-paprsekY, pol.z);	// Bottom Right
				glTexCoord2f(0.f, 0.f); glVertex3f(pol.x+paprsekX, pol.y+paprsekY, pol.z);	// Top Right
				glTexCoord2f(1.f, 0.f); glVertex3f(pol.x-paprsekX, pol.y+paprsekY, pol.z);	// Top Left
			glEnd();														// Done Drawing The Quad
		}
		glEnd();														// Done Drawing The Quad
		glColor3f(1.f,1.f,1.f);	
		break;
	case TYPSTRELY_CASOVANAxNORM: break;
	}

	if ( DEBUG_CTVERCE_KOLEM_LODI ) {
	//udela se ctverec podle rozmeru lodi
		double Ix= pol.x,
			Iy= pol.y,
			Iw= ptkrh->typyZbrane[typTypuObj].w,
			Ih= ptkrh->typyZbrane[typTypuObj].h;
		if ( ptkrh->typyZbrane[typTypuObj].typStrely==TYPSTRELY_VLNAxNORM ) {
			Iw= vlnaW;
			Ih= vlnaH;
		} else if ( ptkrh->typyZbrane[typTypuObj].typStrely==TYPSTRELY_PAPRSEKxNORM ||
			ptkrh->typyZbrane[typTypuObj].typStrely==TYPSTRELY_PAPRSEKxNAVADENA)
			Ih+=0.01;

		glDisable(GL_TEXTURE_2D);
		//glPolygonMode( GL_BACK, GL_FILL );			// Back Face Is Filled In
		glPolygonMode( GL_FRONT, GL_LINE );
		glBegin(GL_QUADS);												// Start Drawing A Textured Quad
			glVertex3f( Ix-Iw, Iy-Ih, pol.z);	// Bottom Left
			glVertex3f( Ix+Iw, Iy-Ih, pol.z);	// Bottom Right
			glVertex3f( Ix+Iw, Iy+Ih, pol.z);	// Top Right
			glVertex3f( Ix-Iw, Iy+Ih, pol.z);	// Top Left
		glEnd();														// Done Drawing The Quad
		glPolygonMode( GL_FRONT, GL_FILL );
		glEnable(GL_TEXTURE_2D);
	}

}
