// TridaKteraRidiHru.cpp: implementation of the CTridaKteraRidiHru class.
//
//////////////////////////////////////////////////////////////////////

#include <string.h>
#include <math.h>
#include "TridaKteraRidiHru.h"
#include "HlavniNabidka.h"
#include "Game.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CTridaKteraRidiHru::CTridaKteraRidiHru()
{
	ptkrh= this;
	znicit= 0;
	typObj= TYPOBJ_TKRH;
	semVNabidce= 1;
	ztmavuj= rozsvecuj= 0;
	zacitHrat= 0;
	pauza=0;

////////////////////////

	initTypuVsehoMoznyho();
	// (
	// typy kreslenejch objektu
	// typy zbrani
	// typy nelodi
	// typy lodi
	// )

////////////////////////

// hraci:
	pocHracu=1;
	//hraci[0].init();

}

CTridaKteraRidiHru::~CTridaKteraRidiHru()
{
	delete[] typyKrObj;//free(typyKrObj);
	delete[] typyZbrane;//free(typyZbrane);
	delete[] typyNelodi;//free(typyNelodi);
	//(typyLodi tu nejsou)
}

int CTridaKteraRidiHru::InitObject()
{
	efekty= 1;

	// neco podobnyho je v COptionNabidka a v CGame a v CSound!
	FILE *File=NULL;
	char s[1000]; int c;
	File=fopen("configure.txt","r");
	if (File) {
		while (fscanf(File,"%s",s)!=EOF) {
			if (strcmp(s,"effects")==0) fscanf(File," %d",&efekty);
			else if (s[0]=='/' && s[1]=='/') while (getc(File)!='\n');
			else while ( (c=getc(File))!='\n' && c!=0 );
		}
		fclose(File);
		efekty= !!efekty;
	}
	
	//textury !!! to bude nak jinak !!!
	glGenTextures(TEX_POC, textury);
	// textury menu
	pogl->LoadGLTextures(textury[TEX_VYBUCH],"Data/vybuch.jpg");
	pogl->LoadGLTextures(textury[TEX_MR1],"Data/mr1.jpg");
	pogl->LoadGLTextures(textury[TEX_MR2],"Data/mr2.jpg");
	pogl->LoadGLTextures(textury[TEX_MR3],"Data/mr3.jpg");
	pogl->LoadGLTextures(textury[TEX_MR4],"Data/mr4.jpg");
	pogl->LoadGLTextures(textury[TEX_MR5],"Data/mr5.jpg");
	pogl->LoadGLTextures(textury[TEX_MR6],"Data/mr6.jpg");
	pogl->LoadGLTextures(textury[TEX_MR7],"Data/mr7.jpg");
	pogl->LoadGLTextures(textury[TEX_MR8],"Data/mr8.jpg");
	pogl->LoadGLTextures(textury[TEX_MR8],"Data/mr8.jpg");

	CHlavniNabidka *phln;
	phln = new CHlavniNabidka;
	if ( !phln ) fprintf(stderr,"nepodarilo se naalokovat pamet pro CHlavniNabidka\n");
	else if ( !pgame->RegisterObject(phln) ) fprintf(stderr, "chyba inicializace CHlavniNabidka\n");

	pgame->konzole.fce= CLevel::KonzoleFce;

	sound.Init();
	sound.SemVMenu();

	Rozni();

	return 1;
}

void CTridaKteraRidiHru::ZacniHru()
{
	// znicim objekty z nabidky (krome sebe)
	for (int i=0; i<POCETOBJ; i++) if ( pgame->objekty[i] && pgame->objekty[i]!=this/*->typObj!=TYPOBJ_POZADI*/ )
		pgame->DestroyObject(pgame->objekty[i]);
	semVNabidce=0;
	Rozni();

	// hracova lod
	hraci[0].zacniHrat();

	// CLevel
	level = new CLevel;
	if ( !level ) fprintf(stderr,"nepodarilo se naalokovat pamet pro CLevel\n");
	else if ( !pgame->RegisterObject(level) ) fprintf(stderr, "chyba inicializace CLevel\n");
	level->zacniHru(hraci[0].mapa.lvlVybCesty());	// tady se musi zacit hra s urovni podle vybrany cesty
}

void CTridaKteraRidiHru::ZkonciHru()
{
	int staryLevel, novyLevel;
	staryLevel= hraci[0].maxLevel;
	// predtim, nez znicim objekty ze hry, musi si hrac odregistrovat svoji lod (abych mu ji neznicil)
	if ( level->konecHry == 1 ) hraci[0].vyhral();
	else hraci[0].prohral();
	novyLevel= hraci[0].maxLevel;

	// znicim objekty ze hry (krome sebe)
	for (int i=0; i<POCETOBJ; i++) if ( pgame->objekty[i] && pgame->objekty[i]!=this/*->typObj!=TYPOBJ_POZADI*/ )
		pgame->DestroyObject(pgame->objekty[i]);

	// nainicalizuje nabidku
	CVyhralProhralNabidka *pvpn;
	pvpn = new CVyhralProhralNabidka;
	pvpn->staryLevel= staryLevel; pvpn->novyLevel= novyLevel;
	if ( !pvpn ) fprintf(stderr,"nepodarilo se naalokovat pamet pro CVyhralProhralNabidka\n");
	else if ( !pgame->RegisterObject(pvpn) ) fprintf(stderr, "chyba inicializace CVyhralProhralNabidka\n");
	semVNabidce=1;
	Rozni();
}


void CTridaKteraRidiHru::Ztmav()
{
	ztmavuj=ZTMAVUJKOLIK;
}

void CTridaKteraRidiHru::Rozni()
{
	rozsvecuj=ROZSVECUJKOLIK;
}

void CTridaKteraRidiHru::UpdateObjLogic(Uint8 *keys)
{
	if ( ztmavuj ) ztmavuj--;
	if ( rozsvecuj ) rozsvecuj--;
	if ( semVNabidce ) {
		// sem v nabidce
		if ( zacitHrat ) {
			zacitHrat=0;
			ZacniHru();		//zaregistruju objekty ze hry
		}
	} else { // sem ve hre
		if (level->konecHry) {
			ZkonciHru();	//zaregistruju objekty z nabidky
			return;
		}

		// vyskoceni do nabidky
		//if (keys[SDLK_ESCAPE]) {
		//	keys[SDLK_ESCAPE]=0;
		//	ZkonciHru();	//zaregistruju objekty z nabidky
		//	return;
		//}
	} // sem ve hre
}

void CTridaKteraRidiHru::UpdateObjDisplay()
{
	if ( semVNabidce ) {
	} else { // sem ve hre
	}

	// ztmaveni obrazovky
	if ( ztmavuj ) {
		glDisable(GL_TEXTURE_2D);
		glDisable(GL_DEPTH_TEST);
		glColor3f( (float)(ztmavuj )/ZTMAVUJKOLIK, (float)(ztmavuj )/ZTMAVUJKOLIK, (float)(ztmavuj )/ZTMAVUJKOLIK);
		glBlendFunc(GL_DST_COLOR,GL_ZERO);				//*** Blend Screen Color With Zero (Black)

		glBegin(GL_QUADS);												// Start Drawing A Textured Quad
			glVertex3f(-SCREEN_X, -SCREEN_Y, -20);	// Bottom Left
			glVertex3f( SCREEN_X, -SCREEN_Y, -20);	// Bottom Right
			glVertex3f( SCREEN_X,  SCREEN_Y, -20);	// Top Right
			glVertex3f(-SCREEN_X,  SCREEN_Y, -20);	// Top Left
		glEnd();														// Done Drawing The Quad

		glEnable(GL_DEPTH_TEST);						// Disable Depth Testing
		glColor3f(1.0f,1.0f,1.0f);
		glEnable(GL_TEXTURE_2D);		// Enable Texture Mapping ( NEW )
	}
	// rozsviceni obrazovky
	if ( rozsvecuj ) {
		glDisable(GL_TEXTURE_2D);
		glDisable(GL_DEPTH_TEST);
		glColor3f( (float)(ROZSVECUJKOLIK-rozsvecuj)/ROZSVECUJKOLIK, (float)(ROZSVECUJKOLIK-rozsvecuj )/ROZSVECUJKOLIK, (float)(ROZSVECUJKOLIK-rozsvecuj )/ROZSVECUJKOLIK);
		glBlendFunc(GL_DST_COLOR,GL_ZERO);				//*** Blend Screen Color With Zero (Black)

		glBegin(GL_QUADS);												// Start Drawing A Textured Quad
			glVertex3f(-SCREEN_X, -SCREEN_Y, -20);	// Bottom Left
			glVertex3f( SCREEN_X, -SCREEN_Y, -20);	// Bottom Right
			glVertex3f( SCREEN_X,  SCREEN_Y, -20);	// Top Right
			glVertex3f(-SCREEN_X,  SCREEN_Y, -20);	// Top Left
		glEnd();														// Done Drawing The Quad

		glEnable(GL_DEPTH_TEST);						// Disable Depth Testing
		glColor3f(1.0f,1.0f,1.0f);
		glEnable(GL_TEXTURE_2D);		// Enable Texture Mapping ( NEW )
	}
}

void CTridaKteraRidiHru::initTypuVsehoMoznyho()
{
	int i;

// typy kreslenejch objektu:
	pocTypuKrObj= 15;
	typyKrObj= new CTypKrObj[pocTypuKrObj];
	for (i=0; i<pocTypuKrObj; i++) switch (i) {
		case 0:// 0. - hracova lod1:
		typyKrObj[i].initProNeAnim(1.5, 1.5, TYPTURA_NORMALNI, "Data/lod1.jpg", "Data/lod1cb.jpg"); break;
		case 1:// 0. - hracova lod2:
		typyKrObj[i].initProNeAnim(1.5, 1.5, TYPTURA_NORMALNI, "Data/lod2.jpg", "Data/lod2cb.jpg"); break;
		case 2:// 0. - hracova lod3:
		typyKrObj[i].initProNeAnim(1.5, 1.5, TYPTURA_NORMALNI, "Data/lod3.jpg", "Data/lod3cb.jpg"); break;
		case 3:// 1. - stit1
		typyKrObj[i].initProNeAnim(1.5*1.6, 1.5*1.6, TYPTURA_PRUHLEDNA, "Data/stit1.jpg", NULL); break;
		case 4:// 2. - nelod1
		typyKrObj[i].initProNeAnim(1.5, 1.5, TYPTURA_NORMALNI, "Data/nelod1.jpg", "Data/nelod1cb.jpg"); break;
		case 5:// 3. - nelod2
		typyKrObj[i].initProNeAnim(1.5, 1.5, TYPTURA_NORMALNI, "Data/nelod2.jpg", "Data/nelod1cb.jpg"); break;
		case 6:// 4. - strela1 (hracova hlavni zbran 1 a 2)
		typyKrObj[i].initProNeAnim(0.8, 0.8, TYPTURA_NORMALNI, "Data/strela1.jpg", "Data/strela1.jpg"); break;
		case 7:// 5. - strela2 (hracova bocni zbran)
		typyKrObj[i].initProNeAnim(0.2, 0.2, TYPTURA_NORMALNI, "Data/strela2.jpg", "Data/strela2cb.jpg"); break;
		case 8:// 6. - strela3
		typyKrObj[i].initProNeAnim(0.4, 0.4, TYPTURA_NORMALNI, "Data/strela3.jpg", "Data/strela3.jpg"); break;
		case 9:// 7. - nelod3
		typyKrObj[i].initProNeAnim(1.5, 1.5, TYPTURA_NORMALNI, "Data/nelod3.jpg", "Data/nelod1cb.jpg"); break;
		case 10:// 8. - nelod4
		typyKrObj[i].initProNeAnim(1.5, 1.5, TYPTURA_NORMALNI, "Data/nelod4.jpg", "Data/nelod1cb.jpg"); break;
		case 11:// 9. - strela4 (hracova hlavni zbran 3 a 4)
		typyKrObj[i].initProNeAnim(0.4, 0.6, TYPTURA_NORMALNI, "Data/strela4.jpg", "Data/strela4cb.jpg"); break;
		case 12:// 10. - strela5 (hracova hlavni zbran - paprsek)
		typyKrObj[i].initProNeAnim(0.6, 0.0, TYPTURA_PRUHLEDNA, "Data/strela5.jpg", "Data/strela5.jpg"); break;
		case 13:// 11. - strela6 (hracova hlavni zbran - navadenej paprsek)
		typyKrObj[i].initProNeAnim(0.6, 0.0, TYPTURA_PRUHLEDNA, "Data/strela6.jpg", "Data/strela6.jpg"); break;
		case 14:// 12. - strela7 (hracova hlavni zbran - vlna)
		typyKrObj[i].initProNeAnim(1.5, 1.5, TYPTURA_PRUHLEDNA, "Data/strela7.jpg", "Data/strela7.jpg"); break;
	}/////////////////////////////////////////////////////////////////////
	/*void initProNeAnim(double _w, double _h, TYPTURA _typTextury, char *_tura, char *_turaCB);*/

// typy zbrani:
	pocTypuZbrane= 13;
	typyZbrane= new CTypZbrane[pocTypuZbrane];
	for (i=0; i<pocTypuZbrane; i++) switch (i) {
		case 0:// 0. - hracova hlavni zbran
			typyZbrane[i].init(3, TSour(0,.25,0), TSour(0,0,0), 2, 0.4, 0.4, 10, 6, TYPSTRELY_KYNETICKAxNORM, 25); break;
		case 1:// 1. - hracova bocni zbran
			typyZbrane[i].init(5, TSour(.04,-.04,0), TSour(0,.008,0), 2, 0.2, 0.2, 10, 7, TYPSTRELY_KYNETICKAxNORM, 50); break;
		case 2:// 2. - nepratelska zbran (stejna jako 0., ale pomalejsi a dyl trva, nez se nabije)
			typyZbrane[i].init(1, TSour(0,.1,0), TSour(0,0,0), 1, 0.4, 0.4, 10, 8, TYPSTRELY_KYNETICKAxNORM, 50); break;
		case 3:// 3. - hracova hlavni zbran 2 - uz ne
			typyZbrane[i].init(3, TSour(0,.25,0), TSour(0,0,0), 10, 0.4, 0.4, 50, 6, TYPSTRELY_KYNETICKAxNORM, 20); break;
		case 4:// 4. - hracova bocni zbran 2
			typyZbrane[i].init(5, TSour(.02,-.04,0), TSour(0,.008,0), 8, 0.2, 0.2, 100, 7, TYPSTRELY_KYNETICKAxNORM, 50); break;
		case 5:// 5. - nepratelska zbran na 2.lvl
			typyZbrane[i].init(2, TSour(0,.16,0), TSour(0,0,0), 10, 0.4, 0.4, 10, 8, TYPSTRELY_KYNETICKAxNORM, 50); break;
		case 6:// 6. - nepratelska zbran na 3.lvl
			typyZbrane[i].init(2, TSour(0,.12,0), TSour(0,0,0), 10, 0.4, 0.4, 10, 8, TYPSTRELY_KYNETICKAxNAVADENA, 50); break;
		case 7:// 7. - hracova bocni zbran 3
			typyZbrane[i].init(5, TSour(.06,-.04,0), TSour(0,.008,0), 8, 0.2, 0.2, 200, 7, TYPSTRELY_KYNETICKAxNORM, 50); break;
		case 8:// 8. - hracova hlavni zbran 2
			typyZbrane[i].init(3, TSour(0,.35,0), TSour(0,0,0), 10, 0.3, 0.6, 100, 11, TYPSTRELY_KYNETICKAxNORM, 17); break;
		case 9:// 9. - hracova hlavni zbran 3
			typyZbrane[i].init(3, TSour(0,.40,0), TSour(0,0,0), 10, 0.3, 0.6, 200, 11, TYPSTRELY_KYNETICKAxNORM, 12); break;
		case 10:// 10. - hracova hlavni zbran 4 - paprsek
			typyZbrane[i].init(0, TSour(0,0,0), TSour(0,0,0), 0.30, 0.3, 0.0, 300, 12, TYPSTRELY_PAPRSEKxNORM, 1); break;
		case 11:// 11. - hracova hlavni zbran - navadenej paprsek
			typyZbrane[i].init(0, TSour(0,0,0), TSour(0,0,0), 0.1, 0.3, 0.0, 700, 13, TYPSTRELY_PAPRSEKxNAVADENA, 1); break;
		case 12:// 12. - hracova hlavni zbran - vlna
			typyZbrane[i].init(2, TSour(0,.15,0), TSour(0,0,0), 2, 1.5, 0.5, 500, 14, TYPSTRELY_VLNAxNORM, 50); break;
	}/////////////////////////////////////////////////////////////////////
	/*void init(double _maxArmour, TSour _pocRych, TSour _zrych, double _nicivaSila,
		double _w, double _h, int _cena, int _cTypuKrObj, TYPSTRELY _typStrely, int _iKDR);*/

// typy nelodi:
	pocTypuNelodi= 24;
	typyNelodi= new CTypNelod[pocTypuNelodi];
		i=0;
		/**/poleLeveluNelodi[0]=i;	// nelode na 1. urovni
			typyNelodi[i++].init(20, 0.24, .003, 0.5, 1.0, 1.0, 1, 4, 2, TSour(0,1,0), 1, TSour(0,-0.05,0), 0, 1, 50, 3, 0, 0);
			typyNelodi[i++].init(20, 0.10, .004, 1, 1.0, 1.0, 2, 5, 2, TSour(0,1,0), 1, TSour(0,-0.05,0), -1, 1, 50, 3, 1, 0);
			typyNelodi[i++].init(20, 0.10, .004, 1, 1.0, 1.0, 2, 5, 2, TSour(0,1,0), 1, TSour(0,-0.05,0), +1, 1, 50, 3, 2, 0);
		/**/poleLeveluNelodi[1]=i; 	// nelode na 2. urovni
			typyNelodi[i++].init(20, 0.24, 0, 1.5, 1.0, 1.0, 3, 9, 5, TSour(0,1,0), 2, TSour(0,-0.1,0), 0, 1, 80, 3, 0, 0);
			typyNelodi[i++].init(25, 0.24, 0, 3, 1.0, 1.0, 5, 10, 5, TSour(0,1,0), 2, TSour(0,-0.1,0), 0, 1, 70, 3, 0, 1);
		/**/poleLeveluNelodi[2]=i; 	// nelode na 3. urovni
			typyNelodi[i++].init(20, 0.24, 0, 1.5, 1.0, 1.0, 6, 9, 6, TSour(0,1,0), 3, TSour(0,-0.1,0), 0, 1, 80, 3, 0, 0);
			typyNelodi[i++].init(25, 0.24, 0, 3, 1.0, 1.0, 10, 10, 6, TSour(0,1,0), 3, TSour(0,-0.1,0), 0, 1, 70, 3, 0, 1);
		/**/poleLeveluNelodi[3]=i; 	// nelode na 4. urovni
			typyNelodi[i++].init(20, 0.24, 0, 2, 1.0, 1.0, 8, 4, 10, TSour(0,1,0), 4, TSour(0,-0.1,0), 0, 1, 80, 3, 0, 3);
			typyNelodi[i++].init(30, 0.10, .004, 4, 1.0, 1.0, 15, 5, 8, TSour(0,1,0), 4, TSour(0,-0.1,0), -.5, .5, 70, 3, 1, 1);
			typyNelodi[i++].init(30, 0.10, .004, 4, 1.0, 1.0, 15, 5, 8, TSour(0,1,0), 4, TSour(0,-0.1,0), +.5, .5, 70, 3, 2, 1);
		/**/poleLeveluNelodi[4]=i; 	// nelode na 5. urovni
			typyNelodi[i++].init(25, 0.24, 0, 2, 1.0, 1.0, 12, 9, 12, TSour(0,1,0), 5, TSour(0,-0.1,0), 0, 1, 80, 3, 0, 0);
			typyNelodi[i++].init(35, 0.10, .004, 4, 1.0, 1.0, 15, 10, 10, TSour(0,1,0), 5, TSour(0,-0.15,0), -.5, .5, 70, 3, 1, 0);
			typyNelodi[i++].init(35, 0.10, .004, 4, 1.0, 1.0, 15, 10, 10, TSour(0,1,0), 5, TSour(0,-0.15,0), +.5, .5, 70, 3, 2, 0);
		/**/poleLeveluNelodi[5]=i; 	// nelode na 6. urovni
			typyNelodi[i++].init(25, 0.24, 0, 2.5, 1.0, 1.0, 20, 9, 12, TSour(0,1,0), 6, TSour(0,-0.1,0), 0, 1, 80, 3, 0, 1);
			typyNelodi[i++].init(35, 0.10, .004, 5, 1.0, 1.0, 30, 10, 11, TSour(0,1,0), 6, TSour(0,-0.15,0), -.5, .5, 70, 3, 1, 0);
			typyNelodi[i++].init(35, 0.10, .004, 5, 1.0, 1.0, 30, 10, 11, TSour(0,1,0), 6, TSour(0,-0.15,0), +.5, .5, 70, 3, 2, 0);
		/**/poleLeveluNelodi[6]=i; 	// nelode na 7. urovni
			// tady odsud jsou jenom zkopirovany lode ze 6. urovne.
			// takze tedka sou levely 6-10 uplne stejny!
			typyNelodi[i++].init(25, 0.24, 0, 2.5, 1.0, 1.0, 6, 9, 12, TSour(0,1,0), 6, TSour(0,-0.1,0), 0, 1, 80, 3, 0, 1);
			typyNelodi[i++].init(35, 0.10, .004, 5, 1.0, 1.0, 7, 10, 11, TSour(0,1,0), 6, TSour(0,-0.15,0), -.5, .5, 70, 3, 1, 0);
		/**/poleLeveluNelodi[7]=i; 	// nelode na 8. urovni
			typyNelodi[i++].init(25, 0.24, 0, 2.5, 1.0, 1.0, 6, 9, 12, TSour(0,1,0), 6, TSour(0,-0.1,0), 0, 1, 80, 3, 0, 1);
			typyNelodi[i++].init(35, 0.10, .004, 5, 1.0, 1.0, 7, 10, 11, TSour(0,1,0), 6, TSour(0,-0.15,0), -.5, .5, 70, 3, 1, 0);
		/**/poleLeveluNelodi[8]=i; 	// nelode na 9. urovni
			typyNelodi[i++].init(25, 0.24, 0, 2.5, 1.0, 1.0, 6, 9, 12, TSour(0,1,0), 6, TSour(0,-0.1,0), 0, 1, 80, 3, 0, 1);
			typyNelodi[i++].init(35, 0.10, .004, 5, 1.0, 1.0, 7, 10, 11, TSour(0,1,0), 6, TSour(0,-0.15,0), -.5, .5, 70, 3, 1, 0);
		/**/poleLeveluNelodi[9]=i; 	// nelode na 10. urovni
			typyNelodi[i++].init(25, 0.24, 0, 2.5, 1.0, 1.0, 6, 9, 12, TSour(0,1,0), 6, TSour(0,-0.1,0), 0, 1, 80, 3, 0, 1);
			typyNelodi[i++].init(35, 0.10, .004, 5, 1.0, 1.0, 7, 10, 11, TSour(0,1,0), 6, TSour(0,-0.15,0), -.5, .5, 70, 3, 1, 0);
		/**/poleLeveluNelodi[10]=i; // kde konci pole typyNelodi
		if ( i>pocTypuNelodi ) fprintf(stderr,"chyba ve fci CTKRH::initTyppu(): je moc nelodi\n");
	/////////////////////////////////////////////////////////////////////
	/*void CTypNelod::init(double _maxArmour, double _maxRych, double _zrych, double _nicivaSila,
		double _w, double _h, int _body, int _cTypuKrObj, int _typZbr,
		TSour _poziceZbr, int _level, TSour _pocRych, double _vstupniBod, double _nahVstupBod,
		int _kdyDalsi, int _kolikJichPrileti, int _pohybFce, int _strileciFce);*/

// typy lodi:
	pocTypuLodi= 3;
	// 0. - zakladni hracova lod
	typyLodi[0].maxShield= 50;	// stity a armour se daj zlepsit na dvojnasobek, petina puvodnich stoji desetinu ceny lode
	typyLodi[0].maxArmour= 50;
	typyLodi[0].maxRych= 0.24;
	typyLodi[0].zrych= 0.008;
	typyLodi[0].nicivaSila= 1;
	typyLodi[0].w= 1.5;
	typyLodi[0].h= 1.5;
	typyLodi[0].cena= 500;
	typyLodi[0].cisloTypuKrObj= 0;
	typyLodi[0].cisloTypuKrObjStitu= 3;
	for (i=0; i<MAX_POCET_HL_ZBR; i++) switch (i) {
		case 0: typyLodi[0].typyHlavZbr[i]= 0; break;
		case 1: typyLodi[0].typyHlavZbr[i]= 8; break;
		case 2: typyLodi[0].typyHlavZbr[i]= 9; break;
		case 3: typyLodi[0].typyHlavZbr[i]= 10; break;
	}
	for (i=0; i<MAX_POCET_BOC_ZBR; i++) switch (i) {
		case 0: typyLodi[0].typyBocZbr[i]= 1; break;
		case 1: typyLodi[0].typyBocZbr[i]= 4; break;
		case 2: typyLodi[0].typyBocZbr[i]= 7; break;
	}
	typyLodi[0].poziceHlZbr= TSour(0,1.5,0);
	typyLodi[0].poziceBocZbr= TSour(1.5,0,0);

	// 1. - hracova lod
	typyLodi[1].maxShield= 100;
	typyLodi[1].maxArmour= 100;
	typyLodi[1].maxRych= 0.3;
	typyLodi[1].zrych= 0.01;
	typyLodi[1].nicivaSila= 2;
	typyLodi[1].w= 1.5;
	typyLodi[1].h= 1.5;
	typyLodi[1].cena= 2000;
	typyLodi[1].cisloTypuKrObj= 1;
	typyLodi[1].cisloTypuKrObjStitu= 3;
	for (i=0; i<MAX_POCET_HL_ZBR; i++) switch (i) {
		case 0: typyLodi[1].typyHlavZbr[i]= 9; break;
		case 1: typyLodi[1].typyHlavZbr[i]= 10; break;
		case 2: typyLodi[1].typyHlavZbr[i]= 11; break;
		case 3: typyLodi[1].typyHlavZbr[i]= 12; break;
	}
	for (i=0; i<MAX_POCET_BOC_ZBR; i++) switch (i) {
		case 0: typyLodi[1].typyBocZbr[i]= 4; break;
		case 1: typyLodi[1].typyBocZbr[i]= 7; break;
		case 2: typyLodi[1].typyBocZbr[i]= 10; break;
	}
	typyLodi[1].poziceHlZbr= TSour(0,1.5,0);
	typyLodi[1].poziceBocZbr= TSour(1.5,0,0);

	// 2. - hracova lod - zatim stejna jako predchozi (jenom jinej obrazek)
	typyLodi[2].maxShield= 100;
	typyLodi[2].maxArmour= 100;
	typyLodi[2].maxRych= 0.3;
	typyLodi[2].zrych= 0.01;
	typyLodi[2].nicivaSila= 2;
	typyLodi[2].w= 1.5;
	typyLodi[2].h= 1.5;
	typyLodi[2].cena= 3000;
	typyLodi[2].cisloTypuKrObj= 2;
	typyLodi[2].cisloTypuKrObjStitu= 3;
	for (i=0; i<MAX_POCET_HL_ZBR; i++) switch (i) {
		case 0: typyLodi[2].typyHlavZbr[i]= 9; break;
		case 1: typyLodi[2].typyHlavZbr[i]= 10; break;
		case 2: typyLodi[2].typyHlavZbr[i]= 11; break;
		case 3: typyLodi[2].typyHlavZbr[i]= 12; break;
	}
	for (i=0; i<MAX_POCET_BOC_ZBR; i++) switch (i) {
		case 0: typyLodi[2].typyBocZbr[i]= 4; break;
		case 1: typyLodi[2].typyBocZbr[i]= 7; break;
		case 2: typyLodi[2].typyBocZbr[i]= 10; break;
	}
	typyLodi[2].poziceHlZbr= TSour(0,1.5,0);
	typyLodi[2].poziceBocZbr= TSour(1.5,0,0);

}
