// TridaKteraRidiHru.h: interface for the CTridaKteraRidiHru class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TRIDAKTERARIDIHRU_H__C3C31AC0_1CED_11D8_83E3_008048208521__INCLUDED_)
#define AFX_TRIDAKTERARIDIHRU_H__C3C31AC0_1CED_11D8_83E3_008048208521__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//#include <vector>

#include "BaseObject.h"
#include "TypKrObj.h"
#include "TypZbrane.h"
#include "TypNelod.h"
#include "TypLod.h"
#include "Hrac.h"
#include "Level.h"
#include "BaseNabidka.h"
#include "Sound.h"

// textury
typedef enum {
	TEX_VYBUCH,		// textura, ze ktery se delaj vybuchy
	TEX_MR1, TEX_MR2, TEX_MR3, TEX_MR4, TEX_MR5, TEX_MR6, TEX_MR7, TEX_MR8,	// ramecek nabidky
	//______secteno_podtrzeno______//
	TEX_POC								// pocet textur
} TEXTURY;

class CTridaKteraRidiHru : public CBaseObject	// zaregistruje se v CGame pri inicializaci
{
	void initTypuVsehoMoznyho();

	int		semVNabidce;
	int		ztmavuj, rozsvecuj;			// pouziva to fce Ztmav() a Rosvit()
	void ZacniHru();	// vola se pro zniceni objektu nabidky a zaregistrovani objektu hry
	void ZkonciHru();	// vola se pro zniceni objektu hry a zaregistrovani objektu nabidky
	#define	ZTMAVUJKOLIK	100	// kolik kol bude trvat ztmavovani
	#define	ROZSVECUJKOLIK	100	// a rozsvecovani

public:
	CTridaKteraRidiHru();
	virtual ~CTridaKteraRidiHru();

	int InitObject();
	void UpdateObjLogic(Uint8 *keys);
	void UpdateObjDisplay();

	void Ztmav();		// ztmavi obrazovku v prubehu 100 kol
	void Rozni();		// rosviti obrazovku v prubehu 100 kol

	int zacitHrat;		// nastavi se v nabidkach; konec hry se zjisti z level->konecHry
	GLuint	textury[TEX_POC];	// pole s texturama ramecku v nabidce, !!! to bude nak jinak !!!

	// init pole kreslenejch objektu, na zacatku se naalokuje a nacte ze souboru
	int			pocTypuKrObj;
	CTypKrObj	*typyKrObj;
	//std::vector<CTypKrObj> typyKrObj;

	// init pole zbrani
	int			pocTypuZbrane;
	CTypZbrane	*typyZbrane;

	// init pole nelodi
	int			pocTypuNelodi;
	CTypNelod	*typyNelodi;
	int			poleLeveluNelodi[11];	// je deset levelu, v kazdem policku je ulozeny,
					// od kolikatyho mista v poli typyNelodi zacinaj nepratele

	// init pole formaci
	//int			pocTypuFormaci;
	//CTypFormace	*typyFormaci;

	// init pole lodi
	int			pocTypuLodi;	// to je zbytecny
	CTypLod		typyLodi[3];	// budou 3 lode

	// pole hracu (uz ne init)
	int			pocHracu;		// podle toho se pozna, jestli hraje 1, nebo 2 hraci
	CHrac		hraci[2];

	CLevel	*level;				// kdyz se ma zacit hrat, tak ho TKRH zaregistruje, a ten pak vytvari nepratele, kresli pozadi, ...

	int efekty;					// 0 vypnuto, 1 zapnuto; zatim jenom stiny a vybuchy

	CSound sound;				// hudba i zvuky

	int pauza;					// pokud sem ve hre, tak se na to jednotlive tridy (level,lod,nelod,strela,(formace,)vybuch) koukaj, jestli se maj hejbat

};

#endif // !defined(AFX_TRIDAKTERARIDIHRU_H__C3C31AC0_1CED_11D8_83E3_008048208521__INCLUDED_)
