// Vybuch.cpp: implementation of the CVybuch class.
//
//////////////////////////////////////////////////////////////////////

#include "Vybuch.h"
#include "TridaKteraRidiHru.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CVybuch::CVybuch()
{
	znicit=0;
	typObj=TYPOBJ_JINA;
}

CVybuch::~CVybuch() {}

void CVybuch::pridej(double x, double y, int level, double kolik)
{
	if (ptkrh->pauza) return;
	if ( !ptkrh->efekty ) return;

	TJedenVybuch pom;
	pom.x= x;
	pom.y= y;
	pom.z= -30;
	pom.maxKDK= pom.kolDoKonce= 80+(int)(3.f*kolik/(level+1));
	pom.otoceni= (rand()%2)*180;
	pom.velikost= 0.3f;

	spojak.push_back(pom);

	ptkrh->sound.Vybuch();
}

void CVybuch::UpdateObjLogic(Uint8 *keys)
{
	std::vector<TJedenVybuch>::iterator v;
	for (int i=0;  i<(int)spojak.size(); i++) {
		spojak[i].kolDoKonce--;
		spojak[i].velikost+=0.015f;
		if ( !spojak[i].kolDoKonce ) {
			v=spojak.begin();
			v+=i;
			spojak.erase(v);
		}
	}
}

void CVybuch::UpdateObjDisplay()
{
	for (std::vector<TJedenVybuch>::iterator p = spojak.begin(); p != spojak.end(); p++)
	{
		float R=1,G=0;
		if ( p->kolDoKonce*3 > p->maxKDK ) G= (1.f*p->kolDoKonce - p->maxKDK/3)*3/2/p->maxKDK;
		if ( p->kolDoKonce*1.5 < p->maxKDK ) R= (1.5f*p->kolDoKonce)/p->maxKDK;

		glPushMatrix();
			glDisable( GL_DEPTH_TEST );
			glTranslated( p->x, p->y, p->z);
			glRotatef( p->otoceni, 0, 0, 1.f);

			// texturaCB	
			glColor3f( G*.5f, G*.5f, G*.5f);
			//glDisable(GL_DEPTH_TEST);						// Disable Depth Testing
			glBlendFunc(GL_ZERO,GL_ONE_MINUS_SRC_COLOR);	// ted je na texture bila lod na cernym pozadi
			glBindTexture(GL_TEXTURE_2D, ptkrh->textury[TEX_VYBUCH]);
			glBegin(GL_QUADS);												// Start Drawing A Textured Quad
				glTexCoord2f(0.f, 0.f); glVertex3f(-p->velikost,-p->velikost, 0.f);	// Bottom Left
				glTexCoord2f(1.f, 0.f); glVertex3f( p->velikost,-p->velikost, 0.f);	// Bottom Right
				glTexCoord2f(1.f, 1.f); glVertex3f( p->velikost, p->velikost, 0.f);	// Top Right
				glTexCoord2f(0.f, 1.f); glVertex3f(-p->velikost, p->velikost, 0.f);	// Top Left
			glEnd();														// Done Drawing The Quad
			//glEnable(GL_DEPTH_TEST);						// Disable Depth Testing

			glColor3f( R, G, 0);
			glBlendFunc(GL_SRC_COLOR, GL_ONE);
			glBindTexture(GL_TEXTURE_2D, ptkrh->textury[TEX_VYBUCH]);
			glBegin(GL_QUADS);												// Start Drawing A Textured Quad
				glTexCoord2f(0.f, 0.f); glVertex3f(-p->velikost,-p->velikost, 0.f);	// Bottom Left
				glTexCoord2f(1.f, 0.f); glVertex3f( p->velikost,-p->velikost, 0.f);	// Bottom Right
				glTexCoord2f(1.f, 1.f); glVertex3f( p->velikost, p->velikost, 0.f);	// Top Right
				glTexCoord2f(0.f, 1.f); glVertex3f(-p->velikost, p->velikost, 0.f);	// Top Left
			glEnd();														// Done Drawing The Quad
			glBegin(GL_QUADS);												// Start Drawing A Textured Quad
				glTexCoord2f(0.f, 0.f); glVertex3f(-p->velikost,-p->velikost, 0.f);	// Bottom Left
				glTexCoord2f(1.f, 0.f); glVertex3f( p->velikost,-p->velikost, 0.f);	// Bottom Right
				glTexCoord2f(1.f, 1.f); glVertex3f( p->velikost, p->velikost, 0.f);	// Top Right
				glTexCoord2f(0.f, 1.f); glVertex3f(-p->velikost, p->velikost, 0.f);	// Top Left
			glEnd();														// Done Drawing The Quad
			glColor3f(1.f,1.f,1.f);
			glEnable( GL_DEPTH_TEST );
		glPopMatrix();

	}
}
