// Zbran.cpp: implementation of the CZbran class.
//
//////////////////////////////////////////////////////////////////////

#include "Zbran.h"
#include "Strela.h"
#include "Game.h"
#include "TridaKteraRidiHru.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CZbran::CZbran()
{
	KDR= 0;
}

//CZbran::~CZbran() {}

void CZbran::init(int _cTypuZbr, TYPOBJ _typPratel, TYPZBRANE _typHlavBoc, double _x, double _y)
{
	cisloTypuZbrane= _cTypuZbr;
	typBocHlav= _typHlavBoc;
	typPratel= _typPratel;
	x= _x;
	y= _y;

}


void CZbran::strilej(TSour poloha)
{
	CStrela *pstrela;

	// jestli se mi uz nabilo, tak se vystreli
	if ( !KDR ) {
		// hlavni:
		pstrela = new CStrela;
		if ( !pstrela ) fprintf(stderr, "nepodarilo se naalokovat pamet pro CStrela\n");
		else if ( !( pgame->RegisterObject(pstrela)) ) fprintf(stderr, "chyba inicializace CStrela\n");
		else {
			pstrela->Init( cisloTypuZbrane, typPratel, TSour(poloha.x+x, poloha.y+y, poloha.z));
			KDR=ptkrh->typyZbrane[cisloTypuZbrane].iKDR;
		}

		// jestli je bocni, tak pridame este tu levou:
		if ( typBocHlav==TYPZBRANE_BOCNI ) {
			pstrela = new CStrela;
			if ( !pstrela ) fprintf(stderr, "nepodarilo se naalokovat pamet pro CStrela\n");
			else if ( !( pgame->RegisterObject(pstrela)) ) fprintf(stderr, "chyba inicializace CStrela\n");
			else {
				pstrela->Init( cisloTypuZbrane, typPratel, TSour(poloha.x-x, poloha.y+y, poloha.z), -1);
			}
		}
		ptkrh->sound.Strelba();
	}
}

void CZbran::zevluj()
{
	if ( KDR ) KDR--;
}
